﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="BumonelectedMissi.aspx.cs" Inherits="EmpCRM.BumonSelectedMissi" %>
<%-- ヘッダーユーザコントロールを追加 --%>
<%@ Register Tagprefix="cc" Tagname="CommonHeader" Src="control/Header.ascx" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml" lang="ja">
<head runat="server">
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <link rel="stylesheet" href="./css/style.css" type="text/css" />
    <title>部門毎従事者選任/解任一覧</title>
    <script src="./js/jquery-3.1.1.min.js"></script>
    <script type="text/javascript">
        $(function () {
            $("[id*='rdSelectWorker']").click(function () {
                $("[id*='rdSelectWorker']").prop('checked', false);
                $(this).prop('checked', true);
            });

            $("[id*='radioSelectCondition']").click(function () {
                $("[id*='radioSelectCondition']").prop('checked', false);
                $(this).prop('checked', true);
            });
        });
    </script>
</head>
<body>
<%--    <form id="form1" runat="server">--%>
    <div id="wrapper">
        <!-- header -->
        <cc:CommonHeader ID="CommonHeader" runat="server" />

        <div id="main">

            <h2>従事者情報検索&nbsp;部門毎選任/解任一覧</h2>
            
            <div class="tagReturn">
                <span>＞</span>
                <asp:HyperLink ID="hyperlink2" NavigateUrl="Mainmenu.aspx" Text="メインメニュー" Target="_top" runat="server" />
                <span>＞ </span>
                <span>部門毎選任/解任一覧</span>

            </div>

            <div id="content">

                <form id="form1" runat="server">
                    <table border="0" style="width: 600px; table-layout: fixed;">
                        <tr>
                            <td colspan="4" style="border-right-style: hidden; border-left-style: hidden; border-top-style: hidden;">
                                <h3>従事者情報</h3>
                            </td>
                        </tr>
                        <tr>
                            <td>免許番号</td>
                            <td colspan="3">
                                <asp:TextBox ID="licenseno" Style="width: 200px;" runat="server" /></td>
                        </tr>
                        <tr>
                            <td>氏名（姓）</td>
                            <td>
                                <asp:TextBox ID="lastname" runat="server" /></td>
                            <td>氏名（名）</td>
                            <td>
                                <asp:TextBox ID="firstname" runat="server" /></td>
                        </tr>
                        <tr>
                            <td>ふりがな（姓）</td>
                            <td>
                                <asp:TextBox ID="furi_familyname" runat="server" /></td>
                            <td>ふりがな（名）</td>
                            <td>
                                <asp:TextBox ID="furi_firstname" runat="server" /></td>
                        </tr>
                        <tr>
                            <td>所属会社（施工会社）</td>
                            <td>
                                <asp:DropDownList ID="ddlBelongCompany" runat="server" OnSelectedIndexChanged="ddlBelongCompany_Changed" AutoPostBack="true" />
                            </td>

                            <td>所属部署（施工会社）</td>
                            <td>
                                <asp:DropDownList ID="ddlBelongDepartment" runat="server" />
                            </td>
                        </tr>

                        <tr>
                            <td colspan="4" style="border-right-style: hidden; border-left-style: hidden; border-bottom-style: hidden;">
                                <asp:Button ID="SearchBtn" Text="検索" runat="server" OnClick="SearchBtn_Click" class="input_submit SmallBtn" />
                                <asp:Button ID="ClearBtn" Text="クリア" runat="server" OnClick="ClearBtn_Click" class="input_submit SmallBtn" />
                                <asp:Button ID="modoru" Text="戻る" runat="server" OnClick="modoru_Click" class="input_submit SmallBtn" />
                            </td>
                        </tr>
                    </table>

                    <%-- 従事者情報一覧 --%>
                    <asp:Panel ID="PnlWorkerSearchResult" runat="server" CssClass="pnlWorkerSearchResult" Visible="false">
                        <asp:GridView ID="gvWorkerSearchResult" runat="server" CssClass="tblWorkerSearchResult"
                                      Visible="false" AutoGenerateColumns="false" AllowPaging="true" OnPageIndexChanging="gvWorker_PageChanging"
                                      ShowHeaderWhenEmpty="true" >
                            <PagerSettings Position="Bottom" Mode="NumericFirstLast" />
                            <PagerStyle HorizontalAlign="Center" CssClass="pagerRow" />
                            <HeaderStyle CssClass="gvHead" HorizontalAlign="Center" />
                            <Columns>
                                <asp:TemplateField HeaderText="選択" HeaderStyle-CssClass="chkBoxColumn">
                                    <ItemTemplate>
                                        <asp:RadioButton runat="server" ID="rdSelectWorker" GroupName="selectWorker" CssClass="rdoBtn" />
                                    </ItemTemplate>
                                </asp:TemplateField>
                                <asp:BoundField DataField="license_number" HeaderText="免許番号" HeaderStyle-CssClass="licenseNumberColumn" ItemStyle-CssClass="" />
                                <asp:BoundField DataField="licenseName" HeaderText="資格名" HeaderStyle-CssClass="licenseNameColumn" ItemStyle-CssClass="" />
                                <asp:BoundField DataField="LastName" HeaderText="氏名（姓）" HeaderStyle-CssClass="lastnameColumn" ItemStyle-CssClass="" />
                                <asp:BoundField DataField="firstName" HeaderText="氏名（名）" HeaderStyle-CssClass="firstnameColumn" ItemStyle-CssClass="" />
                                <asp:BoundField DataField="LastName_Kana" HeaderText="ふりがな（姓）" HeaderStyle-CssClass="kanalastnameColumn" ItemStyle-CssClass="" />
                                <asp:BoundField DataField="FirstName_Kana" HeaderText="ふりがな（名）" HeaderStyle-CssClass="kanafirstnameColumn" ItemStyle-CssClass="" />

                            </Columns>
                        </asp:GridView>

                        <p>
                            <asp:Button ID="BtnBumonSelectionConditionDisplay" Text="部門毎選任/解任状況" runat="server" OnClick="BumonSelectionCondition_Click" CssClass="input_submit TooLargeBtn" />
                        </p>
                    </asp:Panel>

                    <%-- 選任/解任状況一覧 --%>
                    <asp:Panel ID="PnlBumonSelectionCondition" runat="server" CssClass="" Visible="false">
                        <p>選任/解任状況</p>
                        <asp:GridView ID="gvBumonSelectionList" runat="server" CssClass="" Visible="true" AutoGenerateColumns="false"
                                      AllowPaging="true" OnPageIndexChanging="gvBumonSelectionList_PageChanging" ShowHeaderWhenEmpty="true">
                            <PagerSettings Position="Bottom" Mode="NumericFirstLast" />
                            <PagerStyle HorizontalAlign="Center" CssClass="pagerRow" />
                            <HeaderStyle CssClass="gvHead" HorizontalAlign="Center" />
                            <Columns>
                                <asp:TemplateField HeaderText="選択" HeaderStyle-CssClass="chkBoxColumn">
                                    <ItemTemplate>
                                        <asp:RadioButton runat="server" ID="radioSelectCondition" GroupName="selectCondition" CssClass="rdoBtn" />
                                    </ItemTemplate>
                                </asp:TemplateField>
                                <asp:BoundField DataField="社内管理部門" HeaderText="社内管理部門" HeaderStyle-CssClass="bumonColumn" ItemStyle-CssClass="bumonColumn" />
                                <asp:BoundField DataField="okinawa" HeaderText="沖縄" HeaderStyle-CssClass="areaColumn" ItemStyle-CssClass="areaColumn" />
                                <asp:BoundField DataField="kyuushu" HeaderText="九州" HeaderStyle-CssClass="areaColumn" ItemStyle-CssClass="areaColumn" />
                                <asp:BoundField DataField="chugoku" HeaderText="中国" HeaderStyle-CssClass="areaColumn" ItemStyle-CssClass="areaColumn" />
                                <asp:BoundField DataField="shikoku" HeaderText="四国" HeaderStyle-CssClass="areaColumn" ItemStyle-CssClass="areaColumn" />
                                <asp:BoundField DataField="kinki" HeaderText="近畿" HeaderStyle-CssClass="areaColumn" ItemStyle-CssClass="areaColumn" />
                                <asp:BoundField DataField="tokai" HeaderText="東海" HeaderStyle-CssClass="areaColumn" ItemStyle-CssClass="areaColumn" />
                                <asp:BoundField DataField="kantou" HeaderText="関東" HeaderStyle-CssClass="areaColumn" ItemStyle-CssClass="areaColumn" />
                                <asp:BoundField DataField="shinetsu" HeaderText="信越" HeaderStyle-CssClass="areaColumn" ItemStyle-CssClass="areaColumn" />
                                <asp:BoundField DataField="hokuriku" HeaderText="北陸" HeaderStyle-CssClass="areaColumn" ItemStyle-CssClass="areaColumn" />
                                <asp:BoundField DataField="touhoku" HeaderText="東北" HeaderStyle-CssClass="areaColumn" ItemStyle-CssClass="areaColumn" />
                                <asp:BoundField DataField="hokkaidou" HeaderText="北海道" HeaderStyle-CssClass="areaColumn" ItemStyle-CssClass="areaColumn" />
                                <asp:BoundField DataField="request_div" HeaderText="種別" HeaderStyle-CssClass="statusColumn" ItemStyle-CssClass="statusColumn" />
                                <asp:BoundField DataField="ステータス" HeaderText="ステータス" HeaderStyle-CssClass="statusColumn" ItemStyle-CssClass="statusColumn" />
                            </Columns>

                        </asp:GridView>
                        <p>
                            <asp:Button ID="BtnSelectionDetail" Text="詳細表示" runat="server" OnClick="BtnSelectionDetail_Click" CssClass="input_submit LargeBtn" />
                        </p>
                    </asp:Panel>

                    <%--選任/解任詳細表示--%>
                    <asp:Panel ID="PnlSelectionDetail" runat="server" Visible="false">
                        <asp:Label ID="lblDetailTitle" runat="server" Text="選任/解任詳細表示" />
                        <asp:Panel ID="pnlDetailChild" runat="server" Visible="false">
                        <table border="0" style="table-layout: fixed;">
                            <tbody>
                                <tr>
                                    <th>社内管理部門:</th>
                                    <td colspan="6">
                                        <asp:Label ID="lblDetailBumon" runat="server" />
                                    </td>
                                </tr>
                            </tbody>
                        </table>
                        <table border="0" style="table-layout: fixed;">
                            <tbody>
                                <tr>
                                    <th>氏名</th>
                                    <td class="kanalastnameColumn">
                                        <asp:Label ID="lblDetailLastName" runat="server" />
                                    </td>
                                    <td class="kanafirstnameColumn">
                                        <asp:Label ID="lblDetailFirstName" runat="server" />
                                    </td>
<%--                                    <td width="80">生年月日:</td>
                                    <td width="80">
                                        <asp:Label ID="lblDetailBirthDay" runat="server" />
                                    </td>--%>
                                    <th>免許証番号：</th>
                                    <td>
                                        <asp:Label ID="lblDetailLicenseNumber" runat="server" />
                                    </td>
                                </tr>
                                <tr>
                                    <th>氏名(ふりがな):</th>
                                    <td>
                                        <asp:Label ID="lblDetailLastNameKana" runat="server" />
                                    </td>
                                    <td>
                                        <asp:Label ID="lblDetailFirstNameKana" runat="server" />
                                    </td>
                                    <%--<td>&nbsp;</td>
                                    <td>&nbsp;</td>--%>
                                    <th>免許取得日：</th>
                                    <td>
                                        <asp:Label ID="lblDetailGetLicenseDate" runat="server" />
                                    </td>
                                </tr>
                            </tbody>
                        </table>

                        <p>選任/解任状況</p>
                        <asp:Table border="1" ID="tblSelectionDetailInfo" runat="server" Style="width: 1000px">
                            <asp:TableHeaderRow ID="TableHeaderRow1" runat="server">
                                <asp:TableHeaderCell>&nbsp;</asp:TableHeaderCell>
                                <asp:TableHeaderCell CssClass="">沖縄</asp:TableHeaderCell>
                                <asp:TableHeaderCell>九州</asp:TableHeaderCell>
                                <asp:TableHeaderCell>中国</asp:TableHeaderCell>
                                <asp:TableHeaderCell>四国</asp:TableHeaderCell>
                                <asp:TableHeaderCell>近畿</asp:TableHeaderCell>
                                <asp:TableHeaderCell>東海</asp:TableHeaderCell>
                                <asp:TableHeaderCell>関東</asp:TableHeaderCell>
                                <asp:TableHeaderCell>信越</asp:TableHeaderCell>
                                <asp:TableHeaderCell>北陸</asp:TableHeaderCell>
                                <asp:TableHeaderCell>東北</asp:TableHeaderCell>
                                <asp:TableHeaderCell>北海道</asp:TableHeaderCell>
                            </asp:TableHeaderRow>
                        </asp:Table>

                        <div id="pnlDetailHistory" class="">

                            <asp:GridView ID="gvDetailHistory" runat="server" CssClass="" Visible="true" AutoGenerateColumns="false"
                                          AllowPaging="true" OnPageIndexChanging="gvDetailHistory_PageChanging" ShowHeaderWhenEmpty="true" >
                                <PagerSettings Position="Bottom" Mode="NumericFirstLast" />
                                <PagerStyle HorizontalAlign="Center" CssClass="pagerRow" />
                                <HeaderStyle CssClass="gvHead" HorizontalAlign="Center" />
                                <Columns>
                                    <asp:BoundField DataField="num" HeaderText="履歴" HeaderStyle-CssClass="indexNumberColumn" ItemStyle-CssClass="indexNumberColumn" />
                                    <asp:BoundField DataField="okinawa" HeaderText="沖縄" HeaderStyle-CssClass="areaColumn" ItemStyle-CssClass="areaColumn" />
                                    <asp:BoundField DataField="kyuushu" HeaderText="九州" HeaderStyle-CssClass="areaColumn" ItemStyle-CssClass="areaColumn" />
                                    <asp:BoundField DataField="chugoku" HeaderText="中国" HeaderStyle-CssClass="areaColumn" ItemStyle-CssClass="areaColumn" />
                                    <asp:BoundField DataField="shikoku" HeaderText="四国" HeaderStyle-CssClass="areaColumn" ItemStyle-CssClass="areaColumn" />
                                    <asp:BoundField DataField="kinki" HeaderText="近畿" HeaderStyle-CssClass="areaColumn" ItemStyle-CssClass="areaColumn" />
                                    <asp:BoundField DataField="tokai" HeaderText="東海" HeaderStyle-CssClass="areaColumn" ItemStyle-CssClass="areaColumn" />
                                    <asp:BoundField DataField="kantou" HeaderText="関東" HeaderStyle-CssClass="areaColumn" ItemStyle-CssClass="areaColumn" />
                                    <asp:BoundField DataField="shinetsu" HeaderText="信越" HeaderStyle-CssClass="areaColumn" ItemStyle-CssClass="areaColumn" />
                                    <asp:BoundField DataField="hokuriku" HeaderText="北陸" HeaderStyle-CssClass="areaColumn" ItemStyle-CssClass="areaColumn" />
                                    <asp:BoundField DataField="touhoku" HeaderText="東北" HeaderStyle-CssClass="areaColumn" ItemStyle-CssClass="areaColumn" />
                                    <asp:BoundField DataField="hokkaidou" HeaderText="北海道" HeaderStyle-CssClass="areaColumn" ItemStyle-CssClass="areaColumn" />
                                    <asp:BoundField DataField="disp_request_date" HeaderText="申請日" HeaderStyle-CssClass="dateColumn" ItemStyle-CssClass="dateColumn" />
                                    <asp:BoundField DataField="belong_company" HeaderText="所属会社" HeaderStyle-CssClass="belongCompanyColumn" ItemStyle-CssClass="belongCompanyColumn" />
                                </Columns>
                            </asp:GridView>
                            <p>
                                <asp:Button ID="Button1" Text="選任/解任設定" runat="server" OnClick="EditSelection_click" CssClass="input_submit TooLargeBtn" />
                            </p>

                        </div>
                            </asp:Panel>

                    </asp:Panel>
                    <div>
                        <!-- エラーメッセージ表示用ラベル -->
                        <asp:Table ID="Table3" runat="server" CssClass="errMsgTbl">
                            <asp:TableRow>
                                <asp:TableCell HorizontalAlign="Center">
                                    <asp:Label ID="lblErrMsg" runat="server" ForeColor="Red"></asp:Label>
                                </asp:TableCell>
                            </asp:TableRow>
                        </asp:Table>
                    </div>

                </form>



            </div>
</body>
</html>
