﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using EmpCRM.common;
using EmpCRM.Dto;

namespace EmpCRM
{
    public partial class CompanyInfo : System.Web.UI.Page
    {
        private ComFunc m_ComFunc = null;
        private List<section_Info> section_infoL = new List<section_Info>();
        private string gPage_num = "1";
        private static log4net.ILog logger = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
        private string sUserID = "";

        protected void Page_Load(object sender, EventArgs e)
        {
            //セッションから共通関数クラスのインスタンスを取得
            m_ComFunc = (ComFunc)Session[ComConst.COM_FUNC];

            //初期画面表示
            if (!(IsPostBack))
            {
                GridView1.Visible = false;
                T101.Visible = false;

            }
            else
            {
                if (((string)Session["FromResult"] == "CompanyEditResult"))
                {
                    //会社ID
                    companyID.Text = (string)Session[ComConst.COMPANY_ID];
                    //会社名
                    companyName.Text = (string)Session[ComConst.COMPANY_JNAME];
                    Session["FromResult"] = null;
                    //Grid表示
                    GridView1.Visible = true;
                    T101.Visible = true;
                    string query = "SELECT ROW_NUMBER() OVER (ORDER BY COMPANY_ID) AS 'No', [company_id], [section_id], [section_name] FROM [section_mst] WHERE [DEL_FLAG]=0";
                    SqlDataSource1.SelectParameters.Clear();
                    SqlDataSource1.SelectCommand = query + " AND [company_id]=@company_id";
                    SqlDataSource1.SelectParameters.Add("company_id", companyID.Text);
                    GridView1.DataSourceID = "SqlDataSource1";
                }


            }
            ////部門マスタを設定
            //if (string.IsNullOrEmpty(companyID.Text))
            //{
            //    string query = "SELECT ROW_NUMBER() OVER (ORDER BY COMPANY_ID) AS 'No', [company_id], [section_id], [section_name] FROM [section_mst] WHERE [DEL_FLAG]=0";
            //    SqlDataSource1.SelectParameters.Clear();
            //    SqlDataSource1.SelectCommand = query;
            //    GridView1.DataSourceID = "SqlDataSource1";
            //}
            //else
            //{
            //    string query = "SELECT ROW_NUMBER() OVER (ORDER BY COMPANY_ID) AS 'No', [company_id], [section_id], [section_name] FROM [section_mst] WHERE [DEL_FLAG]=0";
            //    SqlDataSource1.SelectParameters.Clear();
            //    SqlDataSource1.SelectCommand = query + " AND [company_id]=@company_id";
            //    SqlDataSource1.SelectParameters.Add("company_id", companyID.Text);
            //    GridView1.DataSourceID = "SqlDataSource1";
            //}
            lblErrMsg.Text = "";

        }
 
        //登録処理
        protected void add_Click(object sender, EventArgs e)
        {
            string sSql = string.Empty;
            bool ret = false;

            try
            {
                if (string.IsNullOrEmpty(companyID.Text))
                {
                    lblErrMsg.Text = "会社IDが空白ですので、入力して下さい。";

                }
                else
                {

                    //トランザクションの開始
                    m_ComFunc.DB_BeginTranzaction();

                    //insert
                    //従事者情報の登録する。
                    sSql = "INSERT INTO company_mst(";
                    sSql = sSql + "company_id";
                    sSql = sSql + ", company_name";
                    sSql = sSql + ", entry_date";
                    sSql = sSql + ", del_flag";
                    sSql = sSql + ") VALUES (";
                    sSql = sSql + "'" + companyID.Text + "'";
                    sSql = sSql + ", '" + companyName.Text + "'";
                    sSql = sSql + ", getdate()";
                    sSql = sSql + ", '" + 0 + "'";
                    sSql = sSql + ")";

                    string msg = "";
                    ret = m_ComFunc.DB_Execute(sSql);
                    if (ret)
                    {
                        m_ComFunc.DB_Commit();
                        compnent_int();
                        lblErrMsg.Text = "登録が成功しました。";
                    }
                    else
                    {
                        m_ComFunc.DB_Rollback();
                        lblErrMsg.Text = "登録が失敗しました。";
                    }
                }
            }
            catch (Exception ex)
            {
                lblErrMsg.Text = ex.Message;
            }

                                

        }
        protected void edit_Click(object sender, EventArgs e)
        {
            string sSql = string.Empty;
            bool ret = false;

            try
            {
                if (string.IsNullOrEmpty(companyID.Text))
                {
                    lblErrMsg.Text = "会社IDが空白ですので、入力して下さい。";

                }
                else
                {

                    //トランザクションの開始
                    m_ComFunc.DB_BeginTranzaction();

                    //insert
                    //従事者情報の登録する。
                    sSql = "UPDATE  company_mst ";
                    sSql = sSql + "SET company_name = '" + companyName.Text + "'";
                    sSql = sSql + " WHERE company_id = '" + companyID.Text + "'";
                    sSql = sSql + " and DEL_FLAG =0";

                    string msg = "";
                    ret = m_ComFunc.DB_Execute(sSql);
                    if (ret)
                    {
                        m_ComFunc.DB_Commit();
                        compnent_int();
                        lblErrMsg.Text = "更新が成功しました。";

                    }
                    else
                    {
                        m_ComFunc.DB_Rollback();
                        lblErrMsg.Text = "更新が失敗しました。";

                    }
                }
            }
            catch (Exception ex)
            {
                lblErrMsg.Text = ex.Message;
            }

        }
        protected void del_Click(object sender, EventArgs e)
        {
            string sSql = string.Empty;
            bool ret = false;
            bool ret1 = false;

            try
            {
                if (string.IsNullOrEmpty(companyID.Text))
                {
                    lblErrMsg.Text = "会社IDが空白ですので、入力して下さい。";

                }
                else
                {

                    //トランザクションの開始
                    m_ComFunc.DB_BeginTranzaction();

                    //insert
                    //従事者情報の登録する。
                    sSql = "UPDATE    company_mst ";
                    sSql = sSql + "SET del_flag = '" + 1 + "'";
                    sSql = sSql + " WHERE company_id = '" + companyID.Text + "'";

                    ret = m_ComFunc.DB_Execute(sSql);
                    if (ret)
                    {
                        //部門マスタの削除する
                        ret1 = updBumon(companyID.Text);
                        if (ret1)
                        {
                            m_ComFunc.DB_Commit();
                            compnent_int();
                            lblErrMsg.Text = "削除が成功しました。";
                        }
                        else
                        {
                            m_ComFunc.DB_Rollback();
                            lblErrMsg.Text = "削除が失敗しました。";
                        }
                    }
                    else
                    {
                        m_ComFunc.DB_Rollback();
                        lblErrMsg.Text = "削除が失敗しました。";
                    }
                }
            }
            catch (Exception ex)
            {
                lblErrMsg.Text = ex.Message;
            }

        }
        //部門マスタ削除する。
        private bool updBumon(string companyID)
        {
            string sSql = string.Empty;
            bool ret = false;


            try
            { 
                //SQL作成                //従事者情報の登録する。
                sSql = "UPDATE    section_mst ";
                sSql = sSql + "SET del_flag = '" + 1 + "'";
                sSql = sSql + " WHERE company_id = '" + companyID + "'";

                ret = m_ComFunc.DB_Execute(sSql);
                if (ret)
                {
                    ret = true;
                }
                else
                {
                    ret = false;
                }

            }
            catch(Exception ex)
            {
                ret = false;
            }

            return ret;
 
        }
        //クリア処理
        protected void clear_Click(object sender, EventArgs e)
        {
            //会社ID
            companyID.Text = string.Empty;
            //会社名
            companyName.Text = string.Empty;
        }
        //戻る
        protected void modoru_Click(object sender, EventArgs e)
        {

            Response.Redirect("Mainmenu.aspx", false);
            Session["FromResult"] = null;

        }
        private void compnent_int()
        {
            companyID.Text = string.Empty;
            companyName.Text = string.Empty;
        }


        protected void Bumoall_Click(object sender, EventArgs e)
        {
            //部門マスタを設定
            companyID.Text = string.Empty;
            companyName.Text = string.Empty;
            Session["FromResult"] = null;

            string query = "SELECT ROW_NUMBER() OVER (ORDER BY COMPANY_ID) AS 'No', [company_id], [section_id], [section_name] FROM [section_mst]  WHERE [DEL_FLAG]=0";
            SqlDataSource1.SelectParameters.Clear();
            SqlDataSource1.SelectCommand = query;
            GridView1.DataSourceID = "SqlDataSource1";
            GridView1.Visible = true;
        }

        protected void GridView1_PageIndexChanging(object sender, GridViewPageEventArgs e)
        {
            GridView1.PageIndex = e.NewPageIndex;

            ////部門マスタを設定
            string query = "SELECT ROW_NUMBER() OVER (ORDER BY COMPANY_ID) AS 'No', [company_id], [section_id], [section_name] FROM [section_mst] WHERE [DEL_FLAG]=0";
            SqlDataSource1.SelectParameters.Clear();

            if (companyID.Text != string.Empty)
            {
                SqlDataSource1.SelectCommand = query + " AND [company_id]=@company_id";
                SqlDataSource1.SelectParameters.Add("company_id", companyID.Text);
            }
            else
                SqlDataSource1.SelectCommand = query;
            { 
            }
            
            GridView1.DataSourceID = "SqlDataSource1";

            GridView1.DataBind();

        }



    }
}