﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using EmpCRM.common;
using EmpCRM.Dto;

namespace EmpCRM
{
    public partial class CompanySearchResult : System.Web.UI.Page
    {
        private ComFunc m_ComFunc = null;
        private List<Company_info> ccompany_infoL = new List<Company_info>();
        private string gPage_num = "1";
        private static log4net.ILog logger = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
        private string sUserID = "";

        protected void Page_Load(object sender, EventArgs e)
        {
            //セッションにユーザIDを設定
            UserRole userRole = Session[ComConst.SESSION_USER_ROLE] as UserRole;
            if (!LoginUtil.IsLogin(userRole))
            {
                Response.Redirect("error.htm", false);
            }

            Session["FromResult"] = null;
            string pcompanyid = Request.QueryString["company_id"];
            string pcompanyname = Request.QueryString["company_name"];
            //セッションクリア
            //会社ID
            Session[ComConst.COMPANY_ID] = string.Empty;
            //会社名
            Session[ComConst.COMPANY_JNAME] = string.Empty;

            //会社情報情報の取得
            workerInfoData(pcompanyid);

        }
        public void workerInfoData(string copmpanyid )
        {
            logger.Info(ComConst.INFO_LOG_START + sUserID + "会社情報の取得処理");

            string sSql = string.Empty;
            bool bRet = false;
            System.Data.DataTable dataTable = null;

            try
            {
                //共通
                m_ComFunc = (ComFunc)Session[ComConst.COM_FUNC];

                //SQL文作成
                sSql = "SELECT ROW_NUMBER() OVER(order by company_id ) 'No', company_id, company_name";
                sSql = sSql + " FROM company_mst";
                sSql = sSql + " WHERE ";
                if (copmpanyid == "")
                {
                    sSql = sSql + "   del_flag = '" + 0 + "'";
                }
                else
                {
                    sSql = sSql + "   company_id = '" + copmpanyid + "'";
                    sSql = sSql + "  AND del_flag = '" + 0 + "'";
                }


                //SQL文発行
                bRet = m_ComFunc.DB_Select(sSql, ref dataTable);

                if (bRet == false)
                {
                    lblErrMsg.Text = "検索できませんでした。";
                }

                GridView1.ShowHeaderWhenEmpty = true;
                GridView1.DataSource = dataTable;
                GridView1.DataBind();


                for (int i = 0; i < dataTable.Rows.Count; i++)
                {
                    Company_info rd = new Company_info();
                    rd.no = Convert.ToInt32( dataTable.Rows[i]["No"]);
                    rd.company_id = dataTable.Rows[i]["company_id"].ToString();
                    rd.company_name = dataTable.Rows[i]["company_name"].ToString();

                    ccompany_infoL.Add(rd);
                }
                //データ件数を表示
                lblErrMsg.Text = dataTable.Rows.Count + "件が検索されました。";

                logger.Info(ComConst.INFO_LOG_END + sUserID + "会社情報情報の取得処理");

            }
            catch (Exception ex)
            {
                lblErrMsg.Text = ex.Message;
                logger.Error("User:" + sUserID + ex.Message, ex);
            }

        }
        ///<summary>
        //選択の押下、処理
        ///</summary>
        protected void selBtn_Click(object sender, EventArgs e)
        {
            logger.Info(ComConst.INFO_LOG_START + sUserID + "選択ボタン押下処理");

            //Label1.Text = selitem.Value;
            int glPage_num = 0;
            if (selitem.Value != "")
            {
                int selitemidx = Int32.Parse(selitem.Value);


                gPage_num = (string)Session["gPage_num"];

                if (gPage_num == null) gPage_num = "1";

                if (Int32.Parse(gPage_num) >= 2)
                {
                    glPage_num = (Int32.Parse(gPage_num) - 1) * GridView1.PageSize;
                }

                selitemidx = selitemidx + glPage_num;


                for (int iIndex = 0; iIndex < ccompany_infoL.Count(); iIndex++)
                {
                    if (selitemidx == iIndex)
                    {
                        //会社ID
                        Session[ComConst.COMPANY_ID] = ccompany_infoL[iIndex].company_id.ToString();
                        //会社名
                        Session[ComConst.COMPANY_JNAME] = ccompany_infoL[iIndex].company_name.ToString();
                        Session["FromResult"] = "CompanyEditResult";
                        break;

                    }
                }

                //Response.Redirect("CompanyInfo.aspx", false);
                //親画面の更新し、閉じる
                string csname = "PostBackSourceWindowScript";
                Type cstype = this.GetType();
                ClientScriptManager cs = Page.ClientScript;
                if (!cs.IsStartupScriptRegistered(cstype, csname))
                {
                    String cstext =
                    @"window.onload = function() {
                if (!window.opener || window.opener.closed) {
                    self.close();
                }
                else {
                    window.opener.document.getElementById('form1').submit();
                    self.close();
                    }
                };";

                    cs.RegisterStartupScript(cstype, csname, cstext, true);
                }

                


            }
            else
            {
                lblErrMsg.Text = "会社情報を選択して下さい。";
            }

            logger.Info(ComConst.INFO_LOG_END + sUserID + "選択ボタン押下処理");

        }
        protected void GridView1_RowCreated(object sender, GridViewRowEventArgs e)
        {
            for (int i = 0; i < GridView1.Rows.Count; i++)
            {
                GridViewRow row = GridView1.Rows[i];
                RadioButton rb =
                  (RadioButton)row.FindControl("RadioButton1");
                rb.Attributes["onClick"] = "getIndex(" + i + ")";

            }

        }

        protected void GridView1_PageIndexChanging(object sender, GridViewPageEventArgs e)
        {
            GridView1.PageIndex = e.NewPageIndex;

            string pcompanyid = Request.QueryString["company_id"];
            string pcompanyname = Request.QueryString["company_name"];

            Session["gPage_num"] = (GridView1.PageIndex + 1).ToString();


            //会社情報情報の取得
            workerInfoData(pcompanyid);


            GridView1.DataBind();


        }


        
    }
}