﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="DepartmentChange.aspx.cs" Inherits="EmpCRM.DepartmentChange" %>
<%-- ヘッダーユーザコントロールを追加 --%>
<%@ Register Tagprefix="cc" Tagname="CommonHeader" Src="control/Header.ascx" %>
<%@ Register Tagprefix="cc" Tagname="DepartmentSelector" Src="control/DepartmentSelector.ascx" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml" lang="ja">
<head runat="server">
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <link rel="stylesheet" href="./css/style.css" type="text/css" />
    <title>部門変更</title>
    <script src="./js/jquery-3.1.1.min.js"></script>
</head>

<body>
    <form id="form1" runat="server">
        <div id="wrapper">
            <!-- header -->
            <cc:CommonHeader ID="CommonHeader" runat="server" />
            <div id="main">
                <h2>部門変更</h2>
                <div class="tagReturn">
                    <span>＞ </span>
                    <asp:HyperLink ID="lnkMenu" NavigateUrl="Mainmenu.aspx" Text="メインメニュー" Target="_top" runat="server" />
                    <span>＞ </span>
                    <span>部門変更</span>

                </div>
                <br />
                <div id="content">
                    <div id="currentBumon" class="ddlBumon" >
                        <div class="ddlTitle">
                            <asp:Label ID="lblCurrentBumon" runat="server">現在設定中の管理部門：</asp:Label>
                        </div>
                        <asp:DropDownList ID="ddlCurrentBumon" runat="server" OnSelectedIndexChanged="ddlCurrentBumon_Changed" AutoPostBack="true" />
                        <div class="currentBumonname">
                            <asp:Label ID="lblCurrentBumonName" runat="server" Text="部門未選択" />
                        </div>
                    </div>
                    <div id="newBumon" class="ddlBumon" style="height:100px" >
                        <div class="ddlTitle">
                            <asp:Label ID="lblNewBumon" runat="server">変更後管理部門：</asp:Label>
                        </div>
                        <cc:DepartmentSelector ID="ccDepartmentSelector" runat="server" />
                    </div>

                    <div id="buttonArea">
                        <asp:Button ID="btnChangeDepartment" runat="server" Text="部門変更実行" OnClick="btnChangeDepartment_Click" CssClass="input_submit LargeBtn" />
                        <asp:Button ID="btnClear" Text="クリア" class="input_submit SmallBtn" runat="server" OnClick="btnClear_Click" />
                        <asp:Button ID="modoru" Text="戻る" class="input_submit SmallBtn" runat="server" OnClick="modoru_Click" />
                    </div>

                    <div>
                        <table class="errMsgTbl">
                            <tr>
                                <td>
                                    <asp:Label ID="lblErrMessage" runat="server" Visible="false" />
                                </td>
                            </tr>
                        </table>
                    </div>
                    <asp:Panel ID="pnlErrorData" runat="server" Visible="false" style="width: 1200px;">
                        <asp:GridView ID="gvErrorData" runat="server" AutoGenerateColumns="false" AllowPaging="true" RowStyle-Height="20px"
                            OnPageIndexChanging="gvPageChanging" ShowHeaderWhenEmpty="true">
                            <PagerSettings Position="Bottom" Mode="NumericFirstLast" />
                            <PagerStyle HorizontalAlign="Center" CssClass="pagerRow" />
                            <HeaderStyle CssClass="gvHead" />
                            <Columns>
                                <asp:BoundField DataField="No" HeaderText="No" HeaderStyle-CssClass="indexNumberColumn align_center" ItemStyle-CssClass="indexNumberColumn" />
                                <asp:BoundField DataField="enginnerID" HeaderText="従事者ID" HeaderStyle-CssClass="lastnameColumn align_center" ItemStyle-CssClass="lastnameColumn" />
                                <asp:BoundField DataField="sectionName" HeaderText="管理部門名" HeaderStyle-CssClass="bumonColumn align_center" ItemStyle-CssClass="bumonColumn" />
                                <asp:BoundField DataField="申請日" HeaderText="申請日" HeaderStyle-CssClass="dateColumn align_center" ItemStyle-CssClass="dateColumn" />
                                <asp:BoundField DataField="belong_company" HeaderText="所属会社" HeaderStyle-CssClass="belongCompanyColumn align_center" ItemStyle-CssClass="belongCompanyColumn" />
                                <asp:BoundField DataField="belong_department" HeaderText="所属部署" HeaderStyle-CssClass="belongCompanyColumn align_center" ItemStyle-CssClass="belongCompanyColumn" />
                                <asp:BoundField DataField="jmcia_flag" HeaderText="JMCIA" HeaderStyle-CssClass="jmcaColumn align_center" ItemStyle-CssClass="jmcaColumn align_center" />
                                <asp:BoundField DataField="sb_wcp" HeaderText="SB/WCP" HeaderStyle-CssClass="sbwcpColumn align_center" ItemStyle-CssClass="sbwcpColumn align_center" />
                                <asp:BoundField DataField="license_number" HeaderText="免許番号" HeaderStyle-CssClass="licenseNumberColumn align_center" ItemStyle-CssClass="licenseNumberColumn" />
                                <asp:BoundField DataField="LastName" HeaderText="氏名（姓）" HeaderStyle-CssClass="lastnameColumn align_center" ItemStyle-CssClass="lastnameColumn" />
                                <asp:BoundField DataField="FirstName" HeaderText="氏名（名）" HeaderStyle-CssClass="firstnameColumn align_center" ItemStyle-CssClass="firstnameColumn" />
                                <asp:BoundField DataField="LastName_Kana" HeaderText="ふりがな（姓）" HeaderStyle-CssClass="kanalastnameColumn align_center" ItemStyle-CssClass="kanalastnameColumn" />
                                <asp:BoundField DataField="FirstName_Kana" HeaderText="ふりがな（名）" HeaderStyle-CssClass="kanafirstnameColumn align_center" ItemStyle-CssClass="kanafirstnameColumn" />
                            </Columns>
                        </asp:GridView>

                    </asp:Panel>
                </div>
            </div>
        </div>
    </form>
</body>
</html>
