﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace EmpCRM.Dto
{
    /// <summary>
    /// ログインしたユーザの情報を保持するクラス
    /// </summary>
    public class UserRole
    {
        private static readonly log4net.ILog logger = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);

        public string _userId;
        private string _userName;
        private string _departmentId;
        private string _departmentName;
        private string[] _roles;
        private string[] _areas;
        private DateTime _loginDateTime;

        //ユーザID
        public string UserId
        {
            get { return this._userId; }
            set { this._userId = value; }
        }

        //ユーザ名
        public string UserName
        {
            get { return this._userName; }
            set { this._userName = value; }
        }

        //部門ID
        public string DepartmentId
        {
            get { return this._departmentId; }
            set { this._departmentId = value; }
        }

        //部門名
        public string DepartmentName
        {
            get { return this._departmentName; }
            set { this._departmentName = value; }
        }

        //権限
        public string[] Roles
        {
            get { return this._roles; }
            set { this._roles = value; }
        }

        //地域
        public string[] Areas
        {
            get { return this._areas; }
            set { this._areas = value; }
        }

        //ログイン日時
        public DateTime LoginDateTime
        {
            get { return this._loginDateTime; }
            set { this._loginDateTime = value; }
        }

        public string DisplayLoginDateTime
        {
            get { return this._loginDateTime.ToString("yyyy/M/d HH:mm:ss"); }
        }
        
        //UserRoleに未設定値が存在する場合はログイン失敗
        public bool IsLogin()
        {
            if (!string.IsNullOrEmpty(this.UserId)
                && !string.IsNullOrEmpty(this.UserName)
                && !string.IsNullOrEmpty(this.DepartmentId)
                && !string.IsNullOrEmpty(this.DepartmentName)
                //&& this.Roles.Count() > 0
                //&& this.Areas.Count() > 0
                && this.LoginDateTime != null
                )
            {
                return true;
            }
            else
            {
                if (string.IsNullOrEmpty(this.UserId)) logger.Debug("UserIdが設定されていません。");
                if (string.IsNullOrEmpty(this.UserName)) logger.Debug("UserNameが設定されていません。");
                if (string.IsNullOrEmpty(this.DepartmentId)) logger.Debug("部門IDが設定されていません。");
                if (string.IsNullOrEmpty(this.DepartmentName)) logger.Debug("部門名が設定されていません。");
                if (this.LoginDateTime == null) logger.Debug("ログイン日時が設定されていません。");
                return false;
            }
        }


    }
}