﻿using OfficeOpenXml;
using System;  
using System.Collections.Generic;
using System.Data;
using System.IO;
using System.Linq;
using System.Web.UI.WebControls;
using EmpCRM.common;
using EmpCRM.Dto;
using log4net;


namespace EmpCRM
{
    public partial class EmployeeAllAdd : System.Web.UI.Page
    {
        //Excel Application宣言
        protected Microsoft.Office.Interop.Excel.Application mApp = null;
        //Excel Workbook宣言
        protected Microsoft.Office.Interop.Excel.Workbook mWorkBook = null;
        //正常用
        private List<Rdselect_info> rdselect_infoL = new List<Rdselect_info>();
        //Warnning用
        private List<warnworker_info> warn_infoL = new List<warnworker_info>();
        //エラー用
        private List<errworker_info> err_infoL = new List<errworker_info>();
        //共通機能設定
        private ComFunc m_ComFunc = new ComFunc();
        //ロガー生成
        private static log4net.ILog logger = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
        private string sUserID = "";

        private int numcnt = 1;
        ///<summary>
        ///１．ページを開いてセッション情報をゲットします。セッション情報が入ってない場合、
        ///エラー画面に遷移される。
        ///２．コンポーネントの初期化する。
        ///</summary>
        ///<remarks>
        ///This is a test.
        ///</remarks>
        protected void Page_Load(object sender, EventArgs e)
        {
            lblErrMsg.Text = "";
            //初期画面表示
            if (!(IsPostBack))
           {
               //セッションにユーザIDを設定
               UserRole userRole = Session[ComConst.SESSION_USER_ROLE] as UserRole;
                //エラー画面に遷移する。
               if (!LoginUtil.IsLogin(userRole))
               {
                   Response.Redirect("error.htm", false);
               }
               else
               {
                   //システム部門の場合、
                   if (userRole.Roles.Contains(ComConst.SYSTEM_OPERATE_USER))
                   {


                       Bu1.Visible = false;
                       Bu2.Visible = true;
                       ////部門マスタ取得
                       //m_ComFunc.bumoMasterList(BumonList, Session[ComConst.SESSION_BUMON_MASTER] as Dictionary<string, string>, true);
                       ccDeepartmentSelector.InitializeControls();
                       ccDeepartmentSelector.Visible = true;



                   }
                   //その他
                   else if (userRole.Roles.Contains(ComConst.REQUEST_USER))
                   {
                       Bu1.Visible = true;
                       Bu2.Visible = false;
                       ////部門ID
                       belong_department.Text = userRole.DepartmentName;


                   }
                   else if (userRole.Roles.Contains(ComConst.APPROVAL_USER))
                   {
                       Bu1.Visible = true;
                       Bu2.Visible = false;
                       ////部門ID
                       belong_department.Text = userRole.DepartmentName;

                   }

               }
               

               sUserID = userRole.UserId;
                
               //再取込
                reRead.Visible = false;
                //削除
               rcdRemove.Visible = false;
               //未取込データ一覧
                T1000.Visible = false;
                //全選択
               cboxAll.Visible = false;
                //前削除
               UncboxAll.Visible = false;
               //エラーデータ一覧
                T101.Visible = false;

           }
               

        }
        ///<summary>
        ///戻る機能
        ///メインメニュー画面に遷移される。
        ///</summary>
        ///<remarks>
        ///This is a test.
        ///</remarks>
        protected void modoru_Click(object sender, EventArgs e)
        {
            Response.Redirect("Mainmenu.aspx", false);
        }

        ///<summary>
        //一括登録する。
        //　Exccelファイルを読み込み、リストに格納する。
        ///</summary>
        ///<remarks>
        ///This is a test.
        ///</remarks>
        protected void Torikomi_Click(object sender, EventArgs e)
        {
            UserRole user = Session[ComConst.SESSION_USER_ROLE] as UserRole;
            sUserID = user.UserId;

            try
            {
                //セッションにユーザIDを設定
                UserRole userRole = Session[ComConst.SESSION_USER_ROLE] as UserRole;

                logger.Info(ComConst.INFO_LOG_START + sUserID + "取込ボタン押下処理");

                string deptID = "";
                //システム部門の場合、
                if (userRole.Roles.Contains(ComConst.SYSTEM_OPERATE_USER))
                {

                    //部門ID
                    //deptID = m_ComFunc.getBumonIdonSystem(ccDeepartmentSelector.SelectedIndex, Session[ComConst.SESSION_BUMON_MASTER] as Dictionary<string, string>);
                    deptID = ccDeepartmentSelector.GetSelectedValue();

                }
                //その他
                else if (userRole.Roles.Contains(ComConst.REQUEST_USER))
                {
                    //部門ID
                    deptID = userRole.DepartmentId;


                }
                else if (userRole.Roles.Contains(ComConst.APPROVAL_USER))
                {
                    //部門ID
                    deptID = userRole.DepartmentId;

                }
                //部門IDの確認
                if (string.IsNullOrEmpty(deptID as string))
                {
                    lblErrMsg.Text = "取込ファイルの部門IDが部門コードではないのでご確認下さい。！";
                    throw new Exception(lblErrMsg.Text);

                }

                if (FileUpload1.HasFile && Path.GetExtension(FileUpload1.FileName) == ".xlsx")
                {
                    using (var excel = new ExcelPackage(FileUpload1.PostedFile.InputStream))
                    {
                        var dt = new System.Data.DataTable(); ;
                        var worksheet = excel.Workbook.Worksheets.First();
                        //システム部門の場合、
                        if (userRole.Roles.Contains(ComConst.SYSTEM_OPERATE_USER))
                        {

                            //部門ID
                            //deptID = m_ComFunc.getBumonIdonSystem(ccDeepartmentSelector.SelectedIndex, Session[ComConst.SESSION_BUMON_MASTER] as Dictionary<string, string>);
                            deptID =ccDeepartmentSelector.GetSelectedValue();

                        }
                        //その他
                        else if (userRole.Roles.Contains(ComConst.REQUEST_USER))
                        {
                            //部門ID
                            deptID = userRole.DepartmentId;


                        }
                        else if (userRole.Roles.Contains(ComConst.APPROVAL_USER))
                        {
                            //部門ID
                            deptID = userRole.DepartmentId;

                        }


                        //セッションに格納
                        Session["deptID"] = deptID;



                        // add DataRows to DataTable
                        //int startRow = hasHeader ? 2 : 1;
                        //int idx = 1;
                        for (int idx = 1; idx <= worksheet.Dimension.End.Row - ComConst.DATA_INDEX; idx++)
                        //while (worksheet.Cells[idx + ComConst.DATA_INDEX, 2].Text.Equals(ComConst.ROWEND) == false)
                       {

                           if (worksheet.Cells[idx + ComConst.DATA_INDEX, 2].Text.Equals(ComConst.ROWEND) == true)
                           {
                               break;
                           }

                            //従事者情報のインスタンス
                            Rdselect_info rds = new Rdselect_info();
                            //行数
                            rds.rows = idx;
                            rds.request_div = "1";
                            //姓
                            ExcelRange rLastName = worksheet.Cells[idx + ComConst.DATA_INDEX, 3];
                            rds.LastName = Convert.ToString(rLastName.Value);
                            //名
                            ExcelRange rFirstName = worksheet.Cells[idx + ComConst.DATA_INDEX, 4];
                            rds.FirstName = Convert.ToString(rFirstName.Value);
                            //セイ
                            ExcelRange rLastName_Kana = worksheet.Cells[idx + ComConst.DATA_INDEX, 5];
                            rds.LastName_Kana = Convert.ToString(rLastName_Kana.Value);
                            //メイ
                            ExcelRange rFirstName_Kana = worksheet.Cells[idx + ComConst.DATA_INDEX, 6];
                            rds.FirstName_Kana = Convert.ToString(rFirstName_Kana.Value);
                            //免許取得日
                            ExcelRange getlicense_date = worksheet.Cells[idx + ComConst.DATA_INDEX, 7];
                            //TODO
                            //★日付形式チェック
                            DateTime dtmCheck;
                            if (DateTime.TryParseExact(getlicense_date.Text, "yyyy/mm/dd", null, System.Globalization.DateTimeStyles.None, out dtmCheck) == false)
                            {
                                //throw new ArgumentOutOfRangeException("日付", getlicense_date, "正しい日付ではありません。");
                                DateTime dateDefault = new DateTime();
                                rds.getlicense_date = dateDefault;
                            }
                            else
                            {
                                rds.getlicense_date = Convert.ToDateTime(getlicense_date.Value);
                            }
                            //免許種別
                            ExcelRange rlicense_type = worksheet.Cells[idx + ComConst.DATA_INDEX, 8];
                            rds.license_type = Convert.ToString(rlicense_type.Value);
                            //免許番号
                            ExcelRange rlicense_number = worksheet.Cells[idx + ComConst.DATA_INDEX, 9];
                            rds.license_number = Convert.ToString(rlicense_number.Value);
                            //業務履歴
                            ExcelRange rtask_history = worksheet.Cells[idx + ComConst.DATA_INDEX, 10];
                            rds.task_history = Convert.ToString(rtask_history.Value);
                            //申請区分
                            ExcelRange rrequest_div = worksheet.Cells[idx + ComConst.DATA_INDEX, 11];
                            rds.request_div = Convert.ToString(rrequest_div.Value);
                            //会社名
                            ExcelRange rbelong_company = worksheet.Cells[idx + ComConst.DATA_INDEX, 12];
                            rds.belong_company = Convert.ToString(rbelong_company.Value);
                            //部署
                            ExcelRange rbelong_department = worksheet.Cells[idx + ComConst.DATA_INDEX, 13];
                            rds.belong_department = Convert.ToString(rbelong_department.Value);
                            //JMCIA
                            ExcelRange rjmcia_flag = worksheet.Cells[idx + ComConst.DATA_INDEX, 14];
                            rds.jmcia_flag = Convert.ToInt32(Convert.ToString(rjmcia_flag.Value));
                            //SB/WCP
                            ExcelRange rsb_wcp = worksheet.Cells[idx + ComConst.DATA_INDEX, 15];
                            rds.sb_wcp = Convert.ToInt32(Convert.ToString(rsb_wcp.Value));
                            //J北海道
                            ExcelRange rhokkaidou = worksheet.Cells[idx + ComConst.DATA_INDEX, 16];
                            rds.hokkaidou = Convert.ToString(rhokkaidou.Value);
                            //J東北
                            ExcelRange rtouhoku = worksheet.Cells[idx + ComConst.DATA_INDEX, 17];
                            rds.touhoku = Convert.ToString(rtouhoku.Value);
                            //J北陸
                            ExcelRange rhokuriku = worksheet.Cells[idx + ComConst.DATA_INDEX, 18];
                            rds.hokuriku = Convert.ToString(rhokuriku.Value);
                            //信越
                            ExcelRange rshinetsu = worksheet.Cells[idx + ComConst.DATA_INDEX, 19];
                            rds.shinetsu = Convert.ToString(rshinetsu.Value);
                            //関東
                            ExcelRange rkantou = worksheet.Cells[idx + ComConst.DATA_INDEX, 20];
                            rds.kantou = Convert.ToString(rkantou.Value);
                            //東海
                            ExcelRange rtokai = worksheet.Cells[idx + ComConst.DATA_INDEX, 21];
                            rds.tokai = Convert.ToString(rtokai.Value);
                            //近畿
                            ExcelRange rkinki = worksheet.Cells[idx + ComConst.DATA_INDEX, 22];
                            rds.kinki = Convert.ToString(rkinki.Value);
                            //四国
                            ExcelRange rshikoku = worksheet.Cells[idx + ComConst.DATA_INDEX, 23];
                            rds.shikoku = Convert.ToString(rshikoku.Value);
                            //四国
                            ExcelRange rchugoku = worksheet.Cells[idx + ComConst.DATA_INDEX, 24];
                            rds.chugoku = Convert.ToString(rchugoku.Value);
                            //九州
                            ExcelRange rkyuushu = worksheet.Cells[idx + ComConst.DATA_INDEX, 25];
                            rds.kyuushu = Convert.ToString(rkyuushu.Value);
                            //沖縄
                            ExcelRange rokinawa = worksheet.Cells[idx + ComConst.DATA_INDEX, 26];
                            rds.okinawa = Convert.ToString(rokinawa.Value);

                            rdselect_infoL.Add(rds);


                        }
                        //無線従事者情報tと選任・解任 個別情報のテーブル登録
                        Ins_workerTable(rdselect_infoL);
                        Session["rdselect_infoL"] = rdselect_infoL;

                    }

                }
                else
                {
                    lblErrMsg.Text = "アップロードファイルが選択されませんでした。.";
                }

                logger.Info(ComConst.INFO_LOG_END + sUserID + "取込ボタン押下処理");

            }
            catch (Exception ex)
            {
                lblErrMsg.Text = ex.Message;
                logger.Error("User:" + sUserID + ex.Message, ex);

            }

        }

        ///<summary>
        //一括登録する。
        //　１．項目チェック（必須、形式）
        //　２．従事者情報をDBに登録する。
        ///</summary>
        ///<remarks>
        ///This is a test.
        ///</remarks>
        private void Ins_workerTable(List<Rdselect_info> arrList) 
        {
            logger.Info(ComConst.INFO_LOG_START + sUserID + "一括登録処理");

            string sSql = string.Empty;
            bool ret = false;
            List<string> errList = new List<string>();
            List<string> warnList = new List<string>();
            System.Data.DataTable errDt = new System.Data.DataTable("errTB");
            System.Data.DataTable warnDt = new System.Data.DataTable("warnTB");
            bool bFg = false;
            int input_cnt = 0;
            UserRole user = Session[ComConst.SESSION_USER_ROLE] as UserRole;
            sUserID = user.UserId;

            try
            {
                // err列を追加します。
                errDt.Columns.Add("row");
                errDt.Columns.Add("Lastname");
                errDt.Columns.Add("Firstname");
                errDt.Columns.Add("license_number");
                errDt.Columns.Add("request_div");
                errDt.Columns.Add("belong_company");
                errDt.Columns.Add("belong_department");
                errDt.Columns.Add("errmessage");
                errDt.Columns.Add("kind");

                //warn列を追加します。
                warnDt.Columns.Add("no");
                warnDt.Columns.Add("Lastname");
                warnDt.Columns.Add("Firstname");
                warnDt.Columns.Add("license_number");
                warnDt.Columns.Add("request_div");
                warnDt.Columns.Add("belong_company");
                warnDt.Columns.Add("belong_department");
                warnDt.Columns.Add("errmessage");
                warnDt.Columns.Add("kind");

                //セッションから情報を取得
                m_ComFunc = (ComFunc)Session[ComConst.COM_FUNC];

                //トランザクションの開始
                //m_ComFunc.DB_BeginTranzaction();

                //登録フラグ
                bool insertOkFlg = true;
                //必須フラグ
                bool manatoryFlg = true;

                //NumberSeqの取得
                int num = this.m_ComFunc.geNumberSeq();
                if (num > 0)
                {
                    foreach (Rdselect_info emInfo in arrList)
                    {
                        num++;

                        //重複データ確認
                        DataTable dt = searchradio_enginner_info_tbl(emInfo);
                        if (dt.Rows.Count > 0)   //従事者情報更新
                        {
                            //更新の場合、
                            //System.Data.DataTable dt = new System.Data.DataTable();
                            bool bRet = false;
                            //セッションから情報を取得
                            m_ComFunc = (ComFunc)Session[ComConst.COM_FUNC];
                            ret = true;
                            //トランザクションの開始
                            m_ComFunc.DB_BeginTranzaction();

                            //////SQL文発行
                            ////Update
                            //sSql = "UPDATE  radio_enginner_info_tbl ";
                            //sSql = sSql + "SET getlicense_date ='" + emInfo.getlicense_date + "'";
                            //sSql = sSql + " WHERE license_number= '" + emInfo.license_number + "'";
                            //sSql = sSql + " AND LastName= '" + emInfo.LastName + "'";
                            //sSql = sSql + " AND FirstName= '" + emInfo.FirstName + "'";
                            //sSql = sSql + " AND enginnerID= '" + dt.Rows[0][0].ToString() + "'";

                            //string msg = "";
                            //ret = m_ComFunc.DB_Execute(sSql);

                            //if (ret == false)
                            //{
                            //    m_ComFunc.DB_Rollback();
                            //}


                            ////従事者情報DBに3項目が同じデータが存在しているかチェックする
                            //m_ComFunc.isMultiLicnse_num(emInfo.license_number, emInfo.LastName, emInfo.FirstName, ref errList);
                            //if (errList.Count > 0)
                            //{
                            //    add_err_infoDt(emInfo, errList[2].ToString(), errDt);
                            //    errList.Clear();
                            //    insertOkFlg = false;
                            //}

                            string msg = string.Empty;
                            string tEngID = dt.Rows[0][0].ToString();
                            //選任・解任 個別情報の登録
                            ret = Ins_selection_personla(emInfo, Int32.Parse(tEngID), tEngID, ref msg);
                            if (ret)
                            {
                                m_ComFunc.DB_Commit();
                                input_cnt++;
                                //NumberSeqの更新
                                bFg = m_ComFunc.setNumberSeq(num);
                                if (bFg == false)
                                {
                                    m_ComFunc.DB_Rollback();
                                }
                            }
                            else
                            {
                                m_ComFunc.DB_Rollback();

                                add_err_infoDt(emInfo, msg, errDt);


                            }

                        }
                        else                //新規作成
                        {
                            insertOkFlg = true;
                            manatoryFlg = true;
                            errList.Clear();
                            warnList.Clear();

                            //必須入力チェック
                            //免許番号
                            m_ComFunc.mandatoryCHK(emInfo.license_number, 1, ref errList);
                            if (errList.Count > 0)
                            {
                                //add_warn_infoL(emInfo, errList[2].ToString());
                                //add_err_infoL(emInfo, errList[2].ToString());
                                add_err_infoDt(emInfo, errList[2].ToString(), errDt);
                                errList.Clear();
                                insertOkFlg = false;
                                manatoryFlg = false;

                                //break;
                            }
                            //氏名（姓）
                            m_ComFunc.mandatoryCHK(emInfo.LastName, 3, ref errList);
                            if (errList.Count > 0)
                            {
                                //                            add_warn_infoL(emInfo, errList[2].ToString());
                                // break;
                                //add_err_infoL(emInfo, errList[2].ToString());
                                add_err_infoDt(emInfo, errList[2].ToString(), errDt);
                                errList.Clear();
                                insertOkFlg = false;
                                manatoryFlg = false;
                            }
                            //氏名（名）
                            m_ComFunc.mandatoryCHK(emInfo.FirstName, 4, ref errList);
                            if (errList.Count > 0)
                            {
                                //add_warn_infoL(emInfo, errList[2].ToString());
                                //add_err_infoL(emInfo, errList[2].ToString());
                                add_err_infoDt(emInfo, errList[2].ToString(), errDt);
                                errList.Clear();
                                insertOkFlg = false;
                                manatoryFlg = false;

                                // break;
                            }
                            //氏名ふりがな（姓）
                            m_ComFunc.mandatoryCHK(emInfo.LastName_Kana, 5, ref errList);
                            if (errList.Count > 0)
                            {
                                //add_warn_infoL(emInfo, errList[2].ToString());
                                //add_err_infoL(emInfo, errList[2].ToString());
                                add_err_infoDt(emInfo, errList[2].ToString(), errDt);
                                errList.Clear();

                                insertOkFlg = false;
                                manatoryFlg = false;

                            }

                            //氏名ふりがな（名）
                            m_ComFunc.mandatoryCHK(emInfo.FirstName_Kana, 6, ref errList);
                            if (errList.Count > 0)
                            {
                                //add_warn_infoL(emInfo, errList[2].ToString());
                                //add_err_infoL(emInfo, errList[2].ToString());
                                add_err_infoDt(emInfo, errList[2].ToString(), errDt);
                                errList.Clear();

                                errList.Clear();
                                insertOkFlg = false;
                                manatoryFlg = false;
                            }
                            //必須がOKかチェック
                            if (manatoryFlg)
                            {
                                //形式チェック(免許番号）
                                m_ComFunc.formatCHK(emInfo.license_number, ref errList);
                                if (errList.Count > 0)
                                {
                                    //add_warn_infoL(emInfo, errList[2].ToString());
                                    add_err_infoDt(emInfo, errList[2].ToString(), errDt);
                                    errList.Clear();

                                    //add_err_infoL(emInfo, errList[2].ToString());
                                    insertOkFlg = false;
                                }

                                ////免許取得日形式チェック
                                m_ComFunc.IsRightDate(emInfo.getlicense_date, ref errList);
                                if (warnList.Count > 0)
                                {
                                    add_err_infoDt(emInfo, errList[2].ToString(), errDt);
                                    errList.Clear();
                                    insertOkFlg = false;

                                }

                                //従事者情報DBに免許番号が同じで、氏名が違うデータの存在チェック
                                m_ComFunc.IsExistRadioMenKey(emInfo.license_number, emInfo.LastName, emInfo.FirstName, ref warnList);
                                if (warnList.Count > 0)
                                {
                                    add_warn_infoDt(emInfo, warnList[2].ToString(), warnDt);
                                    warnList.Clear();
                                    insertOkFlg = false;

                                }

                                //従事者情報DBに3項目が同じデータが存在しているかチェックする
                                m_ComFunc.isMultiLicnse_num(emInfo.license_number, emInfo.LastName, emInfo.FirstName, ref errList);
                                if (errList.Count > 0)
                                {
                                    add_err_infoDt(emInfo, errList[2].ToString(), errDt);
                                    errList.Clear();
                                    insertOkFlg = false;
                                }

                                //登録処理
                                if (insertOkFlg)
                                {
                                    //トランザクションの開始
                                    m_ComFunc.DB_BeginTranzaction();

                                    //insert
                                    //従事者情報の登録する。
                                    sSql = "INSERT INTO radio_enginner_info_tbl(";
                                    sSql = sSql + "license_number";
                                    sSql = sSql + ", LastName";
                                    sSql = sSql + ", FirstName";
                                    sSql = sSql + ", birthday";
                                    sSql = sSql + ", enginnerID";
                                    sSql = sSql + ", LastName_Kana";
                                    sSql = sSql + ", FirstName_Kana";
                                    sSql = sSql + ", license_type";
                                    sSql = sSql + ", getlicense_date";
                                    sSql = sSql + ", zip_code";
                                    sSql = sSql + ", prefectures";
                                    sSql = sSql + ", city";
                                    sSql = sSql + ", address";
                                    sSql = sSql + ", business_backgrand";
                                    sSql = sSql + ", createdate";
                                    sSql = sSql + ", create_name";
                                    sSql = sSql + ", updatedate";
                                    sSql = sSql + ", update_name";
                                    sSql = sSql + ") VALUES (";
                                    sSql = sSql + "'" + emInfo.license_number + "'";
                                    sSql = sSql + ", '" + emInfo.LastName + "'";
                                    sSql = sSql + ", '" + emInfo.FirstName + "'";
                                    sSql = sSql + ", '" + null + "'";
                                    sSql = sSql + ", '" + Convert.ToString(num) + "'";
                                    sSql = sSql + ", '" + emInfo.LastName_Kana + "'";
                                    sSql = sSql + ", '" + emInfo.FirstName_Kana + "'";
                                    sSql = sSql + ", '" + emInfo.license_type + "'";
                                    sSql = sSql + ", '" + emInfo.getlicense_date + "'";
                                    sSql = sSql + ", '" + null + "'";
                                    sSql = sSql + ", '" + null + "'";
                                    sSql = sSql + ", '" + null + "'";
                                    sSql = sSql + ", '" + null + "'";
                                    sSql = sSql + ", '" + null + "'";
                                    sSql = sSql + ", getdate()";
                                    sSql = sSql + ", '" + sUserID + "'";
                                    sSql = sSql + ", getdate()";
                                    sSql = sSql + ", '" + sUserID + "'";
                                    sSql = sSql + ")";

                                    string msg = "";
                                    ret = m_ComFunc.DB_ExecuteforErrMsg(sSql, ref msg);


                                    if (ret)
                                    {
                                        //選任・解任 個別情報の登録
                                        ret = Ins_selection_personla(emInfo, num, num.ToString(), ref msg);
                                        if (ret)
                                        {
                                            m_ComFunc.DB_Commit();
                                            input_cnt++;
                                            //NumberSeqの更新
                                            bFg = m_ComFunc.setNumberSeq(num);
                                            if (bFg == false)
                                            {
                                                m_ComFunc.DB_Rollback();
                                            }
                                        }
                                        else
                                        {
                                            m_ComFunc.DB_Rollback();
                                            //エラーの場合
                                            add_err_infoDt(emInfo, msg, errDt);
                                        }
                                    }
                                    else
                                    {
                                        m_ComFunc.DB_Rollback();
                                        //未登録データのインスタンス作成
                                        add_err_infoDt(emInfo, msg, errDt);
                                    }
                                }
                            }
                        }
                    }

                    Session["err_infoL"] = errDt;
                    //Session["warn_infoL"] = warn_infoL;

                    if (errDt.Rows.Count > 0)
                    {
                        T101.Visible = true;
                        //GridView2.ShowHeaderWhenEmpty = true;
                        GridView2.DataSource = errDt;
                        GridView2.DataBind();
                    }
                    else
                    {
                        //T101.Visible = true;
                        //GridView2.ShowHeaderWhenEmpty = true;
                        GridView2.DataSource = errDt;
                        GridView2.DataBind();

                    }
                    //セッション情報を設定する。
                    Session["warnDt"] = warnDt;

                    if (warnDt.Rows.Count > 0)
                    {
                        T1000.Visible = true;
                        reRead.Visible = true;
                        rcdRemove.Visible = true;
                        cboxAll.Visible = true;
                        UncboxAll.Visible = true;
                        //GridView1.ShowHeaderWhenEmpty = true;
                        GridView1.DataSource = warnDt;
                        GridView1.DataBind();

                    }
                    else 
                    {
                        //T1000.Visible = true;
                        //GridView1.ShowHeaderWhenEmpty = true;
                        GridView1.DataSource = warnDt;
                        GridView1.DataBind();
                    }
                    //セッション情報を設定する。
                    Session["warnDt"] = warnDt;

                    //セッション情報を設定する。
                    Session["arrList"] = arrList;
                    
                }
                else
                {
                    lblErrMsg.Text = "従事者IDの取得が失敗しました。";
                }

                if ((bFg)&&(ret))
                {
                    lblErrMsg.Text = input_cnt +"件、登録が成功しました。";
                }

                logger.Info(ComConst.INFO_LOG_END + sUserID + "一括登録処理");

            }
            catch (Exception ex)
            {
                lblErrMsg.Text = ex.Message;
                logger.Error("User:" + sUserID + ex.Message, ex);


            }
        }
        private DataTable searchradio_enginner_info_tbl(Rdselect_info emInfo )
        {
            bool ret = false, bRet = false;
            string sSql = string.Empty;
            DataTable dt = new DataTable();


            //SELECT
            sSql = "SELECT  enginnerID FROM radio_enginner_info_tbl  ";
            sSql = sSql + " WHERE license_number = '" + emInfo.license_number + "'";
            sSql = sSql + " AND license_number = '" + emInfo.license_number + "'";
            sSql = sSql + " AND LastName= '" + emInfo.LastName + "'";
            sSql = sSql + " AND FirstName= '" + emInfo.FirstName + "'";

            ret = m_ComFunc.DB_Select(sSql, ref dt);


            return dt;

        }
        ///<summary>
        //　エラーDataTableの作成
        ///</summary>
        ///<remarks>
        ///This is a test.
        ///</remarks>
        private void add_err_infoDt(Rdselect_info warninfo, string errmsg, System.Data.DataTable dt)
        {
            logger.Info(ComConst.INFO_LOG_START + sUserID + "エラーDataTableの作成処理");

            DataRow errkRow;

            errkRow = dt.NewRow();
            
            //row
            errkRow["row"] = warninfo.rows;
            //氏名（姓）
            errkRow["Lastname"] = warninfo.LastName;
            //氏名（名）
            errkRow["Firstname"] = warninfo.FirstName;
            //免許番号
            errkRow["license_number"] = warninfo.license_number;
            //選/解
            errkRow["request_div"] = getRequest_div(warninfo.request_div);
            //所属会社
            errkRow["belong_company"] = warninfo.belong_company;
            //所属部門
            errkRow["belong_department"] = warninfo.belong_department;
            //メッセージ
            errkRow["errmessage"] = errmsg;
            //エラー種別
            var enmVal = ComConst.errKind.E;
            errkRow["kind"] = Enum.GetName(typeof(ComConst.errKind), enmVal);


            dt.Rows.Add(errkRow);
            logger.Info(ComConst.INFO_LOG_END + sUserID + "エラーDataTableの作成処理");

        }
        ///<summary>
        //　警告DataTableの作成
        ///</summary>
        ///<remarks>
        ///This is a test.
        ///</remarks>
        private void add_warn_infoDt(Rdselect_info warninfo, string errmsg, System.Data.DataTable dt)
        {
            logger.Info(ComConst.INFO_LOG_START + sUserID + "警告DataTableの作成処理");

            DataRow warnkRow;

            warnkRow = dt.NewRow();

            //row
            warnkRow["no"] = numcnt++;
            //氏名（姓）
            warnkRow["Lastname"] = warninfo.LastName;
            //氏名（名）
            warnkRow["Firstname"] = warninfo.FirstName;
            //免許番号
            warnkRow["license_number"] = warninfo.license_number;
            //選/解
            warnkRow["request_div"] = getRequest_div(warninfo.request_div);
            //所属会社
            warnkRow["belong_company"] = warninfo.belong_company;
            //所属部門
            warnkRow["belong_department"] = warninfo.belong_department;
            //メッセージ
            warnkRow["errmessage"] = errmsg;
            //エラー種別
            var enmVal = ComConst.errKind.W;
            warnkRow["kind"] = Enum.GetName(typeof(ComConst.errKind), enmVal);


            dt.Rows.Add(warnkRow);

            logger.Info(ComConst.INFO_LOG_END + sUserID + "警告DataTableの作成処理");


        }
        ///<summary>
        //　申請区分の設定
        ///</summary>
        ///<remarks>
        ///This is a test.
        ///</remarks>
        private string getRequest_div(string pFlg)
        {
            string ret = string.Empty;

            if (pFlg == "1")
            {
                ret = ComConst.SENNIN;
            }
            else if (pFlg == "2")
            {
                ret = ComConst.KAININ;
            }

            return ret;
        }


        ///<summary>
        //　選任/解任情報の登録する。
        ///</summary>
        ///<remarks>
        ///This is a test.
        ///</remarks>
        private bool Ins_selection_personla(Rdselect_info winfo, int pnum,string num_selection_date,ref string msg)
        {
            string sSql = string.Empty;
            bool ret = false, ret1=false;
            UserRole user = Session[ComConst.SESSION_USER_ROLE] as UserRole;
            sUserID = user.UserId;

            try
            {
                logger.Info(ComConst.INFO_LOG_START + sUserID + "選任/解任情報の登録処理");

                //トランザクションの開始
                m_ComFunc.DB_BeginTranzaction();
                //セッションにユーザIDを設定
                //UserRole userRole = Session[ComConst.SESSION_USER_ROLE] as UserRole;
                string depID = (String)Session["deptID"];

                //登録
                sSql = "INSERT INTO selection_personal_tbl(";
                sSql = sSql + "enginnerID";             //従事者ID
                sSql = sSql + ", selectionID";          //選任部門ID
                sSql = sSql + ", request_date";         //申請日
                sSql = sSql + ", request_div";          //申請区分
                sSql = sSql + ", belong_company";       //所属会社（施工会社）   
                sSql = sSql + ", belong_department";    //所属部署（施工会社）
                sSql = sSql + ", jmcia_flag";           //JMCIA所属フラグ
                sSql = sSql + ", sb_wcp";               //SB/WCP区分
                sSql = sSql + ", hokkaidou";            //北海道（局種別）
                sSql = sSql + ", touhoku";              //東北（局種別）
                sSql = sSql + ", hokuriku";             //北陸（局種別
                sSql = sSql + ", shinetsu";             //信越（局種別）
                sSql = sSql + ", kantou";               //関東（局種別）
                sSql = sSql + ", tokai";                //東海（局種別）
                sSql = sSql + ", kinki";                //近畿（局種別）
                sSql = sSql + ", shikoku";              //四国（局種別）
                sSql = sSql + ", chugoku";             //中国（局種別）
                sSql = sSql + ", kyuushu";             //九州（局種別）
                sSql = sSql + ", okinawa";             //沖縄（局種別）
                sSql = sSql + ", apploval_flag";       //承認フラグ
                sSql = sSql + ", delete_flag";         //削除フラグ
                sSql = sSql + ", create_date";         //作成日
                sSql = sSql + ", create_name";         //作成者   
                sSql = sSql + ", update_date";         //更新日
                sSql = sSql + ", update_name";          //更新者
                sSql = sSql + ") VALUES (";
                sSql = sSql + "'" + Convert.ToString(num_selection_date) + "'";           //従事者ID
                sSql = sSql + ", '" + depID + "'";   //選任部門ID
                sSql = sSql + ", getdate()";                                //申請日
                sSql = sSql + ", '" + winfo.request_div + "'";              //申請区分
                sSql = sSql + ", '" + winfo.belong_company + "'";           //所属会社（施工会社）
                sSql = sSql + ", '" + winfo.belong_department + "'";       //所属部署（施工会社）
                sSql = sSql + ", '" + winfo.jmcia_flag + "'";            //JMCIA所属フラグ
                sSql = sSql + ", '" + winfo.sb_wcp + "'";                       //SB/WCP区分
                sSql = sSql + ", '" + winfo.hokkaidou + "'"; ;          //北海道（局種別）
                sSql = sSql + ", '" + winfo.touhoku + "'"; ;            //東北（局種別）
                sSql = sSql + ", '" + winfo.hokuriku + "'"; ;           //北陸（局種別）
                sSql = sSql + ", '" + winfo.shinetsu + "'"; ;           //信越（局種別）
                sSql = sSql + ", '" + winfo.kantou + "'"; ;             //関東（局種別）
                sSql = sSql + ", '" + winfo.tokai + "'"; ;              //東海（局種別）
                sSql = sSql + ", '" + winfo.kinki + "'"; ;              //近畿（局種別）
                sSql = sSql + ", '" + winfo.shikoku + "'"; ;            //四国（局種別）
                sSql = sSql + ", '" + winfo.chugoku + "'"; ;            //中国（局種別）
                sSql = sSql + ", '" + winfo.kyuushu + "'"; ;            //九州（局種別）
                sSql = sSql + ", '" + winfo.okinawa + "'"; ;            //沖縄（局種別）
                sSql = sSql + ",'" + 1 + "'";                          //承認フラグ
                sSql = sSql + ",'" + 0 + "'";                            //削除フラグ 承認依頼の値
                sSql = sSql + ", getdate()";                              //作成日
                sSql = sSql + ", '" + sUserID + "'";                       //作成者
                sSql = sSql + ", getdate()";                             //更新日
                sSql = sSql + ", '" + sUserID + "'";                        //更新者
                sSql = sSql + ")";

                ret = m_ComFunc.DB_Execute(sSql);
                if (ret)
                {
                    ret1 = true;

                    //選任日解任日設定の登録
                    ret1 = Insselection_date_tbl(winfo, Convert.ToString(pnum), depID, Convert.ToString(num_selection_date));
                    if (ret1 == false)
                    {
                        ret1 = false;
                    }
                }
                else
                {
                    ret1 = false;
                    msg ="DBに同じ選任/解任のデータが存在しています。";

                }

                logger.Info(ComConst.INFO_LOG_END + sUserID + "選任/解任情報の登録処理");
            }
            catch (Exception ex)
            {
                logger.Error("User:" + sUserID + ex.Message, ex); 
                ret = false;
                msg = ex.Message;

            }

            if ((ret == true) && (ret1 == true))
            {
                return true;
            }
            else
            {
                return false;
            }
 
        }

        ///<summary>
        //選任日解任日設定の登録
        ///</summary>
        ///<remarks>
        ///This is a test.
        ///</remarks>
        private bool Insselection_date_tbl(Rdselect_info excleinfo, string enginnerID, string selectionID, string tenginnerID)
        {
            logger.Info(ComConst.INFO_LOG_START + sUserID + "選任日解任日設定の登録処理");

            bool ret = true;
            int request_kind = 1;

            //セッションから情報を取得
            m_ComFunc = (ComFunc)Session[ComConst.COM_FUNC];

            //北海道
            //selection_date_tblの登録されているデータ検索
            //1.地域に何か値が設定されたら、レコード作成する。
            //1.で作成の際に、選任/解任日はnullで設定する。

            request_kind = isSelection_personal(tenginnerID, selectionID, m_ComFunc.GetAreaRowName("J"));
            if (excleinfo.hokkaidou == "")
            {
                if ((request_kind == 1) || (request_kind == 2))
                {
                    ret = InsSelectionDateTbl(tenginnerID, selectionID, 1, request_kind);
                    if (ret == false)
                    {
                        return false;
                    }

                }
            }
            else
            {
                ret = InsSelectionDateTbl(tenginnerID, selectionID, 1, request_kind);
                if (ret == false)
                {
                    return false;
                }
            }
            //東北
            request_kind = isSelection_personal(tenginnerID, selectionID, m_ComFunc.GetAreaRowName("I"));
            if (excleinfo.touhoku == "")
            {
                if ((request_kind == 1) || (request_kind == 2))
                {
                    ret = InsSelectionDateTbl(tenginnerID, selectionID, 2, request_kind);
                    if (ret == false)
                    {
                        return false;

                    }
                }
            }
            else
            {
                ret = InsSelectionDateTbl(tenginnerID, selectionID, 2, request_kind);
                if (ret == false)
                {
                    return false;

                }
            }
            //北陸
            request_kind = isSelection_personal(tenginnerID, selectionID, m_ComFunc.GetAreaRowName("D"));
            if (excleinfo.hokuriku == "")
            {
                if ((request_kind == 1) || (request_kind == 2))
                {
                    ret = InsSelectionDateTbl(tenginnerID, selectionID, 3, request_kind);
                    if (ret == false)
                    {
                        return false;
                    }
                }
            }
            else
            {
                ret = InsSelectionDateTbl(tenginnerID, selectionID, 3, request_kind);
                if (ret == false)
                {
                    return false;
                }
            }
            //信越
            request_kind = isSelection_personal(tenginnerID, selectionID, m_ComFunc.GetAreaRowName("B"));
            if (excleinfo.shinetsu == "")
            {
                if ((request_kind == 1) || (request_kind == 2))
                {
                    ret = InsSelectionDateTbl(tenginnerID, selectionID, 4, request_kind);
                    if (ret == false)
                    {
                        return false;
                    }
                }
            }
            else
            {
                ret = InsSelectionDateTbl(tenginnerID, selectionID, 4, request_kind);
                if (ret == false)
                {
                    return false;
                }
            }
            //関東
            request_kind = isSelection_personal(tenginnerID, selectionID, m_ComFunc.GetAreaRowName("A"));
            if (excleinfo.kantou == "")
            {
                if ((request_kind == 1) || (request_kind == 2))
                {
                    ret = InsSelectionDateTbl(tenginnerID, selectionID, 5, request_kind);
                    if (ret == false)
                    {
                        return false;
                    }
                }
            }
            else
            {
                ret = InsSelectionDateTbl(tenginnerID, selectionID, 5, request_kind);
                if (ret == false)
                {
                    return false;
                }
            }
            //東海
            request_kind = isSelection_personal(tenginnerID, selectionID, m_ComFunc.GetAreaRowName("C"));
            if (excleinfo.tokai == "")
            {
                if ((request_kind == 1) || (request_kind == 2))
                {
                    ret = InsSelectionDateTbl(tenginnerID, selectionID, 6, request_kind);
                    if (ret == false)
                    {
                        return false;
                    }
                }
            }
            else
            {
                ret = InsSelectionDateTbl(tenginnerID, selectionID, 6, request_kind);
                if (ret == false)
                {
                    return false;
                }
            }
            //近畿
            request_kind = isSelection_personal(tenginnerID, selectionID, m_ComFunc.GetAreaRowName("E"));
            if (excleinfo.kinki == "")
            {
                if ((request_kind == 1) || (request_kind == 2))
                {
                    ret = InsSelectionDateTbl(tenginnerID, selectionID, 7, request_kind);
                    if (ret == false)
                    {
                        return false;
                    }
                }
            }
            else
            {
                ret = InsSelectionDateTbl(tenginnerID, selectionID, 7, request_kind);
                if (ret == false)
                {
                    return false;
                }
            }
            //四国
            request_kind = isSelection_personal(tenginnerID, selectionID, m_ComFunc.GetAreaRowName("H"));
            if (excleinfo.shikoku == "")
            {
                if ((request_kind == 1) || (request_kind == 2))
                {
                    ret = InsSelectionDateTbl(tenginnerID, selectionID, 8, request_kind);
                    if (ret == false)
                    {
                        return false;
                    }
                }
            }
            else
            {
                ret = InsSelectionDateTbl(tenginnerID, selectionID, 8, request_kind);
                if (ret == false)
                {
                    return false;
                }
            }
            //中国
            request_kind = isSelection_personal(tenginnerID, selectionID, m_ComFunc.GetAreaRowName("F"));
            if (excleinfo.chugoku == "")
            {
                if ((request_kind == 1) || (request_kind == 2))
                {
                    ret = InsSelectionDateTbl(tenginnerID, selectionID, 9, request_kind);
                    if (ret == false)
                    {
                        return false;
                    }
                }
            }
            else
            {
                ret = InsSelectionDateTbl(tenginnerID, selectionID, 9, request_kind);
                if (ret == false)
                {
                    return false;
                }
            }
            //九州
            request_kind = isSelection_personal(tenginnerID, selectionID, m_ComFunc.GetAreaRowName("G"));
            if (excleinfo.kyuushu == "")
            {
                if ((request_kind == 1) || (request_kind == 2))
                {
                    ret = InsSelectionDateTbl(tenginnerID, selectionID, 10, request_kind);
                    if (ret == false)
                    {
                        return false;
                    }
                }
            }
            else
            {
                ret = InsSelectionDateTbl(tenginnerID, selectionID, 10, request_kind);
                if (ret == false)
                {
                    return false;
                }
            }
            //沖縄
            request_kind = isSelection_personal(tenginnerID, selectionID, m_ComFunc.GetAreaRowName("O"));
            if (excleinfo.okinawa == "")
            {
                if ((request_kind == 1) || (request_kind == 2))
                {
                    ret = InsSelectionDateTbl(tenginnerID, selectionID, 11, request_kind);
                    if (ret == false)
                    {
                        return false;
                    }
                }
            }
            else
            {
                ret = InsSelectionDateTbl(tenginnerID, selectionID, 11, request_kind);
                if (ret == false)
                {
                    return false;
                }
            }

            logger.Info(ComConst.INFO_LOG_END + sUserID + "選任日解任日設定の登録処理");

            return ret;

        }
        private int isSelection_personal(string engID,string scetionID,string region)
        {
            string sSql = string.Empty;
            bool bRet = false;
            DataTable dt = new DataTable();

            int ret = 1;

            //SELECT
            sSql = "SELECT  *   ";
            sSql = sSql + " FROM selection_personal_tbl  ";
            sSql = sSql + " WHERE enginnerID = '" + engID + "'";
            sSql = sSql + " AND selectionID= '" + scetionID + "'";
            sSql = sSql + " AND " + region + "!= '' ";

            //SQL文発行
            bRet = m_ComFunc.DB_Select(sSql, ref dt);
            if (bRet)
            {

                  if (dt.Rows.Count > 0)
                {
                    //SELECT
                    sSql = "SELECT  *   ";
                    sSql = sSql + " FROM selection_personal_tbl  ";
                    sSql = sSql + " WHERE enginnerID = '" + engID + "'";
                    sSql = sSql + " AND selectionID= '" + scetionID + "'";
                    sSql = sSql + " AND " + region + "= '' ";

                    //SQL文発行
                    bRet = m_ComFunc.DB_Select(sSql, ref dt);
                    if (bRet)
                    {
                        if (dt.Rows.Count > 0)
                        {
                            ret = 2; //解任として登録可

                        }
                        else
                        {
                            ret = 1; //選任として登録可
                        }
                    }
                }
                  else if (dt.Rows.Count == 0)
                  {
                      ret = 3; //解任として登録不可
                  }
                  else
                  {
                      ret = 1;
                  }
            }

            return ret;
        }
        ///<summary>
        //選任日解任日設定の登録
        ///</summary>
        private bool InsSelectionDateTbl(string penginnerID, string pselectionID, int pregion, int psr_flag)
        {

            string sSql = string.Empty;
            bool ret = false;

            try
            {
                //トランザクションの開始
                m_ComFunc.DB_BeginTranzaction();

                //登録
                sSql = "INSERT INTO selection_date_tbl(";
                sSql = sSql + "enginnerID";                 //従事者ID
                sSql = sSql + ", selectionID";              //選任部門ID
                sSql = sSql + ", request_date";             //申請日
                sSql = sSql + ", area_code";                //地域
                sSql = sSql + ", sr_flag";                  //選任/解任フラグ
                sSql = sSql + ") VALUES (";
                sSql = sSql + "'" + penginnerID + "'";      //従事者ID
                sSql = sSql + ", '" + pselectionID + "'";   //選任部門ID
                sSql = sSql + ", getdate()";                //申請日
                sSql = sSql + ", '" + pregion + "'";        //地域
                sSql = sSql + ", '" + psr_flag + "'";       //選任/解任フラグ
                sSql = sSql + ")";

                ret = m_ComFunc.DB_Execute(sSql);

                if (ret)
                {
                    ret = true;
                }
                else
                {
                    ret = false;
                }

            }
            catch (Exception ex)
            {
                lblErrMsg.Text = ex.Message;
            }

            return ret;
        }

        ///<summary>
        ///全選択
        ///</summary>
        protected void cboxAll_Click(object sender, EventArgs e)
        {
            //dispworkerinfo(true);
            for (int i = 0; i < GridView1.Rows.Count; i++)
            {
                System.Web.UI.WebControls.CheckBox chk =
                    (System.Web.UI.WebControls.CheckBox)GridView1.Rows[i].Cells[0].FindControl("chkbox");
                chk.Checked = true;
            }
        }

        ///<summary>
        ///全削除
        ///</summary>
        protected void UncboxAll_Click(object sender, EventArgs e)
        {
            //dispworkerinfo(true);
            for (int i = 0; i < GridView1.Rows.Count; i++)
            {
                System.Web.UI.WebControls.CheckBox chk =
                    (System.Web.UI.WebControls.CheckBox)GridView1.Rows[i].Cells[0].FindControl("chkbox");
                chk.Checked = false;
            }
        }

       ///<summary>
        ///s再取込
        ///</summary>
        protected void reRead_Click(object sender, EventArgs e)
        {
            UserRole user = Session[ComConst.SESSION_USER_ROLE] as UserRole;
            sUserID = user.UserId;

            logger.Info(ComConst.INFO_LOG_START + sUserID + "再取込ボタン押下処理");

            //初期化
            List<Rdselect_info> arL = (List<Rdselect_info>)Session["rdselect_infoL"];
            string sSql = string.Empty;

            //セッションから情報を取得
            m_ComFunc = (ComFunc)Session[ComConst.COM_FUNC];

            int reread_cnt = 0;
            //再読込処理
            for (int i = 0; i < GridView1.Rows.Count; i++)
            {
                System.Web.UI.WebControls.CheckBox chk =
                    (System.Web.UI.WebControls.CheckBox)GridView1.Rows[i].Cells[0].FindControl("chkbox");
                if (chk.Checked)
                {
                    bool ret = false, bFg = false;
                    //NumberSeqの取得
                    int num = this.m_ComFunc.geNumberSeq();
                    if (num > 1)
                    {
                        foreach (Rdselect_info emInfo in arL)
                        {

                            //免許番号
                            GridViewRow gvr = GridView1.Rows[i];
                            string glicense_num = gvr.Cells[4].Text; 
                            //氏名（姓）
                            string gLastname = gvr.Cells[2].Text; 
                            ////氏名を分解する。
                            //string[] name = null;
                            //string nameBefore = gname.Replace(" ", "/");
                            //name = nameBefore.Split('/');
                            //氏名（名）
                            string gFirstname = gvr.Cells[3].Text; 


                            //免許番号が同一であるか
                            if (glicense_num.Equals(emInfo.license_number))
                            {
                                if (gLastname.Equals(emInfo.LastName))
                                {
                                    if (gFirstname.Equals(emInfo.FirstName))
                                    {

                                        num++;

                                        //再取り込みする。
                                        //トランザクションの開始
                                        m_ComFunc.DB_BeginTranzaction();

                                        //insert
                                        //従事者情報の登録する。
                                        sSql = "INSERT INTO radio_enginner_info_tbl(";
                                        sSql = sSql + "license_number";
                                        sSql = sSql + ", LastName";
                                        sSql = sSql + ", FirstName";
                                        sSql = sSql + ", birthday";
                                        sSql = sSql + ", enginnerID";
                                        sSql = sSql + ", LastName_Kana";
                                        sSql = sSql + ", FirstName_Kana";
                                        sSql = sSql + ", license_type";
                                        sSql = sSql + ", getlicense_date";
                                        sSql = sSql + ", zip_code";
                                        sSql = sSql + ", prefectures";
                                        sSql = sSql + ", city";
                                        sSql = sSql + ", address";
                                        sSql = sSql + ", business_backgrand";
                                        sSql = sSql + ", createdate";
                                        sSql = sSql + ", create_name";
                                        sSql = sSql + ", updatedate";
                                        sSql = sSql + ", update_name";
                                        sSql = sSql + ") VALUES (";
                                        sSql = sSql + "'" + emInfo.license_number + "'";
                                        sSql = sSql + ", '" + emInfo.LastName + "'";
                                        sSql = sSql + ", '" + emInfo.FirstName + "'";
                                        sSql = sSql + ", '" + null + "'";
                                        sSql = sSql + ", '" + Convert.ToString(num) + "'";
                                        sSql = sSql + ", '" + emInfo.LastName_Kana + "'";
                                        sSql = sSql + ", '" + emInfo.FirstName_Kana + "'";
                                        sSql = sSql + ", '" + emInfo.license_type + "'";
                                        sSql = sSql + ", '" + emInfo.getlicense_date + "'";
                                        sSql = sSql + ", '" + null + "'";
                                        sSql = sSql + ", '" + null + "'";
                                        sSql = sSql + ", '" + null + "'";
                                        sSql = sSql + ", '" + null + "'";
                                        sSql = sSql + ", '" + null + "'";
                                        sSql = sSql + ", getdate()";
                                        sSql = sSql + ", '" + sUserID + "'";
                                        sSql = sSql + ", getdate()";
                                        sSql = sSql + ", '" + sUserID + "'";
                                        sSql = sSql + ")";

                                        string msg = "";
                                        ret = m_ComFunc.DB_ExecuteforErrMsg(sSql, ref msg);


                                        if (ret)
                                        {
                                            //選任・解任 個別情報の登録
                                            ret = Ins_selection_personla(emInfo, num,num.ToString(),ref msg);
                                            if (ret)
                                            {
                                                m_ComFunc.DB_Commit();
                                                reread_cnt++;
                                                //NumberSeqの更新
                                                bFg = m_ComFunc.setNumberSeq(num);
                                                if (bFg == false)
                                                {
                                                    m_ComFunc.DB_Rollback();
                                                }
                                            }
                                            else
                                            {
                                                m_ComFunc.DB_Rollback();
                                            }
                                        }
                                        else
                                        {
                                            m_ComFunc.DB_Rollback();
                                        }

                                    }

                                }
                            } ////免許番号が同一であるか
                            
                        } //foreach

                    } //.Checked
                } //fro文
                lblErrMsg.Text = reread_cnt + "件、再登録が成功しました。";
            } //num>1
            
            //GridView更新
            System.Data.DataTable dt = (System.Data.DataTable)Session["warnDt"];

            for (int i = 0; i < GridView1.Rows.Count; i++)
            {
                System.Web.UI.WebControls.CheckBox chk =
                    (System.Web.UI.WebControls.CheckBox)GridView1.Rows[i].Cells[0].FindControl("chkbox");
                if (chk.Checked)
                {
                    DataRow[] dr = dt.Select("license_number = '" + GridView1.Rows[i].Cells[4].Text + "'");
                    if (dr.Length > 0)
                    {
                        dt.Rows.Remove(dr[0]);
                        dt.AcceptChanges();
                    }
                }
            }
            GridView1.DataSource = dt;
            GridView1.DataBind();

            if (GridView1.Rows.Count == 0)
            {
                reRead.Visible = false;
                rcdRemove.Visible = false;
                T1000.Visible = false;
                cboxAll.Visible = false;
                UncboxAll.Visible = false;

                T101.Visible = false;


            }
            logger.Info(ComConst.INFO_LOG_END + sUserID + "再取込ボタン押下処理");


        }
        //Grid削除
        protected void rcdRemove_Click(object sender, EventArgs e)
        {

            logger.Info(ComConst.INFO_LOG_START + sUserID + "削除ボタン押下処理");

            System.Data.DataTable dt = (System.Data.DataTable)Session["warnDt"];


            for (int i = 0; i < GridView1.Rows.Count; i++)
            {
                System.Web.UI.WebControls.CheckBox chk = 
                    (System.Web.UI.WebControls.CheckBox)GridView1.Rows[i].Cells[0].FindControl("chkbox");
                if (chk.Checked)
                {
                    DataRow[] dr = dt.Select("name = '" + GridView1.Rows[i].Cells[2].Text + "'");
                    if (dr.Length > 0)
                    {
                        dt.Rows.Remove(dr[0]);
                        dt.AcceptChanges();
                    }
                }
            }
            GridView1.DataSource = dt;
            GridView1.DataBind();
            logger.Info(ComConst.INFO_LOG_END + sUserID + "削除ボタン押下処理");


        }

        protected void GridView1_PageIndexChanging(object sender, GridViewPageEventArgs e)
        {
            GridView1.PageIndex = e.NewPageIndex;
            GridView1.DataSource = Session["warnDt"];
            GridView1.DataBind();
        }

        protected void GridView2_PageIndexChanging(object sender, GridViewPageEventArgs e)
        {
            GridView2.PageIndex = e.NewPageIndex;
            GridView2.DataSource = Session["err_infoL"];
            GridView2.DataBind();

        }

        protected void BumonList_SelectedIndexChanged(object sender, EventArgs e)
        {
            //logger.Info(ComConst.INFO_LOG_START + sUserID + "社内管理部門取得処理");

            ////入力項目確認して、重複かチェック
            ////
            //UserRole userRole = Session[ComConst.SESSION_USER_ROLE] as UserRole;
            //if (userRole.Roles.Contains(ComConst.SYSTEM_OPERATE_USER))
            //{
            //    //部門ID
            //    sDeptid = m_ComFunc.getBumonIdonSystem(BumonList.SelectedIndex, Session[ComConst.SESSION_BUMON_MASTER] as Dictionary<string, string>);

            //}


            //enginnerID_key = (string)Session["enginnerID_key"];

            ////重複チェック
            //if (chkSenninKaininInfo(enginnerID_key, sDeptid))
            //{
            //    //重複データが存在している場合、
            //    confrimCHK();
            //    diSpselection_personal_tbl(enginnerID_key, sDeptid);

            //}
            //logger.Info(ComConst.INFO_LOG_END + sUserID + "社内管理部門取得処理");

        }

    }
}