﻿using System;
using System.Collections.Generic;
using EmpCRM.common;
using EmpCRM.Dto;
using System.Linq;

namespace EmpCRM
{
    public partial class EmployeeEdit : System.Web.UI.Page
    {
       //共通機能
        private  ComFunc m_ComFunc = new ComFunc();
       //ロガー生成
       private static log4net.ILog logger = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
       private string sUserID = "";
 
        protected void Page_Load(object sender, EventArgs e)
        {
            //セッションから共通関数クラスのインスタンスを取得
            m_ComFunc = (ComFunc)Session[ComConst.COM_FUNC];

            //初期画面の場合、
            if (!(this.IsPostBack))
            {
                //セッションにユーザIDを設定
                UserRole userRole = Session[ComConst.SESSION_USER_ROLE] as UserRole;
                //セッション情報がない場合
                if (!LoginUtil.IsLogin(userRole))
                {
                    Response.Redirect("error.htm", false);
                }
                else
                {
                    //システム部門の場合、
                    if (userRole.Roles.Contains(ComConst.SYSTEM_OPERATE_USER))
                    {
                        //更新ボタンの活性化
                        edit.Visible = true;
                    }
                    //その他
                    else if (userRole.Roles.Contains(ComConst.REQUEST_USER))
                    {
                        //更新ボタンの非表示
                        edit.Visible = false;

                    }
                    else if (userRole.Roles.Contains(ComConst.APPROVAL_USER))
                    {
                        //更新ボタンの非表示
                        edit.Visible = false;

                    }

                }
               

                sUserID = userRole.UserId;

            }
            else
            {
                //従事者情報検索結果よりセッション情報の設定
                if ((Session["FromResult"] != null))
                {
                    //免許番号
                    licenseno.Text = (string)Session[ComConst.LICENSE_NUM];
                    //免許取得日
                    licensedate.Text = (string)Session[ComConst.LICENSE_DATE];
                    //氏名（姓）
                    lastname.Text = (string)Session[ComConst.LASTNAME];
                    //氏名（名）
                    firstname.Text = (string)Session[ComConst.FIRSTNAME];
                    //氏名（姓）ふりがな
                    furi_familyname.Text = (string)Session[ComConst.LASTNAME_KANA];
                    //氏名（名）ふりがな
                    furi_firstname.Text = (string)Session[ComConst.FIRSTNAME_KANA];
                    //セッション情報
                    Session["FromResult"] = null;
                    //エラーメッセージ初期化
                    lblErrMsg.Text = "";
                }

            }
                
        }
        ///<summary>
        ///セッション情報の初期化
        ///</summary>       
        protected void modoru_Click(object sender, EventArgs e)
        {
            Session[ComConst.LICENSE_NUM] = null;
            Session[ComConst.LICENSE_DATE] = null;
            Session[ComConst.LASTNAME] = null;
            Session[ComConst.FIRSTNAME] = null;
            Session[ComConst.FIRSTNAME_KANA] = null;
            Session[ComConst.LASTNAME_KANA] = null;

            Response.Redirect("Mainmenu.aspx", false);
        }
        ///<summary>
        ///コンポーネント初期化
        ///</summary>       
        protected void clear_Click(object sender, EventArgs e)
        {
            licenseno.Text = string.Empty;
            licensedate.Text = string.Empty;
            lastname.Text = string.Empty;
            firstname.Text = string.Empty;
            furi_familyname.Text = string.Empty;
            furi_firstname.Text = string.Empty;

            lblErrMsg.Text = "";
        }
        //従事者情報の更新する。
        protected void edit_Click(object sender, EventArgs e)
        {
            string sSql = string.Empty;
            bool ret = true, bRet=false; 
            UserRole user = Session[ComConst.SESSION_USER_ROLE] as UserRole;
            sUserID = user.UserId;


            try
            {
                logger.Info(ComConst.INFO_LOG_START + sUserID + "従事者情報の更新ボタン押下処理");
                //現在日
                string dtToday = DateTime.Now.ToString("yyyy/MM/dd");



                //トランザクションの開始
                m_ComFunc.DB_BeginTranzaction();
                //Update
                sSql = "DELETE FROM  radio_enginner_info_tbl ";
                sSql = sSql + "  WHERE license_number = '" + Session[ComConst.LICENSE_NUM] + "'";
                sSql = sSql + "  AND LastName = '" + Session[ComConst.LASTNAME] + "'";
                sSql = sSql + "  AND FirstName = '" + Session[ComConst.FIRSTNAME] + "'";
                
                ret = m_ComFunc.DB_Execute(sSql);
                if (ret)
                {
                    List<string> errList = new List<string>();
                    // 無線従事者情報登録
                    bRet = Ins_radio_enginner_info_tbl(
                                                    licenseno.Text,
                                                    licensedate.Text,
                                                    lastname.Text,
                                                    firstname.Text,
                                                    furi_familyname.Text,
                                                    furi_firstname.Text,
                                                    ref errList);
                    if (!(bRet))
                    {
                        if (errList.Count > 0)
                        {
                            m_ComFunc.DB_Commit();
                            lblErrMsg.Text = "テーブルに更新に失敗しました" + " (" + errList[2].ToString() + ")";

                        }
                        else
                        {

                            m_ComFunc.DB_Rollback();
                            lblErrMsg.Text = "テーブルに更新に失敗しました";
                        }
                    }
                    else
                    {
                        //入力項目クリア
                        ControlClear();

                        lblErrMsg.Text = "データ登録が成功しました。";
                    }


                }
                else
                {
                    m_ComFunc.DB_Rollback();
                    lblErrMsg.Text = "テーブルに更新に失敗しました";
                }







                logger.Info(ComConst.INFO_LOG_END + sUserID + "従事者情報の更新ボタン押下処理");

            }
            catch (Exception ex)
            {
                lblErrMsg.Text = ex.Message;
                logger.Error("User:" + sUserID + ex.Message, ex);
            }
        }
        ///<summary>
        //従事者情報の登録する。
        ///</summary>
        protected void add_Click(object sender, EventArgs e)
        {
            bool bRet = false;

            try 
            {
                logger.Info(ComConst.INFO_LOG_START + sUserID + "登録ボタン押下処理");

                List<string> errList = new List<string>();

                // 無線従事者情報登録
                bRet = Ins_radio_enginner_info_tbl(
                                                licenseno.Text,
                                                licensedate.Text,
                                                lastname.Text,
                                                firstname.Text,
                                                furi_familyname.Text,
                                                furi_firstname.Text,
                                                ref errList);
                if (!(bRet))
                {
                    if (errList.Count > 0)
                    {
                        lblErrMsg.Text = "テーブルに登録に失敗しました" + " (" + errList[2].ToString() + ")";

                    }
                    else
                    {

                        lblErrMsg.Text = "テーブルに登録に失敗しました";
                    }
                }else{
                    //入力項目クリア
                    ControlClear();

                    lblErrMsg.Text = "データ登録が成功しました。";
                }
                logger.Info(ComConst.INFO_LOG_END + sUserID + "登録ボタン押下処理");

            
            }
            catch(Exception ex) 
            {
                lblErrMsg.Text = ex.Message;
                logger.Error("User:" + sUserID + ex.Message, ex);

            }
        }
        ///<summary>
        //無線従事者情報のテーブル登録処理
        ///</summary>
        ///<remarks>
        ///This is a test.
        ///</remarks>
        private bool Ins_radio_enginner_info_tbl(string plicenseno,
                                            string plicensedate,
                                            string plastname,
                                            string pfirstname,
                                            string pfuri_familyname, 
                                            string pfuri_firstname,
            ref List<string> errList)
        {
            UserRole user = Session[ComConst.SESSION_USER_ROLE] as UserRole;
            sUserID = user.UserId;
            logger.Info(ComConst.INFO_LOG_START + sUserID + "無線従事者情報のテーブル登録処理");

            string sSql = string.Empty;
            bool ret = false;
            bool ret1 = true;
            //List<string> errList = new List<string>();

            try
            {
                lblErrMsg.Text = "";
                //必須入力チェック
                //免許番号
                m_ComFunc.mandatoryCHK(plicenseno, 1, ref errList);
                if (errList.Count > 0)
                {
                    lblErrMsg.Text = errList[2].ToString();
                    throw new Exception();
                }
                //免許取得日(年月日)
                m_ComFunc.mandatoryCHK(plicensedate, 2, ref errList);
                if (errList.Count > 0)
                {
                    lblErrMsg.Text = errList[2].ToString();
                    throw new Exception();
                }
                //氏名（姓）
                m_ComFunc.mandatoryCHK(plastname, 3, ref errList);
                if (errList.Count > 0)
                {
                    lblErrMsg.Text = errList[2].ToString();
                    throw new Exception();
                }
                //氏名（名）
                m_ComFunc.mandatoryCHK(pfirstname, 4, ref errList);
                if (errList.Count > 0)
                {
                    lblErrMsg.Text = errList[2].ToString();
                    throw new Exception();
                }
                //氏名フリガナ（姓）
                m_ComFunc.mandatoryCHK(pfuri_familyname, 5, ref errList);
                if (errList.Count > 0)
                {
                    lblErrMsg.Text = errList[2].ToString();
                    throw new Exception();
                }

                //氏名フリガナ（姓）
                m_ComFunc.mandatoryCHK(pfuri_firstname, 6, ref errList);
                if (errList.Count > 0)
                {
                    lblErrMsg.Text = errList[2].ToString();
                    throw new Exception();
                }
                //形式チェック
                m_ComFunc.formatCHK(plicenseno, ref errList);
                if (errList.Count > 0)
                {
                    lblErrMsg.Text = errList[2].ToString();
                    throw new Exception();
                }

                //従事者情報DBに免許番号が同じで、氏名が違うデータの存在チェック
                m_ComFunc.IsExistRadioMenKey(plicenseno, plastname, pfirstname, ref errList);
                if (errList.Count > 0)
                {
                    lblErrMsg.Text = errList[2].ToString();
                    throw new Exception();
                }

                //従事者情報DBに3項目が同じデータが存在しているかチェックする
                m_ComFunc.isMultiLicnse_num(plicenseno, plastname, pfirstname, ref errList);
                if (errList.Count > 0)
                {
                    lblErrMsg.Text = errList[2].ToString();
                    throw new Exception();
                }


                //トランザクションの開始
                m_ComFunc.DB_BeginTranzaction();

                //TODO 入力チェック
                if ((plicenseno == "") || (plastname == "") || (pfirstname == "") || (pfuri_familyname == "") || (pfuri_firstname ==""))
                {
                    throw new Exception("未入力項目は存在しています。");
                }
                //NumberSeqの取得
                int num = this.m_ComFunc.geNumberSeq();

                if (num > 0)
                {
                    num++;

                    sSql = "INSERT INTO radio_enginner_info_tbl(";
                    sSql = sSql + "license_number";
                    sSql = sSql + ", LastName";
                    sSql = sSql + ", FirstName";
                    sSql = sSql + ", birthday";
                    sSql = sSql + ", enginnerID";
                    sSql = sSql + ", LastName_Kana";
                    sSql = sSql + ", FirstName_Kana";
                    sSql = sSql + ", license_type";
                    sSql = sSql + ", getlicense_date";
                    sSql = sSql + ", zip_code";
                    sSql = sSql + ", prefectures";
                    sSql = sSql + ", city";
                    sSql = sSql + ", address";
                    sSql = sSql + ", business_backgrand";
                    sSql = sSql + ", createdate";
                    sSql = sSql + ", create_name";
                    sSql = sSql + ", updatedate";
                    sSql = sSql + ", update_name";
                    sSql = sSql + ") VALUES (";
                    sSql = sSql + "'" + plicenseno + "'";
                    sSql = sSql + ", '" + plastname + "'";
                    sSql = sSql + ", '" + pfirstname + "'";
                    sSql = sSql + ", '" + null + "'";
                    sSql = sSql + ", '" + Convert.ToString(num) + "'";         //従事者ID
                    sSql = sSql + ", '" + pfuri_familyname + "'";
                    sSql = sSql + ", '" + pfuri_firstname + "'";
                    sSql = sSql + ", '" + null + "'";
                    sSql = sSql + ", '" + plicensedate + "'";
                    sSql = sSql + ", '" + null + "'";
                    sSql = sSql + ", '" + null + "'";
                    sSql = sSql + ", '" + null + "'";
                    sSql = sSql + ", '" + null + "'";
                    sSql = sSql + ", '" + null + "'";
                    sSql = sSql + ", getdate()";
                    sSql = sSql + ", '" + sUserID + "'";
                    sSql = sSql + ", getdate()";
                    sSql = sSql + ", '" + sUserID + "'";
                    sSql = sSql + ")";

                    ret = m_ComFunc.DB_Execute(sSql);


                    if (ret)
                    {
                        m_ComFunc.DB_Commit();
                        //NumberSeqの更新
                        bool bFg = m_ComFunc.setNumberSeq(num);
                        if (bFg == false)
                        {
                            m_ComFunc.DB_Rollback();
                        }

                        ret1 = true;
                    }
                    else
                    {
                        m_ComFunc.DB_Rollback();
                        ret1 = false;
                    }
                }
                logger.Info(ComConst.INFO_LOG_END + sUserID + "無線従事者情報のテーブル登録処理");

            }
            catch (Exception ex)
            {
                //lblErrMsg.Text = ex.Message;
                logger.Error("User:" + sUserID + ex.Message, ex);

                ret1 = false;
            }
        

            return ret1;
                
        }
        //入力項目をすべてクリア
        private void ControlClear() {
            licenseno.Text = string.Empty;
            licensedate.Text = string.Empty;
            lastname.Text = string.Empty;
            firstname.Text = string.Empty;
            furi_familyname.Text = string.Empty;
            furi_firstname.Text = string.Empty;

        }
        ///<summary>
        //j作用者IDの取得処理
        ///</summary>
        ///<remarks>
        ///This is a test.
        ///</remarks>
        private string getEngineerId(string plicensenum)
        {
            bool ret;
            string sSql = string.Empty;
            System.Data.DataTable dt = new System.Data.DataTable();
            try
            {
                //トランザクションの開始
                m_ComFunc.DB_BeginTranzaction();

                sSql = "SELECT enginnerID  FROM radio_enginner_info_tbl ";
                sSql = sSql + " WHERE  license_number ='" + plicensenum + "'";

                string msg = "";
                ret = m_ComFunc.DB_Select(sSql, ref dt);

                if (ret == false)
                {
                    ret = false;
                }

            }
            catch
            {
                ret = false;
            }

            return dt.Rows[0][0].ToString();
        }



    }
}