﻿using log4net;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web.UI;
using System.Web.UI.WebControls;
using EmpCRM.common;
using EmpCRM.Dto;

namespace EmpCRM
{
    public partial class EmployeeEditPosi : System.Web.UI.Page
    {
        //共通機能
        private ComFunc m_ComFunc;
        //従事者情報
        private List<radio_enginner_info> rd_enginner_infoL = new List<radio_enginner_info>();
        //作業者ID
        private string enginnerID_key;
        //ページ番号
        private string gPage_num = "1";
        private static log4net.ILog logger = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
        // ユーザID
        private string sUserID = "";
        //部門ID
        private string sDeptid = "";
//        private UserRole userRole = null;

        ///<summary>
        ///ページロードする。
        ///</summary>
        protected void Page_Load(object sender, EventArgs e)
        {

             //セッションから共通関数クラスのインスタンスを取得
            m_ComFunc = (ComFunc)Session[ComConst.COM_FUNC];
            bool ret = false;

            //初期画面の場合、
            if(!(IsPostBack))
            {
                ccDeepartmentSelector.InitializeControls();
                //セッションにユーザIDを設定
                UserRole  userRole = Session[ComConst.SESSION_USER_ROLE] as UserRole;
                //ユーザ情報の取得が失敗したら、エラー画面に遷移する。
                if (!LoginUtil.IsLogin(userRole))
                {
                    Response.Redirect("error.htm", false);
                }
                else
                {
                    //システム部門の場合、
                    if (userRole.Roles.Contains(ComConst.SYSTEM_OPERATE_USER))
                    {
                        Bu1.Visible = false;
                        Bu2.Visible = true;
                        //部門マスタ取得
//                        m_ComFunc.bumoMasterList(BumonList, Session[ComConst.SESSION_BUMON_MASTER] as Dictionary<string, string>, true);


                        Dictionary<string, string> dt = (Dictionary<string, string>)Session[ComConst.SESSION_BUMON_MASTER] as Dictionary<string, string>;
                        //部門ID
                        //sDeptid = m_ComFunc.getBumonIdonSystem(BumonList.SelectedIndex, Session[ComConst.SESSION_BUMON_MASTER] as Dictionary<string, string>);
                        sDeptid = ccDeepartmentSelector.GetSelectedValue();


                    }
                    //その他
                    else if (userRole.Roles.Contains(ComConst.REQUEST_USER))
                    {
                        Bu1.Visible = true;
                        Bu2.Visible = false;
                        //部門ID
                        sDeptid = userRole.DepartmentId;
                    }
                    else if (userRole.Roles.Contains(ComConst.APPROVAL_USER))
                    {
                        Bu1.Visible = true;
                        Bu2.Visible = false;
                        //部門ID
                        sDeptid = userRole.DepartmentId;

                    }

                }
               

                //ユーザID
                sUserID = userRole.UserId;
                //部門ID
                string gPageSize = Request.QueryString["PageSize"];


                //社内管理部門
                belong_department.Text = userRole.DepartmentName.ToString();

                //従事者情報を表示
                string sel = Request.QueryString["sel"].ToString();
                int glPage_num = 0;
                //従事者情報が選択されたのか判定する。
                if (sel != "")
                {
                    int selitemidx = Int32.Parse(sel.ToString());
                    gPage_num = (string)Session["gPage_num"];

                    if (gPage_num == null) gPage_num = "1";
                    if (Int32.Parse(gPage_num) >= 2)
                    {
                        glPage_num = (Int32.Parse(gPage_num) - 1) * Int32.Parse(gPageSize);
                    }
                    selitemidx = selitemidx + glPage_num;

                    rd_enginner_infoL = (List<radio_enginner_info>)Session[ComConst.rd_enginner_infoL];


                    for (int iIndex = 0; iIndex < rd_enginner_infoL.Count(); iIndex++)
                    {
                        if (selitemidx == iIndex)
                        {
                            //免許番号
                            licenseno.Text = rd_enginner_infoL[iIndex].license_number.ToString();
                            //性
                            lastname.Text = rd_enginner_infoL[iIndex].LastName.ToString();
                            //名
                            firstname.Text = rd_enginner_infoL[iIndex].FirstName.ToString();
                            //性（ふりがな）
                            furi_familyname.Text = rd_enginner_infoL[iIndex].LastName_Kana.ToString();
                            //名（ふりがな）
                            furi_firstname.Text = rd_enginner_infoL[iIndex].FirstName_Kana.ToString();

                            //選任・解任 個別情報の検索、表示する。
                            //JMCIA設定
                            m_ComFunc.jmiciaList(jmicia, false);
                            //sbwcp設定
                            m_ComFunc.sbwcpList(sbwcp, true);
                            //所属会社（施工会社）
                            m_ComFunc.companyList(company, true);
                            //所属部署（施工会社）
                            m_ComFunc.departmentList(department, true);

                            //検索キー
                            enginnerID_key = rd_enginner_infoL[iIndex].enginnerID.ToString();
                            //選任解任情報の重複チェック
                            //ret = chkSenninKaininInfo(enginnerID_key, sDeptid);
                            //if (ret)
                            //{
                            //    //重複データが存在している場合、
                            //    confrimCHK();
                            //    //初期値設定
                            //    diSpselection_personal_tbl(enginnerID_key, sDeptid);
                            //}
                            //else
                            //{
                            //    //新規登録
                            //    IsInsOK.Value = "3";

                            //}

                            //種別
                            Session["enginnerID_key"] = enginnerID_key;
                            break;

                        }
                    }
                }
                else
                {
                    lblErrMsg.Text = "従事者情報を選択してください。";
 
                }

            }
        }
        ///<summary>
        ///選任/解任情報の取得する。
        ///</summary>
        private void diSpselection_personal_tbl(string pengineerid,string sectionid)
        {

            string sSql = string.Empty;
            bool bRet = false;
            System.Data.DataTable dataTable = null;
            UserRole userRole = Session[ComConst.SESSION_USER_ROLE] as UserRole;

            try
            {
                logger.Info(ComConst.INFO_LOG_START + sUserID + "選任/解任情報の取得処理");

                //共通セッションの取得
                m_ComFunc = (ComFunc)Session[ComConst.COM_FUNC];
                //現在日取得
                string dtToday = DateTime.Now.ToString("yyyy/MM/dd");
                //SQL文作成
                sSql = "SELECT enginnerID,selectionID,request_date,request_div,belong_company,belong_department,";
                sSql = sSql + " jmcia_flag,sb_wcp,hokkaidou,touhoku,hokuriku,shinetsu,kantou,tokai,kinki,shikoku,";
                sSql = sSql + " chugoku,kyuushu,okinawa,apploval_flag,delete_flag,create_date,create_name,update_date,update_name";
                sSql = sSql + "  FROM selection_personal_tbl ";
                sSql = sSql + "  WHERE enginnerID = '" + pengineerid + "'";
                sSql = sSql + "  AND selectionID = '" + sectionid + "'";
                sSql = sSql + "  AND request_date = '" + dtToday + "'";
                sSql = sSql + "  AND delete_flag = '0'";

                //SQL文発行
                bRet = m_ComFunc.DB_Select(sSql, ref dataTable);
                if (bRet == false)
                {
                    lblErrMsg.Text = "検索できませんでした。";
                }

                ////社内管理部門
                ////システム部門の場合、
                //int idx = 0;
                //if (userRole.Roles.Contains(ComConst.SYSTEM_OPERATE_USER))
                //{

                //    //idx = 0;
                //    //foreach (ListItem item in ccDeepartmentSelector.Items)
                //    //{
                //    //    if (item.Value == dataTable.Rows[0]["selectionID"].ToString())
                //    //    {
                //    //        BumonList.SelectedIndex = idx;
                //    //        break;
                //    //    }
                //    //    idx++;
                //    //}

                //}



                //所属会社設定
                int idx = 0;
               foreach (ListItem item in company.Items)
               {
                   if (item.Value == dataTable.Rows[0]["belong_company"].ToString())
                   {
                       company.SelectedIndex = idx;
                       break;
                   }
                   idx++;
               }
                //部門設定
               idx = 0;
               foreach (ListItem item in department.Items)
               {
                   if (item.Value == dataTable.Rows[0]["belong_department"].ToString())
                   {
                       department.SelectedIndex = idx;
                       break;
                   }
                   idx++;
               }
               //JMCIA設定
               //idx = 0;
               //foreach (ListItem item in jmicia.Items)
               //{
               //    if (Convert.ToString(idx) == dataTable.Rows[0]["jmcia_flag"].ToString())
               //    {
               //        jmicia.SelectedIndex = idx + 1;
               //        break;
               //    }
               //    idx++;
               //}
               if (dataTable.Rows[0]["jmcia_flag"].ToString() == "0")
               {
                   jmicia.SelectedIndex = 0;
               }
               else if (dataTable.Rows[0]["jmcia_flag"].ToString() == "1")
               {
                   jmicia.SelectedIndex = 1;
 
               }

               //sb_wcp設定
               idx = 0;
               foreach (ListItem item in sbwcp.Items)
               {
                   if (Convert.ToString(idx) == dataTable.Rows[0]["sb_wcp"].ToString())
                   {
                       sbwcp.SelectedIndex = idx;
                       break;
                   }
                   idx++;
               }
                //北海道
               string hokkaidou = dataTable.Rows[0]["hokkaidou"].ToString();
               setKind(hokkaidou,1);
               //東北
                string ptouhoku = dataTable.Rows[0]["touhoku"].ToString();
               setKind(ptouhoku, 2);
               //北陸
               string phokuriku = dataTable.Rows[0]["hokuriku"].ToString();
               setKind(phokuriku, 3);
               //信越
               string pshinetsu = dataTable.Rows[0]["shinetsu"].ToString();
               setKind(pshinetsu, 4);
               //関東
               string kpantou = dataTable.Rows[0]["kantou"].ToString();
               setKind(kpantou, 5);
               //東海
               string ptokai = dataTable.Rows[0]["tokai"].ToString();
               setKind(ptokai, 6);
               //近畿
               string pkinki = dataTable.Rows[0]["kinki"].ToString();
               setKind(pkinki, 7);
               //四国
               string pshikoku = dataTable.Rows[0]["shikoku"].ToString();
               setKind(pshikoku, 8);
               //中国
               string pchugoku = dataTable.Rows[0]["chugoku"].ToString();
               setKind(pchugoku, 9);
               //九州
               string pkyuushu = dataTable.Rows[0]["kyuushu"].ToString();
               setKind(pkyuushu, 10);
               //沖縄
               string pokinawa = dataTable.Rows[0]["okinawa"].ToString();
               setKind(pokinawa, 11);

               //セッション情報
                Session["SenninKainin_info"] = dataTable;

               logger.Info(ComConst.INFO_LOG_END + sUserID + "選任/解任情報の取得処理");

            }
            catch (Exception ex)
            {
                lblErrMsg.Text = ex.Message;
                logger.Error("User:" + sUserID + ex.Message, ex);

            }


        }
        //対象無線局種別設定
        private void setKind(string sKind,int pArea) 
        {
            string[] pKind = sKind.Split('/');

            foreach (string stData in pKind)
            {

                switch (pArea)
                {
                     case 1:
                            switch (stData)
                            {
                                case ComConst.EX:
                                    ex1.Checked = true;
                                    break;
                                case ComConst.FX:
                                    fx1.Checked = true;
                                    break;
                                case ComConst.FB:
                                    fb1.Checked = true;
                                    break;
                                case ComConst.FBR:
                                    fbr1.Checked = true;
                                    break;
                                case ComConst.ML:
                                    ml1.Checked = true;
                                    break;
                                default:
                                    break;
                            }
                         break;
                     case 2:
                            switch (stData)
                            {
                                case ComConst.EX:
                                    ex2.Checked = true;
                                    break;
                                case ComConst.FX:
                                    fx2.Checked = true;
                                    break;
                                case ComConst.FB:
                                    fb2.Checked = true;
                                    break;
                                case ComConst.FBR:
                                    fbr2.Checked = true;
                                    break;
                                case ComConst.ML:
                                    ml2.Checked = true;
                                    break;
                                default:
                                    break;
                            }
                            break;
                     case 3:
                            switch (stData)
                            {
                                case ComConst.EX:
                                    ex3.Checked = true;
                                    break;
                                case ComConst.FX:
                                    fx3.Checked = true;
                                    break;
                                case ComConst.FB:
                                    fb3.Checked = true;
                                    break;
                                case ComConst.FBR:
                                    fbr3.Checked = true;
                                    break;
                                case ComConst.ML:
                                    ml3.Checked = true;
                                    break;
                                default:
                                    break;
                            }
                            break;
                     case 4:
                            switch (stData)
                            {
                                case ComConst.EX:
                                    ex4.Checked = true;
                                    break;
                                case ComConst.FX:
                                    fx4.Checked = true;
                                    break;
                                case ComConst.FB:
                                    fb4.Checked = true;
                                    break;
                                case ComConst.FBR:
                                    fbr4.Checked = true;
                                    break;
                                case ComConst.ML:
                                    ml4.Checked = true;
                                    break;
                                default:
                                    break;
                            }
                            break;
                     case 5:
                            switch (stData)
                            {
                                case ComConst.EX:
                                    ex5.Checked = true;
                                    break;
                                case ComConst.FX:
                                    fx5.Checked = true;
                                    break;
                                case ComConst.FB:
                                    fb5.Checked = true;
                                    break;
                                case ComConst.FBR:
                                    fbr5.Checked = true;
                                    break;
                                case ComConst.ML:
                                    ml5.Checked = true;
                                    break;
                                default:
                                    break;
                            }
                            break;
                     case 6:
                            switch (stData)
                            {
                                case ComConst.EX:
                                    ex6.Checked = true;
                                    break;
                                case ComConst.FX:
                                    fx6.Checked = true;
                                    break;
                                case ComConst.FB:
                                    fb6.Checked = true;
                                    break;
                                case ComConst.FBR:
                                    fbr6.Checked = true;
                                    break;
                                case ComConst.ML:
                                    ml6.Checked = true;
                                    break;
                                default:
                                    break;
                            }
                            break;
                     case 7:
                            switch (stData)
                            {
                                case ComConst.EX:
                                    ex7.Checked = true;
                                    break;
                                case ComConst.FX:
                                    fx7.Checked = true;
                                    break;
                                case ComConst.FB:
                                    fb7.Checked = true;
                                    break;
                                case ComConst.FBR:
                                    fbr7.Checked = true;
                                    break;
                                case ComConst.ML:
                                    ml7.Checked = true;
                                    break;
                                default:
                                    break;
                            }
                            break;
                     case 8:
                            switch (stData)
                            {
                                case ComConst.EX:
                                    ex8.Checked = true;
                                    break;
                                case ComConst.FX:
                                    fx8.Checked = true;
                                    break;
                                case ComConst.FB:
                                    fb8.Checked = true;
                                    break;
                                case ComConst.FBR:
                                    fbr8.Checked = true;
                                    break;
                                case ComConst.ML:
                                    ml8.Checked = true;
                                    break;
                                default:
                                    break;
                            }
                            break;
                     case 9:
                            switch (stData)
                            {
                                case ComConst.EX:
                                    ex9.Checked = true;
                                    break;
                                case ComConst.FX:
                                    fx9.Checked = true;
                                    break;
                                case ComConst.FB:
                                    fb9.Checked = true;
                                    break;
                                case ComConst.FBR:
                                    fbr9.Checked = true;
                                    break;
                                case ComConst.ML:
                                    ml9.Checked = true;
                                    break;
                                default:
                                    break;
                            }
                            break;
                     case 10:
                            switch (stData)
                            {
                                case ComConst.EX:
                                    ex10.Checked = true;
                                    break;
                                case ComConst.FX:
                                    fx10.Checked = true;
                                    break;
                                case ComConst.FB:
                                    fb10.Checked = true;
                                    break;
                                case ComConst.FBR:
                                    fbr10.Checked = true;
                                    break;
                                case ComConst.ML:
                                    ml10.Checked = true;
                                    break;
                                default:
                                    break;
                            }
                            break;
                     case 11:
                            switch (stData)
                            {
                                case ComConst.EX:
                                    ex11.Checked = true;
                                    break;
                                case ComConst.FX:
                                    fx11.Checked = true;
                                    break;
                                case ComConst.FB:
                                    fb11.Checked = true;
                                    break;
                                case ComConst.FBR:
                                    fbr1.Checked = true;
                                    break;
                                case ComConst.ML:
                                    ml1.Checked = true;
                                    break;
                                default:
                                    break;
                            }
                            break;
                     default:
                            break;
                }



            }
        }

        //無線従事者情報のテーブル登録処理
        //選任日解任日設定テーブル登録処理
        //2017/1/27 nakamura
        public bool Ins_selection_personal_Selectioon_date()
        {
            logger.Info(ComConst.INFO_LOG_START + sUserID + "無線従事者情報のテーブル登録処理");
            

            string sSql = string.Empty;
            bool ret = false;
            bool ret1 = true;
            UserRole user = Session[ComConst.SESSION_USER_ROLE] as UserRole;
            sUserID = user.UserId;

            try
            {
                
                logger.Info(ComConst.INFO_LOG_START + sUserID + "従事者情報の登録処理");
                //ユーザ情報より
                UserRole userRole = Session[ComConst.SESSION_USER_ROLE] as UserRole;
                if (userRole.Roles.Contains(ComConst.SYSTEM_OPERATE_USER))
                {
                    //部門ID
                    //sDeptid = m_ComFunc.getBumonIdonSystem(BumonList.SelectedIndex, Session[ComConst.SESSION_BUMON_MASTER] as Dictionary<string, string>);
                    sDeptid = ccDeepartmentSelector.GetSelectedValue();

                }
                else
                {
                    sDeptid = userRole.DepartmentId.ToString();
                }


                enginnerID_key = (string)Session["enginnerID_key"];

               // string engID = (string)Session["enginnerID_key"];


                //トランザクションの開始
                m_ComFunc.DB_BeginTranzaction();


                //解任解任判定ですが、この処理区分の使用は使えない。
                string sRequest_div = getSenninKaininKubun(licenseno.Text, lastname.Text, firstname.Text);

                //登録
                sSql = "INSERT INTO selection_personal_tbl(";
                sSql = sSql + "enginnerID";             //従事者ID
                sSql = sSql + ", selectionID";          //選任部門ID
                sSql = sSql + ", request_date";         //申請日
                sSql = sSql + ", request_div";          //申請区分
                sSql = sSql + ", belong_company";       //所属会社（施工会社）   
                sSql = sSql + ", belong_department";    //所属部署（施工会社）
                sSql = sSql + ", jmcia_flag";           //JMCIA所属フラグ
                sSql = sSql + ", sb_wcp";               //SB/WCP区分
                sSql = sSql + ", hokkaidou";            //北海道（局種別）
                sSql = sSql + ", touhoku";              //東北（局種別）
                sSql = sSql + ", hokuriku";             //北陸（局種別
                sSql = sSql + ", shinetsu";             //信越（局種別）
                sSql = sSql + ", kantou";               //関東（局種別）
                sSql = sSql + ", tokai";                //東海（局種別）
                sSql = sSql + ", kinki";                //近畿（局種別）
                sSql = sSql + ", shikoku";              //四国（局種別）
                sSql = sSql + ", chugoku";             //中国（局種別）
                sSql = sSql + ", kyuushu";             //九州（局種別）
                sSql = sSql + ", okinawa";             //沖縄（局種別）
                sSql = sSql + ", apploval_flag";       //承認フラグ
                sSql = sSql + ", delete_flag";         //削除フラグ
                sSql = sSql + ", create_date";         //作成日
                sSql = sSql + ", create_name";         //作成者   
                sSql = sSql + ", update_date";         //更新日
                sSql = sSql + ", update_name";          //更新者
                sSql = sSql + ") VALUES (";
                sSql = sSql + "'" + enginnerID_key + "'";         //従事者ID
                sSql = sSql + ", '" + sDeptid + "'";       //選任部門ID
                sSql = sSql + ", getdate()";        //申請日
                sSql = sSql + ", '" + sRequest_div + "'";               //申請区分
                sSql = sSql + ", '" + company.Text + "'";               //所属会社（施工会社）
                sSql = sSql + ", '" + department.Text + "'";             //所属部署（施工会社）
                sSql = sSql + ", '" + jmicia.SelectedIndex + "'";  //JMCIA所属フラグ
                sSql = sSql + ", '" + sbwcp.SelectedIndex + "'";     //SB/WCP区分
                sSql = sSql + ", '" + gethokkaidou() + "'"; ;       　//北海道（局種別）
                sSql = sSql + ", '" + gettouhoku() + "'"; ;          //東北（局種別）
                sSql = sSql + ", '" + gethokuriku() + "'"; ;        //北陸（局種別）
                sSql = sSql + ", '" + getshinetsu() + "'"; ;       //信越（局種別）
                sSql = sSql + ", '" + getkantou() + "'"; ;          //関東（局種別）
                sSql = sSql + ", '" + gettokai() + "'"; ;           //東海（局種別）
                sSql = sSql + ", '" + getkinki() + "'"; ;           //近畿（局種別）
                sSql = sSql + ", '" + getshikoku() + "'"; ;         //四国（局種別）
                sSql = sSql + ", '" + getchugoku() + "'"; ;         //中国（局種別）
                sSql = sSql + ", '" + getkyuushu() + "'"; ;         //九州（局種別）
                sSql = sSql + ", '" + getokinawa() + "'"; ;         //沖縄（局種別）
                sSql = sSql + ",'" + 0 + "'";       //承認フラグ　
                sSql = sSql + ",'" + 0 + "'";       //削除フラグ
                sSql = sSql + ", getdate()";           //作成日
                sSql = sSql + ", '" + sUserID + "'";       //作成者
                sSql = sSql + ", getdate()";            //更新日
                sSql = sSql + ", '" + sUserID + "'";       //更新者
                sSql = sSql + ")";

                ret = m_ComFunc.DB_Execute(sSql);


                if (ret)
                {
                    //選任日解任日設定の登録
                    ret1 = Insselection_date_tbl(enginnerID_key, sDeptid);
                    if (ret1 == false)
                    {
                        ret1 = false;
                    }
                }
                else
                {
                    ret1 = false;
                }
                
            }
            catch (Exception ex)
            {
                lblErrMsg.Text = ex.Message;
                logger.Error("User:" + sUserID + ex.Message, ex);

                ret1 = false;
            }
            if ((ret == true) && (ret1 == true))
            {
                return true;

            }
            else
            {
                return false;
            }


            logger.Info(ComConst.INFO_LOG_END + sUserID + "無線従事者情報のテーブル登録処理");
                
        }
        //選任解任判断処理
        private string getSenninKaininKubun(string licensenum, string lastnm, string firstnm)
        {
            string ret = string.Empty;
            bool ret1 = true;
            string sSql = string.Empty;
            bool bRet=false;
            System.Data.DataTable dt = new System.Data.DataTable();

            //全て解任する場合、
            if ( ( ex1.Checked == false) &&　(fx1.Checked == false) && (fb1.Checked == false) && (fbr1.Checked == false) && (ml1.Checked == false)
            && (ex2.Checked == false) && (fx2.Checked == false) && (fb2.Checked == false) && (fb2.Checked == false) && (ml2.Checked == false)           
            && (ex3.Checked == false) && (fx3.Checked == false) && (fb3.Checked == false) && (fb3.Checked == false) && (ml3.Checked == false)
            && (ex4.Checked == false) && (fx4.Checked == false) && (fb4.Checked == false) && (fb4.Checked == false) && (ml4.Checked == false)
            && (ex5.Checked == false) && (fx5.Checked == false) && (fb5.Checked == false) && (fb5.Checked == false) && (ml5.Checked == false)
            && (ex6.Checked == false) && (fx6.Checked == false) && (fb6.Checked == false) && (fb6.Checked == false) && (ml6.Checked == false)
            && (ex7.Checked == false) && (fx7.Checked == false) && (fb7.Checked == false) && (fb7.Checked == false) && (ml7.Checked == false)
            && (ex8.Checked == false) && (fx8.Checked == false) && (fb8.Checked == false) && (fb8.Checked == false) && (ml8.Checked == false)
            && (ex9.Checked == false) && (fx9.Checked == false) && (fb9.Checked == false) && (fb9.Checked == false) && (ml9.Checked == false)
            && (ex10.Checked == false) && (fx10.Checked == false) && (fb10.Checked == false) && (fb10.Checked == false) && (ml9.Checked == false)
            && (ex11.Checked == false) && (fx11.Checked == false) && (fb10.Checked == false) && (fb10.Checked == false) && (ml9.Checked == false) )
            {
                //解任判定
                ret= "2";      //解任登録確定
            
            }
            else
            {
                ret = "1";      //選任登録確定
            }

            return ret;

        }
        private string getEngineerId(string plicensenum)
        {
            bool ret;
            string sSql = string.Empty;
            System.Data.DataTable dt = new System.Data.DataTable();
            try
            {
                 //トランザクションの開始
                m_ComFunc.DB_BeginTranzaction();

                sSql = "SELECT enginnerID  FROM radio_enginner_info_tbl ";
                sSql = sSql + " WHERE  license_number ='"  + plicensenum + "'" ;

                string msg = "";
                ret = m_ComFunc.DB_Select(sSql,  ref dt);

                if (ret == false)                {
                    ret = false;
                }

            }
            catch
            {
                ret = false;
            }

            return dt.Rows[0][0].ToString();
        }



        #region 北海道（局種別）
        private string gethokkaidou()
        {
            string ret= string.Empty;
            ArrayList arList = new ArrayList();

            if ( ex1.Checked)
            {
                arList.Add(ComConst.EX);
            }
            if(fx1.Checked)
            {
                arList.Add(ComConst.FX);
            }
            if (fb1.Checked)
            {
                arList.Add(ComConst.FB);
            }
            if (fbr1.Checked)
            {
                arList.Add(ComConst.FBR);
            }
            if (ml1.Checked)
            {
                arList.Add(ComConst.ML);
            }

            return getRet(arList);

        }
        #endregion

        #region 東北（局種別）
        private string gettouhoku()
        {
            string ret= string.Empty;
            ArrayList arList = new ArrayList();

            if (ex2.Checked)
            {
                arList.Add(ComConst.EX);
            }
            if (fx2.Checked)
            {
                arList.Add(ComConst.FX);
            }
            if (fb2.Checked)
            {
                arList.Add(ComConst.FB);
            }
            if (fbr2.Checked)
            {
                arList.Add(ComConst.FBR);
            }
            if (ml2.Checked)
            {
                arList.Add(ComConst.ML);
            }
            return getRet(arList);
        }
        #endregion

        #region 北陸（局種別）
        private string gethokuriku()
        {
            string ret = string.Empty;
            ArrayList arList = new ArrayList();

            if (ex3.Checked)
            {
                arList.Add(ComConst.EX);
            }
            if (fx3.Checked)
            {
                arList.Add(ComConst.FX);
            }
            if (fb3.Checked)
            {
                arList.Add(ComConst.FB);
            }
            if (fbr3.Checked)
            {
                arList.Add(ComConst.FBR);
            }
            if (ml3.Checked)
            {
                arList.Add(ComConst.ML);
            }

            return getRet(arList);
        }
        #endregion

        #region 信越（局種別）
        private string getshinetsu()
        {
            string ret = string.Empty;
            ArrayList arList = new ArrayList();

            if (ex4.Checked)
            {
                arList.Add(ComConst.EX);
            }
            if (fx4.Checked)
            {
                arList.Add(ComConst.FX);
            }
            if (fb4.Checked)
            {
                arList.Add(ComConst.FB);
            }
            if (fbr4.Checked)
            {
                arList.Add(ComConst.FBR);
            }
            if (ml4.Checked)
            {
                arList.Add(ComConst.ML);
            }

            return getRet(arList);
        }
        #endregion

        #region 関東（局種別）
        private string getkantou()
        {
            string ret = string.Empty;
            ArrayList arList = new ArrayList();

            if (ex5.Checked)
            {
                arList.Add(ComConst.EX);
            }
            if (fx5.Checked)
            {
                arList.Add(ComConst.FX);
            }
            if (fb5.Checked)
            {
                arList.Add(ComConst.FB);
            }
            if (fbr5.Checked)
            {
                arList.Add(ComConst.FBR);
            }
            if (ml5.Checked)
            {
                arList.Add(ComConst.ML);
            }

            return getRet(arList);
        }
        #endregion
        #region 東海（局種別）
        private string gettokai()
        {
            string ret = string.Empty;
            ArrayList arList = new ArrayList();

            if (ex6.Checked)
            {
                arList.Add(ComConst.EX);
            }
            if (fx6.Checked)
            {
                arList.Add(ComConst.FX);
            }
            if (fb6.Checked)
            {
                arList.Add(ComConst.FB);
            }
            if (fbr6.Checked)
            {
                arList.Add(ComConst.FBR);
            }
            if (ml6.Checked)
            {
                arList.Add(ComConst.ML);
            }

            return getRet(arList);
        }
        #endregion

        #region 近畿（局種別）
        private string getkinki()
        {
            string ret = string.Empty;
            ArrayList arList = new ArrayList();

            if (ex7.Checked)
            {
                arList.Add(ComConst.EX);
            }
            if (fx7.Checked)
            {
                arList.Add(ComConst.FX);
            }
            if (fb7.Checked)
            {
                arList.Add(ComConst.FB);
            }
            if (fbr7.Checked)
            {
                arList.Add(ComConst.FBR);
            }
            if (ml7.Checked)
            {
                arList.Add(ComConst.ML);
            }

            return getRet(arList);
        }
        #endregion

        #region 四国（局種別）
        private string getshikoku()
        {
            string ret = string.Empty;
            ArrayList arList = new ArrayList();

            if (ex8.Checked)
            {
                arList.Add(ComConst.EX);
            }
            if (fx8.Checked)
            {
                arList.Add(ComConst.FX);
            }
            if (fb8.Checked)
            {
                arList.Add(ComConst.FB);
            }
            if (fbr8.Checked)
            {
                arList.Add(ComConst.FBR);
            }
            if (ml8.Checked)
            {
                arList.Add(ComConst.ML);
            }

            return getRet(arList);
        }
        #endregion

        #region 中国（局種別）
        private string getchugoku()
        {
            string ret = string.Empty;
            ArrayList arList = new ArrayList();

            if (ex9.Checked)
            {
                arList.Add(ComConst.EX);
            }
            if (fx9.Checked)
            {
                arList.Add(ComConst.FX);
            }
            if (fb9.Checked)
            {
                arList.Add(ComConst.FB);
            }
            if (fbr9.Checked)
            {
                arList.Add(ComConst.FBR);
            }
            if (ml9.Checked)
            {
                arList.Add(ComConst.ML);
            }

            return getRet(arList);
        }
        #endregion

        #region 九州（局種別）
        private string getkyuushu()
        {
            string ret = string.Empty;
            ArrayList arList = new ArrayList();

            if (ex10.Checked)
            {
                arList.Add(ComConst.EX);
            }
            if (fx10.Checked)
            {
                arList.Add(ComConst.FX);
            }
            if (fb10.Checked)
            {
                arList.Add(ComConst.FB);
            }
            if (fbr10.Checked)
            {
                arList.Add(ComConst.FBR);
            }
            if (ml10.Checked)
            {
                arList.Add(ComConst.ML);
            }

            return getRet(arList);
        }
        #endregion
        #region 沖縄（局種別
        private string getokinawa()
        {
            string ret = string.Empty;
            ArrayList arList = new ArrayList();

            if (ex11.Checked)
            {
                arList.Add(ComConst.EX);
            }
            if (fx11.Checked)
            {
                arList.Add(ComConst.FX);
            }
            if (fb11.Checked)
            {
                arList.Add(ComConst.FB);
            }
            if (fbr11.Checked)
            {
                arList.Add(ComConst.FBR);
            }
            if (ml11.Checked)
            {
                arList.Add(ComConst.ML);
            }

            return getRet(arList);
        }
        #endregion

        //comma区切り結果取得する。
        private string getRet(ArrayList arr) 
        {
            string ret = null;

            for (int icnt = 0; icnt < arr.Count; icnt++)
            {
                if (icnt == arr.Count - 1)
                {
                    ret = ret + arr[icnt].ToString();
                }
                else
                {
                    ret = ret + arr[icnt].ToString() + "/";
                }

            }
            return ret;


        }
//        private void confrimCHK()
//        {
//            string csname = "PostBackSourceWindowScript";
//            Type cstype = this.GetType();
//            ClientScriptManager cs = Page.ClientScript;
//            if (!cs.IsStartupScriptRegistered(cstype, csname))
//            {

//                String cstext =
//                @"window.onload  =function() {
//	                    if(window.confirm('同一選任/解任情報が存在しています。更新してよろしいでしょうか？')){
//
//                            document.getElementById('IsInsOK').value = '1';
//	                    }
//	                    else{
//                            document.getElementById('IsInsOK').value = '2';
//	                    } 
//                        //alert(document.getElementById('IsInsOK').value);
//                        //document.getElementById('form1').submit();
//
//                        if(document.getElementById('IsInsOK').value == '2')
//                        {
//                                        self.close();
//                        }
//                   };";

//                cs.RegisterStartupScript(cstype, csname, cstext, true);

//            }
//        }
        //登録
        protected void add_Click(object sender, EventArgs e)
        {
            logger.Info(ComConst.INFO_LOG_START + sUserID + "登録ボタン押下処理");

            bool bRet = false;
            bool ret = false;
            try
            {
                //セッションにユーザIDを設定
                UserRole userRole = Session[ComConst.SESSION_USER_ROLE] as UserRole;
                //作業者ID
                enginnerID_key = (string)Session["enginnerID_key"];

                string sDeptid = "";
                //システム部門の場合、
                if (userRole.Roles.Contains(ComConst.SYSTEM_OPERATE_USER))
                {

                    //部門ID
                    //deptID = m_ComFunc.getBumonIdonSystem(ccDeepartmentSelector.SelectedIndex, Session[ComConst.SESSION_BUMON_MASTER] as Dictionary<string, string>);
                    sDeptid = ccDeepartmentSelector.GetSelectedValue();

                }
                //その他
                else if (userRole.Roles.Contains(ComConst.REQUEST_USER))
                {
                    //部門ID
                    sDeptid = userRole.DepartmentId;


                }
                else if (userRole.Roles.Contains(ComConst.APPROVAL_USER))
                {
                    //部門ID
                    sDeptid = userRole.DepartmentId;

                }
                //部門IDの確認
                if (string.IsNullOrEmpty(sDeptid as string))
                {
                    lblErrMsg.Text = "社内管理部門の部門IDが部門コードではないのでご確認下さい。！";
                    throw new Exception(lblErrMsg.Text);

                }


                //選任解任情報の重複チェック
                ret = chkSenninKaininInfo(enginnerID_key, sDeptid);
                if (ret)
                {
                    //重複データが存在している場合、
                   //confrimCHK();
                    //初期値設定
                    //diSpselection_personal_tbl(enginnerID_key, sDeptid);
                    //Response.Write("<script language=JavaScript> alert('クライアント') </script>");
                    
                    IsInsOK.Value = "1";
                }
                else
                {
                    //新規登録
                    IsInsOK.Value = "3";

                }
                //新規登録
                if (IsInsOK.Value == "3")
                {
                    // 選任・解任 個別情報の登録
                    //選任日解任日設定の登録
                    bRet = Ins_selection_personal_Selectioon_date();
                    if (!(bRet))
                    {
                        m_ComFunc.DB_Rollback();

                        lblErrMsg.Text = "選任・解任 個別情報の登録が同一データがあるため、失敗しました";
                    }
                    else
                    {
                        //コミットする。
                        m_ComFunc.DB_Commit();

                        //親画面の更新し、閉じる
                        string csname = "PostBackSourceWindowScript";
                        Type cstype = this.GetType();
                        ClientScriptManager cs = Page.ClientScript;
                        if (!cs.IsStartupScriptRegistered(cstype, csname))
                        {
                            String cstext =
                            @"window.onload = function() {
                    if (!window.opener || window.opener.closed) {
                        self.close();
                    }
                    else {
                        window.opener.document.getElementById('updcb').value = 'posi';
                        window.opener.document.getElementById('form1').submit();
                        self.close();
                        }
                    };";

                            cs.RegisterStartupScript(cstype, csname, cstext, true);
                        }

                        lblErrMsg.Text = "選任・解任 個別情報の登録が成功しました。";
                    }
                }
                else if (IsInsOK.Value == "1")    //更新
                {

                    //更新しましょうね
                    bRet = Upd_selection_personal();
                    if (!(bRet))
                    {
                        m_ComFunc.DB_Rollback();
                        
                        lblErrMsg.Text = "選任・解任 個別情報の更新が失敗しました";
                    }
                    else
                    {
                        //コミットする。
                        m_ComFunc.DB_Commit();
                        //親画面の更新し、閉じる
                        string csname = "PostBackSourceWindowScript";
                        Type cstype = this.GetType();
                        ClientScriptManager cs = Page.ClientScript;
                        if (!cs.IsStartupScriptRegistered(cstype, csname))
                        {
                            String cstext =
                            @"window.onload = function() {
                    if (!window.opener || window.opener.closed) {
                        self.close();
                    }
                    else {
                        window.opener.document.getElementById('updcb').value = 'posi';
                        window.opener.document.getElementById('form1').submit();
                        //self.close();
                        }
                    };";

                            cs.RegisterStartupScript(cstype, csname, cstext, true);
                        }

                        lblErrMsg.Text = "申請日が同じ選任・解任 個別情報が存在するため、更新されました。";
                    }

                }
                logger.Info(ComConst.INFO_LOG_END + sUserID + "登録ボタン押下処理");

            }
            catch (Exception ex)
            {
                lblErrMsg.Text = ex.Message;
                logger.Error("User:" + sUserID + ex.Message, ex);

            }
        }

        private int isSelection_personal(string engID, string scetionID, string region)
        {
            string sSql = string.Empty;
            bool bRet = false;
            DataTable dt = new DataTable();

            int ret = 1;

            //SELECT
            sSql = "SELECT  *   ";
            sSql = sSql + " FROM selection_personal_tbl  ";
            sSql = sSql + " WHERE enginnerID = '" + engID + "'";
            sSql = sSql + " AND selectionID= '" + scetionID + "'";
            sSql = sSql + " AND " + region + "!= '' ";

            //SQL文発行
            bRet = m_ComFunc.DB_Select(sSql, ref dt);
            if (bRet)
            {
                if (dt.Rows.Count > 1)
                {
                    ret = 2; //解任として登録可
                }
                else if (dt.Rows.Count == 0)
                {
                    ret = 3; //解任として登録不可
                }
                else
                {
                    ret = 1;
                }
            }

            return ret;
        }

        //選任日解任日設定の登録
        private bool Insselection_date_tbl(string enginnerID, string selectionID)
        {
            //System.Data.DataTable dt;
            bool ret = true;
            int request_kind = 1;

            //北海道
            if ((ex1.Checked == true) || (fx1.Checked == true) || (fb1.Checked == true) || (fbr1.Checked == true) || (ml1.Checked == true))
            {
                //tNEW_ENTITY1の登録
                //1.地域に何か値が設定されたら、レコード作成する。
                //1.で作成の際に、選任/解任日はnullで設定する。
                ret = Ins_selection_date(enginnerID, selectionID, 1, 1);
                if (ret == false)
                {
                    return false;

                }

            }
            else if ((ex1.Checked == false) && (fx1.Checked == false) && (fb1.Checked == false) && (fbr1.Checked == false) && (ml1.Checked == false))
            {
                request_kind = isSelection_personal(enginnerID, selectionID, m_ComFunc.GetAreaRowName("J"));
                if ((request_kind == 1) || (request_kind == 2))
                {
                    ret = Ins_selection_date(enginnerID, selectionID, 1, 2);
                    if (ret == false)
                    {
                        return false;

                    }

                }
 
            }
            //東北
            if ((ex2.Checked == true) || (fx2.Checked == true) || (fb2.Checked == true) || (fb2.Checked == true) || (ml2.Checked == true))
            {
                ret = Ins_selection_date(enginnerID, selectionID, 2, 1);
                if (ret == false)
                {
                    return false;

                }
            }
            else if ((ex2.Checked == false) && (fx2.Checked == false) && (fb2.Checked == false) && (fbr2.Checked == false) && (ml2.Checked == false))
            {
                request_kind = isSelection_personal(enginnerID, selectionID, m_ComFunc.GetAreaRowName("I"));
                if ((request_kind == 1) || (request_kind == 2))
                {
                    ret = Ins_selection_date(enginnerID, selectionID, 2, 2);
                    if (ret == false)
                    {
                        return false;

                    }

                }

            }
            //北陸
            if ((ex3.Checked == true) || (fx3.Checked == true) || (fb3.Checked == true) || (fb3.Checked == true) || (ml3.Checked == true))
            {
                ret = Ins_selection_date(enginnerID, selectionID, 3, 1);
                if (ret == false)
                {
                    return false;
                }
            }
            else if ((ex3.Checked == false) && (fx3.Checked == false) && (fb3.Checked == false) && (fbr3.Checked == false) && (ml3.Checked == false))
            {
                request_kind = isSelection_personal(enginnerID, selectionID, m_ComFunc.GetAreaRowName("D"));
                if ((request_kind == 1) || (request_kind == 2))
                {
                    ret = Ins_selection_date(enginnerID, selectionID, 3, 2);
                    if (ret == false)
                    {
                        return false;

                    }

                }

            }
            //信越
            if ((ex4.Checked == true) || (fx4.Checked == true) || (fb4.Checked == true) || (fb4.Checked == true) || (ml4.Checked == true))
            {
                ret = Ins_selection_date(enginnerID, selectionID, 4, 1);
                if (ret == false)
                {
                    return false;
                }
            }
            else if ((ex4.Checked == false) && (fx4.Checked == false) && (fb4.Checked == false) && (fbr4.Checked == false) && (ml4.Checked == false))
            {
                request_kind = isSelection_personal(enginnerID, selectionID, m_ComFunc.GetAreaRowName("B"));
                if ((request_kind == 1) || (request_kind == 2))
                {
                    ret = Ins_selection_date(enginnerID, selectionID, 4, 2);
                    if (ret == false)
                    {
                        return false;

                    }

                }

            }
            //関東
            if ((ex5.Checked == true) || (fx5.Checked == true) || (fb5.Checked == true) || (fb5.Checked == true) || (ml5.Checked == true))
            {
                ret = Ins_selection_date(enginnerID, selectionID, 5, 1);
                if (ret == false)
                {
                    return false;
                }
            }
            else if ((ex5.Checked == false) && (fx5.Checked == false) && (fb5.Checked == false) && (fbr5.Checked == false) && (ml5.Checked == false))
            {
                request_kind = isSelection_personal(enginnerID, selectionID, m_ComFunc.GetAreaRowName("A"));
                if ((request_kind == 1) || (request_kind == 2))
                {
                    ret = Ins_selection_date(enginnerID, selectionID, 5, 2);
                    if (ret == false)
                    {
                        return false;

                    }

                }

            }
            //東海
            if ((ex6.Checked == true) || (fx6.Checked == true) || (fb6.Checked == true) || (fb6.Checked == true) || (ml6.Checked == true))
            {
                ret = Ins_selection_date(enginnerID, selectionID, 6, 1);
                if (ret == false)
                {
                    return false;
                }
            }
            else if ((ex6.Checked == false) && (fx6.Checked == false) && (fb6.Checked == false) && (fbr6.Checked == false) && (ml6.Checked == false))
            {
                request_kind = isSelection_personal(enginnerID, selectionID, m_ComFunc.GetAreaRowName("C"));
                if ((request_kind == 1) || (request_kind == 2))
                {
                    ret = Ins_selection_date(enginnerID, selectionID, 6, 2);
                    if (ret == false)
                    {
                        return false;

                    }

                }

            }
            //近畿
            if ((ex7.Checked == true) || (fx7.Checked == true) || (fb7.Checked == true) || (fb7.Checked == true) || (ml7.Checked == true))
            {
                ret = Ins_selection_date(enginnerID, selectionID, 7, 1);
                if (ret == false)
                {
                    return false;
                }
            }
            else if ((ex7.Checked == false) && (fx7.Checked == false) && (fb7.Checked == false) && (fbr7.Checked == false) && (ml7.Checked == false))
            {
                request_kind = isSelection_personal(enginnerID, selectionID, m_ComFunc.GetAreaRowName("E"));
                if ((request_kind == 1) || (request_kind == 2))
                {
                    ret = Ins_selection_date(enginnerID, selectionID, 7, 2);
                    if (ret == false)
                    {
                        return false;

                    }

                }

            }
            //四国
            if ((ex8.Checked == true) || (fx8.Checked == true) || (fb8.Checked == true) || (fb8.Checked == true) || (ml8.Checked == true))
            {
                ret = Ins_selection_date(enginnerID, selectionID, 8, 1);
                if (ret == false)
                {
                    return false;
                }
            }
            else if ((ex8.Checked == false) && (fx8.Checked == false) && (fb8.Checked == false) && (fbr8.Checked == false) && (ml8.Checked == false))
            {
                request_kind = isSelection_personal(enginnerID, selectionID, m_ComFunc.GetAreaRowName("H"));
                if ((request_kind == 1) || (request_kind == 2))
                {
                    ret = Ins_selection_date(enginnerID, selectionID, 8, 2);
                    if (ret == false)
                    {
                        return false;

                    }

                }

            }
            //中国
            if ((ex9.Checked == true) || (fx9.Checked == true) || (fb9.Checked == true) || (fb9.Checked == true) || (ml9.Checked == true))
            {
                ret = Ins_selection_date(enginnerID, selectionID, 9, 1);
                if (ret == false)
                {
                    return false;
                }
            }
            else if ((ex9.Checked == false) && (fx9.Checked == false) && (fb9.Checked == false) && (fbr9.Checked == false) && (ml9.Checked == false))
            {
                request_kind = isSelection_personal(enginnerID, selectionID, m_ComFunc.GetAreaRowName("F"));
                if ((request_kind == 1) || (request_kind == 2))
                {
                    ret = Ins_selection_date(enginnerID, selectionID, 9, 2);
                    if (ret == false)
                    {
                        return false;

                    }

                }

            }
            //九州
            if ((ex10.Checked == true) || (fx10.Checked == true) || (fb10.Checked == true) || (fb10.Checked == true) || (ml9.Checked == true))
            {
                ret = Ins_selection_date(enginnerID, selectionID, 10, 1);
                if (ret == false)
                {
                    return false;
                }
            }
            else if ((ex10.Checked == false) && (fx10.Checked == false) && (fb10.Checked == false) && (fbr10.Checked == false) && (ml10.Checked == false))
            {
                request_kind = isSelection_personal(enginnerID, selectionID, m_ComFunc.GetAreaRowName("G"));
                if ((request_kind == 1) || (request_kind == 2))
                {
                    ret = Ins_selection_date(enginnerID, selectionID, 10, 2);
                    if (ret == false)
                    {
                        return false;

                    }

                }

            }
            //沖縄
            if ((ex11.Checked == true) || (fx11.Checked == true) || (fb10.Checked == true) || (fb10.Checked == true) || (ml9.Checked == true))
            {
                ret = Ins_selection_date(enginnerID, selectionID, 11, 1);
                if (ret == false)
                {
                    return false;
                }
            }
            else if ((ex11.Checked == false) && (fx11.Checked == false) && (fb11.Checked == false) && (fbr11.Checked == false) && (ml11.Checked == false))
            {
                request_kind = isSelection_personal(enginnerID, selectionID, m_ComFunc.GetAreaRowName("O"));
                if ((request_kind == 1) || (request_kind == 2))
                {
                    ret = Ins_selection_date(enginnerID, selectionID, 11, 2);
                    if (ret == false)
                    {
                        return false;

                    }

                }

            }


            return ret;

        }
        //選任日解任日設定
        private bool Ins_selection_date(string penginnerID, string pselectionID, int pregion, int psr_flag)
        {
            string sSql = string.Empty;
            bool ret = false;

            try
            {
                logger.Info(ComConst.INFO_LOG_START + sUserID + "選任日解任日設定登録の処理");

                //セッションにユーザIDを設定
                UserRole userRole = Session[ComConst.SESSION_USER_ROLE] as UserRole;

               //トランザクションの開始
                m_ComFunc.DB_BeginTranzaction();


                sSql = "INSERT INTO selection_date_tbl(";
                sSql = sSql + "enginnerID";                 //従事者ID
                sSql = sSql + ", selectionID";              //選任部門ID
                sSql = sSql + ", request_date";             //申請日
                sSql = sSql + ", area_code";                   //地域
                sSql = sSql + ", sr_flag";                  //選任/解任フラグ
//                sSql = sSql + ", sr_date";                  //ni
                sSql = sSql + ") VALUES (";
                sSql = sSql + "'" + penginnerID + "'";      //従事者ID
                sSql = sSql + ", '" + pselectionID + "'";   //選任部門ID
                sSql = sSql + ", getdate()";                //申請日
                sSql = sSql + ", '" + pregion + "'";        //地域
                sSql = sSql + ", '" + psr_flag + "'";                 //選任/解任フラグ
//                sSql = sSql + ", '" + null + "'";           ///選任/解任日
                sSql = sSql + ")";

                ret = m_ComFunc.DB_Execute(sSql);

                if (ret)
                {
                    ret = true;
                }
                else
                {
                    ret = false;
                }
                logger.Info(ComConst.INFO_LOG_END + sUserID + "選任日解任日設定登録の処理");

            }
            catch(Exception ex) 
            {
               　 lblErrMsg.Text = ex.Message;
                 logger.Error("User:" + sUserID + ex.Message, ex);
            }

            return ret;
        }

        private bool updSelection_date(string penginnerID, string pselectionID, int pregion, int psr_flag)
        {
            string sSql = string.Empty;
            bool ret = false;

            try
            {
                logger.Info(ComConst.INFO_LOG_START + sUserID + "選任日解任日設定の更新処理");

                //トランザクションの開始
                m_ComFunc.DB_BeginTranzaction();

                // 現在の日付を取得する
                //DateTime dtToday = DateTime.Today;
                string dtToday = DateTime.Now.ToString("yyyy/MM/dd");


                //ユーザ情報より
                UserRole userRole = Session[ComConst.SESSION_USER_ROLE] as UserRole;
                if (userRole.Roles.Contains(ComConst.SYSTEM_OPERATE_USER))
                {
                    //部門ID
                    //sDeptid = m_ComFunc.getBumonIdonSystem(BumonList.SelectedIndex, Session[ComConst.SESSION_BUMON_MASTER] as Dictionary<string, string>);
                    sDeptid = ccDeepartmentSelector.GetSelectedValue();

                }
                else
                {
                    sDeptid = userRole.DepartmentId.ToString();
                }

                sSql = "UPDATE  selection_date_tbl ";
                sSql = sSql + "SET  sr_date= '" + null + "'";
                sSql = sSql + ", sr_flag= '" + psr_flag + "'";
                sSql = sSql + "WHERE enginnerID ='" + penginnerID + "'";
                sSql = sSql + "AND selectionID = '" + sDeptid + "'";
                sSql = sSql + "AND request_date = '" + dtToday + "'";
                sSql = sSql + "AND region = '" + pregion + "'";

                ret = m_ComFunc.DB_Execute(sSql);

                if (ret)
                {
                    ret = true;
                }
                else
                {
                    ret = false;
                }
                logger.Info(ComConst.INFO_LOG_END + sUserID + "選任日解任日設定の更新処理");

            }
            catch (Exception ex)
            {
                lblErrMsg.Text = ex.Message;
                logger.Error("User:" + sUserID + ex.Message, ex);
            }

            return ret;
        }
        //重複データ存在しているか検索
        private bool chkSenninKaininInfo(string engID, string sectionID)
        {
            logger.Info(ComConst.INFO_LOG_START + sUserID + "重複データ検索処理");
            bool bRet = false,ret=false;
            string sSql = string.Empty;
            System.Data.DataTable  dt = new System.Data.DataTable();
            try
            {
                m_ComFunc = (ComFunc)Session[ComConst.COM_FUNC];

                // 現在の日付を取得する
                //DateTime dtToday = DateTime.Today;
                string dtToday = DateTime.Now.ToString("yyyy/MM/dd");

                //SQL文作成
                sSql = "SELECT enginnerID,selectionID,request_date,request_div,belong_company,belong_department,";
                sSql = sSql + " jmcia_flag,sb_wcp,hokkaidou,touhoku,hokuriku,shinetsu,kantou,tokai,kinki,shikoku,";
                sSql = sSql + " chugoku,kyuushu,okinawa,apploval_flag,delete_flag,create_date,create_name,update_date,update_name";
                sSql = sSql + "  FROM selection_personal_tbl";
                sSql = sSql + "  WHERE enginnerID = '" + engID + "'";
                sSql = sSql + "  AND selectionID = '" + sectionID + "'";
                sSql = sSql + "  AND request_date= '" + dtToday + "'";
                sSql = sSql + "  AND delete_flag= '0'";

                //SQL文発行
                bRet = m_ComFunc.DB_Select(sSql, ref dt);

                if (bRet == false)
                {
                    lblErrMsg.Text = "検索できませんでした。";
                }

                //データ件数を表示
                if ( dt.Rows.Count > 0)
                {
                    ret = true;
                }
                logger.Info(ComConst.INFO_LOG_END + sUserID + "重複データ検索処理");

            }
            catch(Exception ex)
            {
                logger.Error("User:" + sUserID + ex.Message, ex);

            }

            return ret;

        }

        //選任/解任個別情報の更新
        private bool Upd_selection_personal()
        {
            logger.Info(ComConst.INFO_LOG_START + sUserID + "選任/解任個別情報の更新処理");

            bool ret = false, ret1 = true;
            string sSql = string.Empty;
            UserRole user = Session[ComConst.SESSION_USER_ROLE] as UserRole;
            sUserID = user.UserId;

            try
            {
                //トランザクションの開始
                m_ComFunc.DB_BeginTranzaction();
                
                string dtToday = DateTime.Now.ToString("yyyy/MM/dd");
                string engineerID = (string)Session["enginnerID_key"];


                //ユーザ情報より
                UserRole userRole = Session[ComConst.SESSION_USER_ROLE] as UserRole;
                if (userRole.Roles.Contains(ComConst.SYSTEM_OPERATE_USER))
                {
                    //部門ID
                    //sDeptid = m_ComFunc.getBumonIdonSystem(BumonList.SelectedIndex, Session[ComConst.SESSION_BUMON_MASTER] as Dictionary<string, string>);
                    sDeptid = ccDeepartmentSelector.GetSelectedValue();

                }
                else
                {
                    sDeptid = userRole.DepartmentId.ToString();
                }

                //解任判定
                string sRequest_div = getSenninKaininKubun(licenseno.Text, lastname.Text, firstname.Text);
                //SQL作成
                sSql = "UPDATE  selection_personal_tbl ";
                sSql = sSql + " SET request_div = '" + sRequest_div + "'";
                sSql = sSql + ", belong_company= '" + company.Text + "'";
                sSql = sSql + ", belong_department= '" + department.Text + "'";
                sSql = sSql + ", jmcia_flag= '" + jmicia.SelectedIndex + "'";
                sSql = sSql + ", sb_wcp= '" + sbwcp.SelectedIndex + "'";
                sSql = sSql + ", hokkaidou= '" + gethokkaidou() + "'";
                sSql = sSql + ", touhoku= '" + gettouhoku() + "'";
                sSql = sSql + ", hokuriku= '" + gethokuriku() + "'";
                sSql = sSql + ", shinetsu= '" + getshinetsu() + "'";
                sSql = sSql + ", kantou= '" + getkantou() + "'";
                sSql = sSql + ", tokai= '" + gettokai() + "'";
                sSql = sSql + ", kinki= '" + getkinki() + "'";
                sSql = sSql + ", shikoku= '" + getshikoku() + "'";
                sSql = sSql + ", chugoku= '" + getchugoku() + "'";
                sSql = sSql + ", kyuushu= '" + getkyuushu() + "'";
                sSql = sSql + ", okinawa= '" + getokinawa() + "'";
                sSql = sSql + ", update_date= '" + dtToday + "'";
                sSql = sSql + ", update_name= '" + sUserID + "'";
                sSql = sSql + "WHERE request_date ='" + dtToday + "'";
                sSql = sSql + "AND enginnerID = '" + engineerID + "'";
                sSql = sSql + "AND selectionID = '" + sDeptid + "'";
                string msg = "";
                ret = m_ComFunc.DB_Execute(sSql);

                if (ret == false)
                {
                    ret = false;
                }
                else
                {
                    //選任日解任日設定の削除
                    bool ret3 = deleteSelection_date_tbl(engineerID, sDeptid, dtToday);
                    if (ret3 == true)
                    {

                        //選任日解任日設定の登録
                        //ret1 = setselection_date_tbl(engineerID, deptID);
                        ret1 = Insselection_date_tbl(engineerID, sDeptid);
                        if (ret1 == false)
                        {
                            ret1 = false;
                        }
                    }

                    ret = true;

                }
                logger.Info(ComConst.INFO_LOG_END + sUserID + "選任/解任個別情報の更新処理");

            }

            catch(Exception ex)
            {
                logger.Error("User:" + sUserID + ex.Message, ex);

            }
            return ret1;
        }

        //選任解任日が同一データであれば、削除する。
        private bool deleteSelection_date_tbl(string enginnerID, string selectionID, string reqday)
        {
            string sSql = string.Empty;

            bool ret;

            //トランザクションの開始
            m_ComFunc.DB_BeginTranzaction();


            sSql = "DELETE  FROM selection_date_tbl ";
            sSql = sSql + "WHERE request_date ='" + reqday + "'";
            sSql = sSql + "AND enginnerID = '" + enginnerID + "'";
            sSql = sSql + "AND selectionID = '" + selectionID + "'";

            ret = m_ComFunc.DB_Execute(sSql);
            if (ret == true)
            {
                ret = true;
            }
            else
            {
                ret = false;
            }


            return ret;
 
        }
        //所属部署（施工会社）
        protected void company_SelectedIndexChanged(object sender, EventArgs e)
        {
            logger.Info(ComConst.INFO_LOG_START + sUserID + "所属部署（施工会社）取得処理");

            string sSql = string.Empty;
            bool bRet = false;
            System.Data.DataTable dt = new System.Data.DataTable();
            bool pbFirstFlg = true;
            string sTargetCompanyID = "";

            //SQL文作成
            sSql = "SELECT distinct company_id ";
            sSql = sSql + " FROM company_mst ";
            sSql = sSql + " WHERE DEL_FLAG = 0";
            sSql = sSql + " AND company_name= '" + company.SelectedItem.Text + "'";

            //SQL文発行
            bRet = m_ComFunc.DB_Select(sSql, ref dt);
            if (dt != null)
            {
               sTargetCompanyID= dt.Rows[0][0].ToString();
            }

            //初期化
            department.Items.Clear();
            //空白設定フラグによる判別
            if (pbFirstFlg)
            {
                department.Items.Add("");
            }

            //SQL文作成
            sSql = "SELECT distinct company_id,section_id,section_name";
            sSql = sSql + " FROM section_mst ";
            sSql = sSql + " WHERE del_flag=0";
            sSql = sSql + " AND company_id ='" + sTargetCompanyID +"'";
            sSql = sSql + " ORDER BY company_id ";

            //SQL文発行
            bRet = m_ComFunc.DB_Select(sSql, ref dt);
            if (bRet)
            {
                for(int i = 0 ;i < dt.Rows.Count;i++)
                {

                    department.Items.Add(dt.Rows[i][2].ToString());
                }

            }

            logger.Info(ComConst.INFO_LOG_END + sUserID + "所属部署（施工会社）取得処理");

        }


        
    }
}