﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web.UI;
using System.Web.UI.WebControls;
using EmpCRM.common;
using EmpCRM.Dto;
using log4net;

namespace EmpCRM
{
    public partial class EmployeeEditResult : System.Web.UI.Page
    {
        private ComFunc m_ComFunc = null;
        private List<radio_enginner_info> rd_enginner_infoL = new List<radio_enginner_info>();
        private string gPage_num = "1";
        private static log4net.ILog logger = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
        private string sUserID = "";

        protected void Page_Load(object sender, EventArgs e)
        {
            //セッションにユーザIDを設定
            UserRole userRole = Session[ComConst.SESSION_USER_ROLE] as UserRole;
            if (!LoginUtil.IsLogin(userRole))
            {
                Response.Redirect("error.htm", false);
            }
            Session["FromResult"] = null;

            string slicenseno = Request.QueryString["licenseno"];
            string slicensedate = Request.QueryString["licensedate"];
            string slastname = Request.QueryString["lastname"];
            string sfirstname = Request.QueryString["firstname"];
            string sfuri_familyname = Request.QueryString["furi_familyname"];
            string sfuri_firstname = Request.QueryString["furi_firstname"];

            //従事者情報情報の取得
            workerInfoData(slicenseno, slicensedate, slastname, sfirstname, sfuri_familyname, sfuri_firstname);

        }
        //従事者情報情報の取得
        public void workerInfoData(string plicenseno, string plicensedate, string plastname, string pfirstname, string pfuri_familyname, string pfuri_firstname)
        {
            logger.Info(ComConst.INFO_LOG_START + sUserID + "従事者情報情報の取得処理");

            string sSql = string.Empty;
            bool bRet = false;
             System.Data.DataTable dataTable = null;

            try
            {
                m_ComFunc = (ComFunc)Session[ComConst.COM_FUNC];

                //条件設定する。
                string SQL_edt = m_ComFunc.createWhereEdit(
                                     plicenseno,
                                     plastname,
                                     pfirstname,
                                     pfuri_familyname,
                                     pfuri_firstname,
                                     plicensedate);


                //SQL文作成
                //sSql = "SELECT license_number, getlicense_date, LastName, FirstName, birthday";
                sSql = "SELECT ROW_NUMBER() OVER(order by license_number ) 'No',license_number,LastName,firstName,birthday,enginnerID,LastName_Kana,FirstName_Kana,";
                sSql = sSql + "license_type,CONVERT(NVARCHAR, getlicense_date, 111) AS getlicense_date,zip_code,prefectures,city,address,business_backgrand,createdate,";
                sSql = sSql + "create_name,updatedate,update_name";
                sSql = sSql + " FROM radio_enginner_info_tbl";
                if ((plicenseno == "") && (plicensedate == "") && (plicensedate == "") 
                    && (plastname == "") && (plastname == "") && (pfirstname == ""))
                {
                    sSql = sSql + "  ";
                }
                else
                {
                    sSql = sSql + " WHERE ";
                }
                //Where句設定
                sSql = sSql + SQL_edt;

                //SQL文発行
                bRet = m_ComFunc.DB_Select(sSql, ref dataTable);

                if (bRet == false)
                {
                    lblErrMsg.Text = "検索できませんでした。";
                }

                GridView1.ShowHeaderWhenEmpty = true;
                GridView1.DataSource = dataTable;
                GridView1.DataBind();


                for (int i = 0; i < dataTable.Rows.Count; i++)
                {
                    radio_enginner_info rd = new radio_enginner_info();
                    rd.no = i + 1;
                    rd.license_number = dataTable.Rows[i]["license_number"].ToString();
                    rd.LastName = dataTable.Rows[i]["LastName"].ToString();
                    rd.FirstName = dataTable.Rows[i]["FirstName"].ToString();
                    rd.birthday = Convert.ToDateTime(dataTable.Rows[i]["birthday"]);
                    rd.enginnerID = dataTable.Rows[i]["enginnerID"].ToString();
                    rd.LastName_Kana = dataTable.Rows[i]["LastName_Kana"].ToString();
                    rd.FirstName_Kana = dataTable.Rows[i]["FirstName_Kana"].ToString();
                    rd.license_type = dataTable.Rows[i]["license_type"].ToString();
                    rd.getlicense_date = Convert.ToDateTime(dataTable.Rows[i]["getlicense_date"].ToString());

                    rd.zip_code = dataTable.Rows[i]["zip_code"].ToString();
                    rd.prefectures = dataTable.Rows[i]["prefectures"].ToString();
                    rd.city = dataTable.Rows[i]["city"].ToString();
                    rd.address = dataTable.Rows[i]["address"].ToString();
                    rd.business_backgrand = dataTable.Rows[i]["business_backgrand"].ToString();
                    rd.createdate = Convert.ToDateTime(dataTable.Rows[i]["createdate"].ToString());
                    rd.create_name = dataTable.Rows[i]["create_name"].ToString();
                    rd.updatedate = Convert.ToDateTime(dataTable.Rows[i]["updatedate"].ToString());
                    rd.update_name = dataTable.Rows[i]["update_name"].ToString();

                    rd_enginner_infoL.Add(rd);
                }
                //データ件数を表示
                lblErrMsg.Text = dataTable.Rows.Count.ToString() + "件が検索されました。";

                logger.Info(ComConst.INFO_LOG_END + sUserID + "従事者情報情報の取得処理");

            }
            catch(Exception ex)
            {
                lblErrMsg.Text = ex.Message;
                logger.Error("User:" + sUserID + ex.Message, ex);
            }
 
        }
 

        ///<summary>
        //選択の押下、処理
        ///</summary>
        protected void selBtn_Click(object sender, EventArgs e)
        {
            logger.Info(ComConst.INFO_LOG_START + sUserID + "選択ボタン押下処理");

            //Label1.Text = selitem.Value;
            int glPage_num = 0;
            if (selitem.Value != "")
            {
                int selitemidx = Int32.Parse(selitem.Value);


                gPage_num = (string)Session["gPage_num"];

                if (gPage_num == null) gPage_num = "1";

                if (Int32.Parse(gPage_num) >= 2)
                {
                    glPage_num = (Int32.Parse(gPage_num) - 1) * GridView1.PageSize;
                }

                selitemidx = selitemidx + glPage_num;


                for (int iIndex = 0; iIndex < rd_enginner_infoL.Count(); iIndex++)
                {
                    if (selitemidx == iIndex)
                    {
                        Session[ComConst.LICENSE_NUM] = rd_enginner_infoL[iIndex].license_number.ToString();
                        Session[ComConst.LICENSE_DATE] = rd_enginner_infoL[iIndex].getlicense_date.ToShortDateString();
                        Session[ComConst.LASTNAME] = rd_enginner_infoL[iIndex].LastName.ToString();
                        Session[ComConst.FIRSTNAME] = rd_enginner_infoL[iIndex].FirstName.ToString();
                        Session[ComConst.LASTNAME_KANA] = rd_enginner_infoL[iIndex].LastName_Kana.ToString();
                        Session[ComConst.FIRSTNAME_KANA] = rd_enginner_infoL[iIndex].FirstName_Kana.ToString();
                        Session["FromResult"] = "EmployeeEditResult";
                        break;

                    }
                    

                }
                //Response.Redirect("EmployeeEdit.aspx", false);

                //親画面の更新し、閉じる
                string csname = "PostBackSourceWindowScript";
                Type cstype = this.GetType();
                ClientScriptManager cs = Page.ClientScript;
                if (!cs.IsStartupScriptRegistered(cstype, csname))
                {
                    String cstext =
                    @"window.onload = function() {
                    if (!window.opener || window.opener.closed) {
                        self.close();
                    }
                    else {
                        window.opener.document.getElementById('form1').submit();
                        self.close();
                        }
                    };";

                    cs.RegisterStartupScript(cstype, csname, cstext, true);
                }


            }
            else 
            {
                lblErrMsg.Text = "従事者情報を選択して下さい。";
            }

            logger.Info(ComConst.INFO_LOG_END + sUserID + "選択ボタン押下処理");

        }
        protected void GridView1_RowCreated(object sender, GridViewRowEventArgs e)
        {
            for (int i = 0; i < GridView1.Rows.Count; i++)
            {
                GridViewRow row = GridView1.Rows[i];
                RadioButton rb =
                  (RadioButton)row.FindControl("RadioButton1");
                rb.Attributes["onClick"] = "getIndex(" + i + ")";

            }

        }

        protected void GridView1_PageIndexChanging(object sender, GridViewPageEventArgs e)
        {
            GridView1.PageIndex = e.NewPageIndex;

            string slicenseno = Request.QueryString["licenseno"];
            string slicensedate = Request.QueryString["licensedate"];
            string slastname = Request.QueryString["lastname"];
            string sfirstname = Request.QueryString["firstname"];
            string sfuri_familyname = Request.QueryString["furi_familyname"];
            string sfuri_firstname = Request.QueryString["furi_firstname"];

            Session["gPage_num"] = (GridView1.PageIndex + 1).ToString();


            //従事者情報情報の取得
            workerInfoData(slicenseno, slicensedate, slastname, sfirstname, sfuri_familyname, sfuri_firstname);

            GridView1.DataBind();


        }

    }
}