﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.Web.UI;
using System.Web.UI.WebControls;
using EmpCRM.common;
using EmpCRM.Dto;
using log4net;

namespace EmpCRM
{
    public partial class EmployeeMissionPermit : System.Web.UI.Page
    {
        private ComFunc m_ComFunc;
        private List<selection_personal> selectionpersonL = new List<selection_personal>();
        private static log4net.ILog logger = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
        private string sUserID = "";


        protected void Page_Load(object sender, EventArgs e)
        {
            if (!(IsPostBack))
            {
                //セッションにユーザIDを設定
                UserRole userRole = Session[ComConst.SESSION_USER_ROLE] as UserRole;
                //社内管理部門
                department.Text = userRole.DepartmentName.ToString();


                if (!LoginUtil.IsLogin(userRole))
                {
                    Response.Redirect("error.htm", false);
                }
                sUserID = userRole.UserId;

                start_date.Text = "";
                end_date.Text = "";
                cb1.Checked = false;
                cb2.Checked = false;
                cb3.Checked = false;
                cb4.Checked = false;
                cb5.Checked = false;

                cboxAll.Visible = false;
                UncboxAll.Visible = false;
                Table1.Visible = false;

                //Panel5.Visible = false;

                ShoninTB.Visible = false;
                //Calendar1.SelectedDate = Calendar1.TodaysDate;
                //Calendar1.Visible = false;
                //Calendar2.SelectedDate = Calendar2.TodaysDate;
                //Calendar2.Visible = false;
            }
            else
            {
            }
        }

        protected void Calendar1_SelectionChanged(object sender, EventArgs e)
        {
            //start_date.Text = Calendar1.SelectedDate.ToShortDateString();
            //Calendar1.Visible = false;

        }
        protected void Calendar2_SelectionChanged(object sender, EventArgs e)
        {
            //end_date.Text = Calendar2.SelectedDate.ToShortDateString();
            //Calendar2.Visible = false;

        } 

        protected void modoru_LClick(object sender, EventArgs e)
        {
            Response.Redirect("Mainmenu.aspx", false);
        }
            

        protected void ibtnCal2_Click(Object sender, ImageClickEventArgs e)
        {
            //Calendar2.Visible = true;
        }
        protected void Clear_LClick(object sender, EventArgs e)
        {
            start_date.Text = string.Empty;
            end_date.Text = string.Empty;
            cb1.Checked = false;
            cb2.Checked = false;
            cb3.Checked = false;
            cb4.Checked = false;
            cb5.Checked = false;
        }

        protected void search_LClick(object sender, EventArgs e)
        {
            SennninKaininREAD();
        }
        private void SennninKaininREAD()
        {
            logger.Info(ComConst.INFO_LOG_START + sUserID + "選任/解任検索処理");

            string sSql = string.Empty;
            bool bRet = false, flg = false;
            System.Data.DataTable dataTable = null;

            try
            {

                //if ((start_date.Text != "") && (end_date.Text != ""))
                //{
                //    flg = true;
                //}

                cboxAll.Visible = true;
                UncboxAll.Visible = true;
                Table1.Visible = true;
                ShoninTB.Visible = true;
                m_ComFunc = (ComFunc)Session[ComConst.COM_FUNC];

                string SQL_edt = createWhereStatus(
                                         cb1.Checked,
                                         cb2.Checked,
                                         cb3.Checked,
                                         cb4.Checked,
                                         cb5.Checked);


                //SQL文作成
                sSql = "SELECT  ";
                sSql = sSql + " B.license_number license_number,B.LastName ,B.FirstName,A.enginnerID enginnerID,A.selectionID selectionID,A.request_date request_date,A.request_div request_div,A.belong_company";
                sSql = sSql + " ,A.belong_department,A.jmcia_flag,A.sb_wcp,A.hokkaidou,A.touhoku,A.hokuriku,A.shinetsu,A.kantou,A.tokai,A.kinki,A.shikoku,A.chugoku,A.kyuushu,A.okinawa,A.apploval_flag,' ' dummy, ' ' dummy1";
                sSql = sSql + " ,A.delete_flag,A.create_date,A.create_name,A.update_date,A.update_name,ROW_NUMBER() OVER(order by B.license_number ) 'no'  FROM selection_personal_tbl A,radio_enginner_info_tbl B  ";
                sSql = sSql + " WHERE A.enginnerID = B.enginnerID ";
                //sSql = sSql + " AND belong_department = '" + sDepartment + "'";
                if (start_date.Text != "")
                {
                    sSql = sSql + " AND  request_date >= '" + start_date.Text + "'";
                }
                if (end_date.Text != "")
                {
                    sSql = sSql + " AND request_date <= '" + end_date.Text + "'";
                }

                if ((cb1.Checked == false) && (cb2.Checked == false) && (cb3.Checked == false) && (cb4.Checked == false) && (cb5.Checked == false))
                {
                    sSql = sSql + "  ";
                }
                else
                {
                    sSql = sSql + " AND ";
                }
                //Where句設定
                sSql = sSql + SQL_edt;

                //SQL文発行
                bRet = m_ComFunc.DB_Select(sSql, ref dataTable);

                if (bRet == false)
                {
                    lblErrMsg.Text = "検索できませんでした。";
                }

                //状態名と種別名取得する。
                editStatusKind(dataTable);

                if (dataTable.Rows.Count == 0)
                {
                    //データ件数を表示
                    lblErrMsg.Text = "対象データが検索されませんでした。";
                    ShoninTB.Visible = false;
                    cboxAll.Visible = false;
                    UncboxAll.Visible = false;
                    Table1.Visible = false;
                }
                else
                {
                    //データ件数を表示
                    lblErrMsg.Text = dataTable.Rows.Count.ToString() + "件が検索されました。";
                    ShoninTB.Visible = true;
                    cboxAll.Visible = true;
                    UncboxAll.Visible = true;
                    Table1.Visible = true;
                    //Panel5.Visible = true;
                }
                Session["warn_infoL"] = dataTable;
                GridView1.ShowHeaderWhenEmpty = true;
                GridView1.DataSource = dataTable;
                GridView1.DataBind();

                logger.Info(ComConst.INFO_LOG_END + sUserID + "選任/解任検索処理");
            }
            catch (Exception ex)
            {
                lblErrMsg.Text = ex.Message;
                logger.Error("User:" + sUserID + ex.Message, ex);

            }

        }
        protected void GridView1_RowCreated(Object sender, System.Web.UI.WebControls.GridViewRowEventArgs e)
        {
            if ((e.Row.RowType == DataControlRowType.DataRow) || (e.Row.RowType == DataControlRowType.Header))
            {
                e.Row.Cells[3].Visible = false;
            }


        }
        //状態
        private System.Data.DataTable editStatusKind(System.Data.DataTable dt)
        {
            DataTable ret_dt = null;

            for (int n = 0; n < dt.Rows.Count; n++)
            {
                int applova_flag = Int32.Parse(dt.Rows[n][22].ToString());
                if (applova_flag == 0)
                {
                    dt.Rows[n][23] = ComConst.MISHONIN;

                }
                else if (applova_flag == 1)
                {
                    dt.Rows[n][23] = ComConst.SHONIN_REQ;
                }
                else if (applova_flag == 2)
                {
                    dt.Rows[n][23] = ComConst.SHONIN_COMPLETED;
                }
                else if (applova_flag == 3)
                {
                    dt.Rows[n][23] = ComConst.SHONIN_DENY;
                }
                else if (applova_flag == 4)
                {
                    dt.Rows[n][23] = ComConst.SHONIN_RETURN;
                }
                //int request_flag = Int32.Parse(dt.Rows[n][6].ToString());
                //if (request_flag == 1)
                //{
                //    dt.Rows[n]["dummy1"] = ComConst.SENNIN;

                //}
                //else if (request_flag == 2)
                //{
                //    dt.Rows[n]["dummy1"] = ComConst.KAININ;
                //}



            }
            ret_dt = dt;
            return ret_dt;

        }

        //
        public string createWhereStatus(
                                        bool pcb1,
                                        bool pcb2,
                                        bool pcb3,
                                        bool pcb4,
                                        bool pcb5)
        {
            string ret = string.Empty;

            // Dictionaryの初期化
            Dictionary<string, string> map = new Dictionary<string, string>();

            map.Add("cb1", (pcb1 == true) ? "0" : string.Empty);
            map.Add("cb2", (pcb2 == true) ? "1" : string.Empty);
            map.Add("cb3", (pcb3 == true) ? "2" : string.Empty);
            map.Add("cb4", (pcb4 == true) ? "3" : string.Empty);
            map.Add("cb5", (pcb5 == true) ? "4" : string.Empty);
            int andCount = 0;
            // キーと値のペアを列挙
            foreach (var p in map)
            {
                if (p.Value != "")
                {
                    andCount++;
                }

                //Console.WriteLine(string.Format("{0}:{1}", p.Key, p.Value));
            }
            if (andCount == 0)  //1個選択の場合、
            {
                ret = "";
            }
            else if (andCount == 1)
            {
                foreach (var p in map)
                {
                    if (p.Value != "")
                    {

                        ret = string.Format(" apploval_flag =  '{0}' ", p.Value);
                    }
                }

            }
            else　　//複数選択の場合、
            {
                int jcnt = 0;
                foreach (var p in map)
                {
                    if (p.Value != "")
                    {
                        //最後
                        if (andCount - 1 == jcnt)
                        {
                            ret += string.Format(" apploval_flag =  '{0}' )", p.Value);
                        }
                        else if (jcnt == 0)
                        {
                            ret += string.Format("( apploval_flag =  '{0}'  OR ", p.Value);

                        }
                        else
                        {
                            ret += string.Format(" apploval_flag =  '{0}'  OR ", p.Value);
                        }

                        jcnt++;
                    }

                }
                //ret = ret1;
            }
            return ret;

        }
        private ArrayList getRdoengineerInfo(string penginnerID)
        {
            ArrayList ret = new ArrayList();

            //セッションから情報を取得
            m_ComFunc = (ComFunc)Session[ComConst.COM_FUNC];

            bool bRet;
            string sSql = string.Empty;
            DataTable dataTable = new DataTable();

            //SQL文作成
            sSql = "SELECT license_number,LastName,firstName ";
            sSql = sSql + " FROM radio_enginner_info_tbl";
            sSql = sSql + " WHERE enginnerID = '" + penginnerID + "'";

            //SQL文発行
            bRet = m_ComFunc.DB_Select(sSql, ref dataTable);


            if (dataTable.Rows.Count == 1)
            {

                for (int n = 0; n < dataTable.Rows.Count; n++)
                {
                    for (int i = 0; i < 3; i++)
                    {
                        ret.Add(dataTable.Rows[n][i]);

                    }
                }
            }

            return ret;

        }

        protected void cboxAll_Click(object sender, EventArgs e)
        {

            //lblErrMsg.Text = "国語がチェックされました";
            //warn_infoL = (List<warnworker_info>)Session["warn_infoL"];

            //dispworkerinfo(true);
            for (int i = 0; i < GridView1.Rows.Count; i++)
            {
                System.Web.UI.WebControls.CheckBox chk =
                    (System.Web.UI.WebControls.CheckBox)GridView1.Rows[i].Cells[0].FindControl("chkbox");
                chk.Checked = true;
            }


        }

        protected void UncboxAll_Click(object sender, EventArgs e)
        {

            //lblErrMsg.Text = "国語がチェックされました";
            //warn_infoL = (List<warnworker_info>)Session["warn_infoL"];

            //dispworkerinfo(true);
            for (int i = 0; i < GridView1.Rows.Count; i++)
            {
                System.Web.UI.WebControls.CheckBox chk =
                    (System.Web.UI.WebControls.CheckBox)GridView1.Rows[i].Cells[0].FindControl("chkbox");
                chk.Checked = false;
            }


        }
        //承認処理
        protected void confirm_Click(object sender, EventArgs e)
        {
            logger.Info(ComConst.INFO_LOG_START + sUserID + "承認ボタン押下処理");

            for (int i = 0; i < GridView1.Rows.Count; i++)
            {
                System.Web.UI.WebControls.CheckBox chk =
                    (System.Web.UI.WebControls.CheckBox)GridView1.Rows[i].Cells[0].FindControl("chkbox");
                if (chk.Checked)
                {
                    //検索キー設定
                    //免許番号
                    string pParam1 = GridView1.Rows[i].Cells[4].Text;
                    //氏名（姓）
                    string pParam2 = GridView1.Rows[i].Cells[2].Text;
                    //氏名（名）
                    string pParam3 = GridView1.Rows[i].Cells[3].Text;

                    //更新
                    bool ret1 = Isradio_enginner_info_tbl(pParam1, pParam2, pParam3,2);
                    if (ret1 == false)
                    {
                        lblErrMsg.Text = "承認処理が失敗しました。";
                    }
                    else
                    {
                        lblErrMsg.Text = "承認処理が成功しました。";
                    }

                }
            }
            //grid更新
            dispGrd();
            logger.Info(ComConst.INFO_LOG_END + sUserID + "承認ボタン押下処理");

        }
        //否認処理
        protected void Deny_Click(object sender, EventArgs e)
        {
            logger.Info(ComConst.INFO_LOG_START + sUserID + "否認ボタン押下処理");

            for (int i = 0; i < GridView1.Rows.Count; i++)
            {
                System.Web.UI.WebControls.CheckBox chk =
                    (System.Web.UI.WebControls.CheckBox)GridView1.Rows[i].Cells[0].FindControl("chkbox");
                if (chk.Checked)
                {
                    //検索キー設定
                    //免許番号
                    string pParam1 = GridView1.Rows[i].Cells[4].Text;
                    //氏名（姓）
                    string pParam2 = GridView1.Rows[i].Cells[2].Text;
                    //氏名（名）
                    string pParam3 = GridView1.Rows[i].Cells[3].Text;

                    //更新
                    bool ret1 = Isradio_enginner_info_tbl(pParam1, pParam2, pParam3,3);
                    if (ret1 == false)
                    {
                        lblErrMsg.Text = "否認処理が失敗しました。";
                    }
                    else
                    {
                        lblErrMsg.Text = "否認処理が成功しました。";
                    }


                }
            }

            //grid更新
            dispGrd();
            logger.Info(ComConst.INFO_LOG_END + sUserID + "否認ボタン押下処理");

        }
        //差戻し処理
        protected void Sashimodosi_Click(object sender, EventArgs e)
        {
            logger.Info(ComConst.INFO_LOG_START + sUserID + "差戻しボタン押下処理");

            for (int i = 0; i < GridView1.Rows.Count; i++)
            {
                System.Web.UI.WebControls.CheckBox chk =
                    (System.Web.UI.WebControls.CheckBox)GridView1.Rows[i].Cells[0].FindControl("chkbox");
                if (chk.Checked)
                {
                    //検索キー設定
                    //免許番号
                    string pParam1 = GridView1.Rows[i].Cells[4].Text;
                    //氏名（姓）
                    string pParam2 = GridView1.Rows[i].Cells[2].Text;
                    //氏名（名）
                    string pParam3 = GridView1.Rows[i].Cells[3].Text;

                    //更新
                    bool ret1 = Isradio_enginner_info_tbl(pParam1, pParam2,pParam3, 4);
                    if (ret1 == false)
                    {
                        lblErrMsg.Text = "差戻し処理が失敗しました。";
                    }
                    else
                    {
                        lblErrMsg.Text = "差戻し処理が成功しました。";
                    }

                }
            }
            //grid更新
            dispGrd();
            logger.Info(ComConst.INFO_LOG_END + sUserID + "差戻しボタン押下処理");


        }
        private bool Isradio_enginner_info_tbl(string pParam1, string pParam2,string pParam3, int shonin)
        {
            bool ret = false;
            string sSql = string.Empty;
            System.Data.DataTable dt = new System.Data.DataTable();


            m_ComFunc = (ComFunc)Session[ComConst.COM_FUNC];

            //氏名を分解する。
            //string[] name = null;
            //string nameBefore = pParam2.Replace(" ", "/");
            //name = nameBefore.Split('/');

            m_ComFunc.DB_BeginTranzaction();

            //SQL文作成
            sSql = "SELECT enginnerID ";
            sSql = sSql + " FROM radio_enginner_info_tbl";
            sSql = sSql + " WHERE license_number = '" + pParam1 + "'";
            sSql = sSql + " AND LastName = '" + pParam2.ToString() + "'";
            sSql = sSql + " AND FirstName = '" + pParam3.ToString() + "'";

            //SQL文発行
            ret = m_ComFunc.DB_Select(sSql, ref dt);
            if (ret)
            {

                if (dt.Rows.Count > 0)
                {

                    //選任/解任の承認済みの更新
                    bool flg = upd_selection_personal_tbl(dt.Rows[0][0].ToString(), shonin);
                    if (flg)
                    {
                        m_ComFunc.DB_Commit();

                    }
                    else
                    {
                        m_ComFunc.DB_Rollback();

                    }

                }
            }
            //Gridview更新
            //readselection_personal_tbl();
            return ret;
        }


        private bool upd_selection_personal_tbl(string pParam1,int shonin)
        {
            UserRole user = Session[ComConst.SESSION_USER_ROLE] as UserRole;
            sUserID = user.UserId;

            bool ret = false, bRet;
            string sSql = string.Empty;
            DataTable dataTable = new DataTable();

            sSql = "UPDATE  selection_personal_tbl ";
            sSql = sSql + " SET apploval_flag=" + "'" + shonin + "'";   //承認フラグ
            sSql = sSql + " ,  update_date = getdate() ";               //更新日時
            sSql = sSql + " ,  update_name=" + "'" + sUserID + "'";     //更新者
            sSql = sSql + "  WHERE enginnerID = '" + pParam1 + "'";

            ret = m_ComFunc.DB_Execute(sSql);
            if (ret)
            {
                bRet = true;
            }
            else
            {
                bRet = false;
            }

            return bRet;
        }

        private void readselection_personal_tbl()
        {
            string sSql = string.Empty;
            bool bRet = false, flg = false;
            System.Data.DataTable dataTable = null;

            {
                m_ComFunc = (ComFunc)Session[ComConst.COM_FUNC];

                string SQL_edt = createWhereStatus(
                                            cb1.Checked,
                                            cb2.Checked,
                                            cb3.Checked,
                                            cb4.Checked,
                                            cb5.Checked);

                //SQL文作成
                sSql = "SELECT  ";
                sSql = sSql + " B.license_number license_number,B.LastName +' '+  B.FirstName  name,A.enginnerID enginnerID,A.selectionID selectionID,A.request_date request_date,A.request_div,A.belong_company";
                sSql = sSql + " ,A.belong_department,A.jmcia_flag,A.sb_wcp,A.hokkaidou,A.touhoku,A.hokuriku,A.shinetsu,A.kantou,A.tokai,A.kinki,A.shikoku,A.chugoku,A.kyuushu,A.okinawa,A.apploval_flag,' ' dummy";
                sSql = sSql + " ,A.delete_flag,A.create_date,A.create_name,A.update_date,A.update_name  FROM selection_personal_tbl A,radio_enginner_info_tbl B  ";
                sSql = sSql + " WHERE A.enginnerID = B.enginnerID ";
                sSql = sSql + " AND  A.request_date >= '" + start_date.Text + "'";
                sSql = sSql + " AND A.belong_department = '" + department.Text + "'";
                sSql = sSql + " AND A.request_date <= '" + end_date.Text + "'";
                sSql = sSql + " AND A.delete_flag = '0'";

                if ((cb1.Checked == false) && (cb2.Checked == false) && (cb3.Checked == false) && (cb4.Checked == false) && (cb5.Checked == false))
                {
                    sSql = sSql + "  ";
                }
                else
                {
                    sSql = sSql + " AND ";
                }
                //Where句設定
                sSql = sSql + SQL_edt;

                //SQL文発行
                bRet = m_ComFunc.DB_Select(sSql, ref dataTable);

                if (bRet == false)
                {
                    lblErrMsg.Text = "検索できませんでした。";
                }

                //ステータス名取得する。
                editStatusKind(dataTable);
                //データ件数を表示
                lblErrMsg.Text = dataTable.Rows.Count.ToString();

                GridView1.ShowHeaderWhenEmpty = true;
                GridView1.DataSource = dataTable;
                GridView1.DataBind();
            }

        }

        private void dispGrd()
        {
            System.Data.DataTable dt = (System.Data.DataTable)Session["warn_infoL"];


            for (int i = 0; i < GridView1.Rows.Count; i++)
            {
                System.Web.UI.WebControls.CheckBox chk =
                    (System.Web.UI.WebControls.CheckBox)GridView1.Rows[i].Cells[0].FindControl("chkbox");
                if (chk.Checked)
                {
                    DataRow[] dr = dt.Select("license_number = '" + GridView1.Rows[i].Cells[4].Text + "'");
                    if (dr.Length > 0)
                    {
                        dt.Rows.Remove(dr[0]);
                        dt.AcceptChanges();
                    }
                }
            }
            GridView1.ShowHeaderWhenEmpty = true;
            GridView1.DataSource = dt;
            GridView1.DataBind();

        }

        protected void GridView1_PageIndexChanging(object sender, GridViewPageEventArgs e)
        {
            GridView1.PageIndex = e.NewPageIndex;
            dispGrd();
            GridView1.DataBind();
        }


    }
}