﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web.UI.WebControls;
using EmpCRM.common;
using EmpCRM.Dto;
using System.Web;
using log4net;

namespace EmpCRM
{
    public partial class EmployeeSearch : System.Web.UI.Page
    {
        //共通機能
        private ComFunc m_ComFunc = null;
        //従事者情報リスト
        private List<radio_enginner_info> rd_enginner_infoL = new List<radio_enginner_info>();
        //選任/解任情報リスト
        private List<selection_personal> selectionpersonL = new List<selection_personal>();
        //作業者ID
        private string enginnerID_key = string.Empty;
        //免許番号
        private string slicenseno = string.Empty;
        //氏名（姓）
        private string slastname = string.Empty;
        //氏名（名）
        private string sfirstname = string.Empty;
        //作業者ID
        private string pengineerid;
        //セクションID
        private string pselectionID;
        //申請日
        private string prequest_date;
        //ページ番号
        private string gPage_num = "1";
        //グローバルリスト
        private List<int> gIndex = new List<int> { };
        //ロガー生成
        private static log4net.ILog logger = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
        private string sUserID = "";

        protected void Page_Load(object sender, EventArgs e)
        {
            m_ComFunc = (ComFunc)Session[ComConst.COM_FUNC];

            if (!IsPostBack)
            {
                GridView1.DataSource = selection_personal_tblREAD();
                GridView1.DataBind();
                GridView1.Visible = false;
                //セッションにユーザIDを設定
                UserRole userRole = Session[ComConst.SESSION_USER_ROLE] as UserRole;
                //社内管理部門
                department.Text = userRole.DepartmentName.ToString();

                if (!LoginUtil.IsLogin(userRole))
                {
                    Response.Redirect("error.htm", false);
                }
                sUserID = userRole.UserId;

                ////コンポーネント初期化
                //cboxAll.Visible = false;
                //UncboxAll.Visible = false;
                ////workerInfo.Visible = false;
                //statusDetail.Visible = false;
                //PosEdit.Visible = false;
                //T2.Visible = false;
                //T100.Visible = false;
                //uupdateShonin.Visible = false;
                //Table2.Visible = false;
                ////ページサイズのゲット
                PageSize.Value = GridView3.PageSize.ToString();

                //所属会社（施工会社）
                m_ComFunc.companyList(BelongLtdList, true);
                //所属部署（施工会社）
                m_ComFunc.departmentList(BelongDeptList, true);

                if ((Session[ComConst.SELECTION_ID] != null) && (Session[ComConst.LICENSE_NUM] != null) && (Session[ComConst.LASTNAME] != null)
                  && (Session[ComConst.FIRSTNAME] != null) && (Session[ComConst.LASTNAME_KANA] != null) && (Session[ComConst.FIRSTNAME_KANA] != null))
                {
                    //部門毎選任解任一覧画面よりセッション情報取得する。
                    department.Text = m_ComFunc.getBumonByCode((string)Session[ComConst.SELECTION_ID], Session[ComConst.SESSION_BUMON_MASTER] as Dictionary<string, string>);
                    licenseno.Text = (string)Session[ComConst.LICENSE_NUM];
                    lastname.Text = (string)Session[ComConst.LASTNAME];
                    firstname.Text = (string)Session[ComConst.FIRSTNAME];
                    furi_familyname.Text = (string)Session[ComConst.LASTNAME_KANA];
                    furi_firstname.Text = (string)Session[ComConst.FIRSTNAME_KANA];

                    //検索機能実行させる。
                    searchfromParm();
                    uupdateShonin.Visible = true;

                }
                else
                {
                    //コンポーネント初期化
                    cboxAll.Visible = false;
                    UncboxAll.Visible = false;
                    //workerInfo.Visible = false;
                    statusDetail.Visible = false;
                    PosEdit.Visible = false;
                    T2.Visible = false;
                    T100.Visible = false;
                    uupdateShonin.Visible = false;
                    Table2.Visible = false;
                    //ページサイズのゲット
                    PageSize.Value = GridView3.PageSize.ToString();
                }
            }
            else
            {
                //選任/解任編集情報の反映する。
                if (updcb.Value == "posi")
                {
                    uupdateShonin.Visible = true;
                    cboxAll.Visible = true;
                    UncboxAll.Visible = true;
                    GridView1.Visible = true;



                    GridView1.DataSource = selection_personal_tblREAD();
                    GridView1.DataBind();
                    updcb.Value = "";
                    radiochk();

                }

            }
        }
        //戻る
        protected void modoru_Click(object sender, EventArgs e)
        {
            //セッションん情報をクリア
            Session["Hello"] = null;
            Session[ComConst.SELECTION_ID] = null;
            Session[ComConst.LICENSE_NUM] = null;
            Session[ComConst.LASTNAME] = null;
            Session[ComConst.FIRSTNAME] = null;
            Session[ComConst.LASTNAME_KANA] = null;
            Session[ComConst.FIRSTNAME_KANA] = null;
            department.Text = string.Empty;
            licenseno.Text = string.Empty;
            lastname.Text = string.Empty;
            firstname.Text = string.Empty;
            furi_familyname.Text = string.Empty;
            furi_firstname.Text = string.Empty;

            //メインメニュー画面に遷移する。
            Response.Redirect("Mainmenu.aspx", false);
        }
        //クリアする。
        protected void clear_Click(object sender, EventArgs e)
        {
            //各コンポーネント初期化
            licenseno.Text = string.Empty;
            lastname.Text = string.Empty;
            firstname.Text = string.Empty;
            furi_familyname.Text = string.Empty;
            furi_firstname.Text = string.Empty;

            //所属会社（施工会社）
            BelongLtdList.SelectedIndex = -1;
            //所属部署（施工会社）
            BelongDeptList.SelectedIndex = -1;

        }
        //検索する
        protected void search_Click(object sender, EventArgs e)
        {
            logger.Info(ComConst.INFO_LOG_START + sUserID + "検索ボタン押下処理");

            lblErrMsg.Text = "";
            //従事者情報検索する。
            selradio_enginner_info_tbl();

            T100.Visible = true;

            GridView1.ShowHeaderWhenEmpty = true;
            GridView1.DataSource = selection_personal_tblREAD();
            GridView1.DataBind();
            //コンポーネント表示
            if (GridView1.Rows.Count > 0)
            {
                uupdateShonin.Visible = true;
                cboxAll.Visible = true;
                UncboxAll.Visible = true;
            }
            logger.Info(ComConst.INFO_LOG_END + sUserID + "検索ボタン押下処理");

        }
        //検索機能実行させる。
        private void searchfromParm()
        {
            logger.Info(ComConst.INFO_LOG_START + sUserID + "検索ボタン自動押下処理");

            lblErrMsg.Text = "";
            //従事者情報検索する。
            selradio_enginner_info_tbl();

            //T100.Visible = true;
            GridView1.ShowHeaderWhenEmpty = true;
            GridView1.DataSource = selection_personal_tblREAD();
            GridView1.DataBind();
            //コンポーネント表示
            if (GridView1.Rows.Count > 0)
            {
                uupdateShonin.Visible = true;
                cboxAll.Visible = true;
                UncboxAll.Visible = true;
            }
            logger.Info(ComConst.INFO_LOG_END + sUserID + "検索ボタン自動押下処理");
        }
        ///<summary>
        //従事者情報検索
        ///</summary>
        ///<remarks>
        ///This is a test.
        ///</remarks>
        private void selradio_enginner_info_tbl()
        {
            //変数宣言
            string sSql = string.Empty;
            bool bRet = false;
            System.Data.DataTable dataTable = null;

            try
            {
                logger.Info(ComConst.INFO_LOG_START + sUserID + "従事者検索ボタン押下処理");

                //共通機能定義する。
                m_ComFunc = (ComFunc)Session[ComConst.COM_FUNC];
                //ダミー設定
                string dummy=string.Empty;
                string deptID = string.Empty;

                //SQL条件設定する。
                string SQL_edt = m_ComFunc.createWhere(
                                     licenseno.Text,                    //免許番号
                                     lastname.Text,                 //氏名（姓）
                                     firstname.Text,                //氏名（名）
                                     furi_familyname.Text,          //氏名フリガナ（姓）
                                     furi_firstname.Text,           //氏名フリガナ（名）
                                     BelongLtdList.SelectedValue,       //所属会社（施工会社）
                                     BelongDeptList.SelectedValue);   //所属部署（施工会社）
                //SQL文作成
                sSql = "SELECT ROW_NUMBER() OVER(ORDER BY [license_number] ASC) NO, ' ' license_name, ";
                sSql = sSql + "enginnerID,license_number,LastName,FirstName,LastName_Kana,FirstName_Kana";
                sSql = sSql + ",selectionID,belong_company,belong_department";
                sSql = sSql + " FROM enginner_info_search_view";
                //検索条件がすべて空の場合、
                if ((licenseno.Text == "") && (lastname.Text == "")
                    && (lastname.Text == "") && (furi_familyname.Text == "") && (firstname.Text == "") && (BelongLtdList.SelectedValue == "")
                    && (BelongDeptList.SelectedValue == "")
                    )
                {
                    sSql = sSql + "  ";
                }
                else
                {
                    sSql = sSql + " WHERE ";
                }
                //Where句設定
                sSql = sSql + SQL_edt;


                //SQL文発行
                bRet = m_ComFunc.DB_Select(sSql, ref dataTable);

                //DataTableの件数が0件の場合、
                if ((dataTable.Rows.Count == 0)|(bRet == false))
                {
                    cboxAll.Visible = false;
                    UncboxAll.Visible = false;
                    //T100.Visible = false;
                    uupdateShonin.Visible = false;
                    lblErrMsg.Text = "従事者情報が検索できませんでした。";
                }
                else
                {
                    //従事者情報をクリアする
                    rd_enginner_infoL.Clear();
                    for (int i = 0; i < dataTable.Rows.Count; i++)
                    {
                        //従事者情報のインスタンス
                        radio_enginner_info rd = new radio_enginner_info();

                        rd.no = Convert.ToInt32( dataTable.Rows[i]["No"]);
                        //免許番号
                        rd.license_number = dataTable.Rows[i]["license_number"].ToString();
                        //氏名（姓）
                        rd.LastName = dataTable.Rows[i]["LastName"].ToString();
                        //氏名（名）
                        rd.FirstName = dataTable.Rows[i]["FirstName"].ToString();
                        //生年月日
                        //rd.birthday = Convert.ToDateTime(dataTable.Rows[i]["birthday"]);
                        //作業者ID
                        rd.enginnerID = dataTable.Rows[i]["enginnerID"].ToString();
                        //氏名フリガナ（姓）
                        rd.LastName_Kana = dataTable.Rows[i]["LastName_Kana"].ToString();
                        //氏名フリガナ（名）
                        rd.FirstName_Kana = dataTable.Rows[i]["FirstName_Kana"].ToString();
                        //免許種別
                        //rd.license_type = dataTable.Rows[i]["license_type"].ToString();
                        //免許取得日
                       // rd.getlicense_date = Convert.ToDateTime(dataTable.Rows[i]["getlicense_date"].ToString());
                        //郵便番号
                        //rd.zip_code = dataTable.Rows[i]["zip_code"].ToString();
                        //都道府県
                        //rd.prefectures = dataTable.Rows[i]["prefectures"].ToString();
                        //市区町村
                        //rd.city = dataTable.Rows[i]["city"].ToString();
                        //町丁目
                        //rd.address = dataTable.Rows[i]["address"].ToString();
                        //業務い歴
                        //rd.business_backgrand = dataTable.Rows[i]["business_backgrand"].ToString();
                        //登録日
                        //rd.createdate = Convert.ToDateTime(dataTable.Rows[i]["createdate"].ToString());
                        //登録者
                        //rd.create_name = dataTable.Rows[i]["create_name"].ToString();
                        //更新日
                        //rd.updatedate = Convert.ToDateTime(dataTable.Rows[i]["updatedate"].ToString());
                        //更新者
                        //rd.update_name = dataTable.Rows[i]["update_name"].ToString();

                        rd_enginner_infoL.Add(rd);
                    }
                    //データ件数を表示
                    //lblErrMsg.Text = rd_enginner_infoL.Count().ToString();

                    //セッション情報の設定
                    Session[ComConst.rd_enginner_infoL] = rd_enginner_infoL;

                    //資格名取得
                    m_ComFunc.getLicense_name(dataTable);

                    T2.Visible = true;
                    PosEdit.Visible = true;
                    statusDetail.Visible = true;
                }
                //Grid設定
                GridView3.ShowHeaderWhenEmpty = true;
                GridView3.DataSource = dataTable;
                GridView3.DataBind();

                if ((dataTable.Rows.Count == 0) && (GridView2.Visible))
                {
                    Table2.Visible = false;
                    GridView2.Visible = false;
                }
                uupdateShoninRow.Visible = true;
                uupdateShonin.Visible = true;
                cboxAll.Visible = true;
                UncboxAll.Visible = true;
                GridView1.Visible = true;

                GridView1.Visible = true;

                logger.Info(ComConst.INFO_LOG_END + sUserID + "従事者検索ボタン押下処理");

            }
            catch (Exception ex)
            {
                lblErrMsg.Text = ex.Message;
                logger.Error("User:" + sUserID + ex.Message, ex);

            }

        }
        ///<summary>
        //j選任・解任 個別情報検索
        ///</summary>
        ///<remarks>
        ///This is a test.
        ///</remarks>
        private void selselection_personal_tbl()
        {
            logger.Info(ComConst.INFO_LOG_START + sUserID + "選任・解任 個別情報検索処理");
            //変数宣言
            string sSql = string.Empty;
            bool bRet = false;
            System.Data.DataTable dataTable = null;
            string dummy = string.Empty;

            try
            {
                //従事者IDのゲット
                string engID = (string)Session["enginnerID_key"];

                //共通機能設定
                m_ComFunc = (ComFunc)Session[ComConst.COM_FUNC];

                //SQL文作成
                sSql = "select ";
                sSql = sSql + " B.license_number license_number,B.LastName LastName,B.FirstName FirstName,A.enginnerID enginnerID,A.selectionID selectionID,A.request_date request_date,A.request_div,A.belong_company";
                sSql = sSql + " ,A.belong_department,A.jmcia_flag,A.sb_wcp,A.hokkaidou,A.touhoku,A.hokuriku,A.shinetsu,A.kantou,A.tokai,A.kinki,A.shikoku,A.chugoku,A.kyuushu,A.okinawa,A.apploval_flag,' ' dummy";
                sSql = sSql + " ,A.delete_flag,A.create_date,A.create_name,A.update_date,A.update_name  FROM selection_personal_tbl A,radio_enginner_info_tbl B  ";
                sSql = sSql + " WHERE A.enginnerID = B.enginnerID ";
                sSql = sSql + " AND A.apploval_flag = '" + 0 + "'";
                sSql = sSql + " AND A.delete_flag = '0'";
                //SQL文発行
                bRet = m_ComFunc.DB_Select(sSql, ref dataTable);
                if (bRet == false)
                {
                    lblErrMsg.Text = "検索できませんでした。";
                }
                //DataTableの件数が０件以上の場合、
                if (dataTable.Rows.Count > 0)
                {
                    //cboxAll.Visible = true;
                    //UncboxAll.Visible = true;
                    //T100.Visible = true;
                    ////uupdateShonin.Visible = true;

                    for (int i = 0; i < dataTable.Rows.Count; i++)
                    {
                        //選任/解任情報を設定
                        selection_personal sd = new selection_personal();

                        //作業者ID
                        sd.enginnerID = dataTable.Rows[i]["enginnerID"].ToString();
                        //セッションID
                        sd.selectionID = dataTable.Rows[i]["selectionID"].ToString();
                        //申請日
                        sd.request_date = dataTable.Rows[i]["request_date"].ToString();
                        //申請区分
                        sd.request_div = dataTable.Rows[i]["request_div"].ToString();
                        //所属会社（施工会社
                        sd.belong_company = dataTable.Rows[i]["belong_company"].ToString();
                        //所属部署（施工会社）
                        sd.belong_department = dataTable.Rows[i]["belong_department"].ToString();
                        //JMCIA
                        sd.jmcia_flag = Int32.Parse(dataTable.Rows[i]["jmcia_flag"].ToString());
                        //sb_wcp
                        sd.sb_wcp = Int32.Parse(dataTable.Rows[i]["sb_wcp"].ToString());
                        //北海道
                        sd.hokkaidou = dataTable.Rows[i]["hokkaidou"].ToString();
                        //東北
                        sd.touhoku = dataTable.Rows[i]["touhoku"].ToString();
                        //北陸
                        sd.hokuriku = dataTable.Rows[i]["hokuriku"].ToString();
                        //信越
                        sd.shinetsu = dataTable.Rows[i]["shinetsu"].ToString();
                        //関東
                        sd.kantou = dataTable.Rows[i]["kantou"].ToString();
                        //東海
                        sd.tokai = dataTable.Rows[i]["tokai"].ToString();
                        //近畿
                        sd.kinki = dataTable.Rows[i]["kinki"].ToString();
                        //四国
                        sd.shikoku = dataTable.Rows[i]["shikoku"].ToString();
                        //中国
                        sd.chugoku = dataTable.Rows[i]["chugoku"].ToString();
                        //九州
                        sd.kyuushu = dataTable.Rows[i]["kyuushu"].ToString();
                        //沖縄
                        sd.okinawa = dataTable.Rows[i]["okinawa"].ToString();
                        //承認フラグ
                        sd.apploval_flag = Int32.Parse(dataTable.Rows[i]["apploval_flag"].ToString());
                        //削除フラグ
                        sd.delete_flag = Int32.Parse(dataTable.Rows[i]["delete_flag"].ToString());
                        //作業日
                        sd.create_date = dataTable.Rows[i]["create_date"].ToString();
                        //作業者
                        sd.create_name = dataTable.Rows[i]["create_name"].ToString();
                        //更新日
                        sd.update_date = dataTable.Rows[i]["update_date"].ToString();
                        //更新者
                        sd.update_name = dataTable.Rows[i]["update_name"].ToString();


                        selectionpersonL.Add(sd);

                    }
                    cboxAll.Visible = true;
                    UncboxAll.Visible = true;
                    T100.Visible = true;
                    uupdateShonin.Visible = true;

                }
                else
                {
                    //コンポーネント非表示
                    //cboxAll.Visible = false;
                    //UncboxAll.Visible = false;
                    //T100.Visible = false;
                    //uupdateShonin.Visible = false;

                }
                //データ件数を表示
                GridView1.ShowHeaderWhenEmpty = true;
                GridView1.DataSource = dataTable;
                GridView1.DataBind();
                //ページング調節する。
                Session["selectionpersonL"] = selectionpersonL;
                logger.Info(ComConst.INFO_LOG_END + sUserID + "選任・解任 個別情報検索処理");

            }
            catch (Exception ex)
            {
                lblErrMsg.Text = ex.Message;
                logger.Error("User:" + sUserID + ex.Message, ex);

            }

        }


        ///<summary>
        //詳細状況表示の選択の押下、処理
        ///</summary>
        public void dispstatusDetail()
        {
            logger.Info(ComConst.INFO_LOG_START + sUserID + "詳細状況表示の選択ボタン押下処理");

            string enginnerID_key = string.Empty;

            List<radio_enginner_info> aList = (List<radio_enginner_info>)Session[ComConst.rd_enginner_infoL];
            int glPage_num = 0;
            //選択行があるか判断する。
            if (selitem.Value != "")
            {
                int selitemidx = Int32.Parse(selitem.Value);

                gPage_num = (string)Session["gPage_num"];
                if (gPage_num == null) gPage_num = "1";
                if (Int32.Parse(gPage_num) >= 2)
                {
                    glPage_num = (Int32.Parse(gPage_num) - 1) * GridView2.PageSize;
                }

                selitemidx = selitemidx + glPage_num;

                for (int iIndex = 0; iIndex < aList.Count(); iIndex++)
                {
                    if (selitemidx == iIndex)
                    {
                        enginnerID_key = aList[iIndex].enginnerID.ToString();
                        Session[ComConst.ENGINEERID] = aList[iIndex].enginnerID.ToString();
                        break;
                    }
                }
                //作業者IDをセッション情報に設定する。
                Session["enginnerID_key"] = enginnerID_key;
                string sSql = string.Empty;
                bool bRet = false;
                System.Data.DataTable dataTable = null;

                try
                {
                    m_ComFunc = (ComFunc)Session[ComConst.COM_FUNC];

                    //SQL文作成
                    sSql = "SELECT apploval_flag,'      ' dummy,request_div,belong_company,belong_department,";
                    sSql = sSql + " okinawa,kyuushu,chugoku,shikoku,kinki,tokai,kantou,shinetsu,hokuriku,touhoku,hokkaidou,ROW_NUMBER() OVER(ORDER BY [enginnerID] ASC) NO ";
                    sSql = sSql + " FROM selection_personal_tbl";


                    if (enginnerID_key == "")
                    {
                        sSql = sSql + " WHERE ";
                    }
                    else
                    {
                        sSql = sSql + " WHERE enginnerID = '" + enginnerID_key + "'";
                    }

                    sSql = sSql + " AND delete_flag = '0'";

                    sSql = sSql + " ORDER BY enginnerID";

                    //SQL文発行
                    bRet = m_ComFunc.DB_Select(sSql, ref dataTable);

                    if (bRet == false)
                    {
                        lblErrMsg.Text = "検索できませんでした。";
                        GridView2.Visible = false;
                        Table2.Visible = false;

                    }
                    else
                    {
                        //データ件数を表示
                        //lblErrMsg.Text = dataTable.Rows.Count.ToString();


                        string aa = dataTable.Rows[0][3].ToString();

                        //ステータス名取得する。
                        editStatus(dataTable);

                        if (dataTable.Rows.Count == 0)
                        {
                            Table2.Visible = false;
                            //Panel2.Visible = false;
                             GridView2.Visible = false;

                        }
                        else
                        {
                            Table2.Visible = true;
                            //Panel2.Visible = true;
                            GridView2.Visible = true;
                        }
                        //Grid設定
                        GridView2.ShowHeaderWhenEmpty = true;
                        GridView2.DataSource = dataTable;
                        GridView2.DataBind();
                    }

                }
                catch (Exception ex)
                {
                    lblErrMsg.Text = ex.Message;
                    logger.Error("User:" + sUserID + ex.Message, ex);
                }
            }
            else
            {
                lblErrMsg.Text = "従事者情報を選択して下さい。";
            }
            //従事者情報を表示する。
            rd_enginner_infoL = (List<radio_enginner_info>)Session[ComConst.rd_enginner_infoL];
            //Gridview1の設定
            selselection_personal_tbl();
            logger.Info(ComConst.INFO_LOG_END + sUserID + "詳細状況表示の選択ボタン押下処理");


        }
        ///<summary>
        ///Gridview2のRow作成
        ///</summary>
        ///<remarks>
        ///This is a test.
        ///</remarks>
        protected void GridView2_RowCreated(Object sender, System.Web.UI.WebControls.GridViewRowEventArgs e)
        {
            if (( e.Row.RowType == DataControlRowType.DataRow) || (e.Row.RowType == DataControlRowType.Header))
            {
                //ステータス
                e.Row.Cells[0].Visible = false;
            }

 
        }
        ///<summary>
        ///ステータスをステータス名に変換する。
        ///</summary>
        ///<remarks>
        ///This is a test.
        ///</remarks>
        private System.Data.DataTable editStatus(System.Data.DataTable dt)
        {
            DataTable ret_dt = null;

            for (int n = 0; n < dt.Rows.Count; n++)
            {
                int applova_flag = Int32.Parse(dt.Rows[n][0].ToString());
                if (applova_flag == 0)
                {
                    dt.Rows[n][1] = ComConst.MISHONIN; //未承認

                }
                else if (applova_flag == 1)
                {
                    dt.Rows[n][1] = ComConst.SHONIN_REQ; //承認依頼
                }
                else if (applova_flag == 2)
                {
                    dt.Rows[n][1] = ComConst.SHONIN_COMPLETED; //承認済み
                }
                else if (applova_flag == 3)
                {
                    dt.Rows[n][1] = ComConst.SHONIN_DENY;  //否認
                }
                else if (applova_flag == 4)
                {
                    dt.Rows[n][1] = ComConst.SHONIN_RETURN;  //差戻し
                }
            }           
            ret_dt = dt;
            return ret_dt;
 
        }
        ///<summary>
        //選任・解任 個別情報の表示
        ///</summary>
        ///<remarks>
        ///This is a test.
        ///</remarks>
        private void selSelectionPersonal_Info()
        {
            logger.Info(ComConst.INFO_LOG_START + sUserID + "選任・解任 個別情報の表示処理");
            //変数宣言
            string sSql = string.Empty;
            bool bRet = false;
            System.Data.DataTable dataTable = null;

            try
            {

                //共通機能の設定
                m_ComFunc = (ComFunc)Session[ComConst.COM_FUNC];

               //セッション情報より従事者情報のゲットする。 
               rd_enginner_infoL = (List<radio_enginner_info>)Session[ComConst.rd_enginner_infoL];

                for (int iIndex = 0; iIndex < rd_enginner_infoL.Count(); iIndex++)
                {
                    if (Int32.Parse(selitem.Value) == iIndex)
                    {
                        //免許番号
                        slicenseno = rd_enginner_infoL[iIndex].license_number.ToString();
                        //氏名（姓）
                        slastname = rd_enginner_infoL[iIndex].LastName.ToString();
                        //氏名（名）
                        sfirstname = rd_enginner_infoL[iIndex].FirstName.ToString();
                        //検索キー
                        enginnerID_key = rd_enginner_infoL[iIndex].enginnerID.ToString();
                        break;
                    }

                }

                //SQL文作成
                sSql = "SELECT enginnerID,selectionID,request_date,request_div,belong_company,belong_department,";
                sSql = sSql + " jmcia_flag,sb_wcp,hokkaidou,touhoku,hokuriku,shinetsu,kantou,tokai,kinki,shikoku,";
                sSql = sSql + " chugoku,kyuushu,okinawa,apploval_flag,delete_flag,create_date,create_name,update_date,update_name";
                sSql = sSql + "  FROM selection_personal_tbl";
                sSql = sSql + "  WHERE enginnerID = '" + enginnerID_key + "'";
                sSql = sSql + " AND apploval_flag = '1'";　　//1：承認依頼
                sSql = sSql + " AND delete_flag = '0'";　　　//削除フラグ

                sSql = sSql + " ORDER BY enginnerID";

                //SQL文発行
                bRet = m_ComFunc.DB_Select(sSql, ref dataTable);

                if (bRet == false)
                {
                    lblErrMsg.Text = "検索できませんでした。";
                    GridView2.Visible = false;
                }
                else
                {
                    //データ件数を表示
                    lblErrMsg.Text = dataTable.Rows.Count.ToString();

                    //ステータス名取得する。
                    editStatus(dataTable);

                    for (int i = 0; i < dataTable.Rows.Count; i++)
                    {
                        selection_personal sd = new selection_personal();
                        //作業者ID 
                        sd.enginnerID = dataTable.Rows[i]["enginnerID"].ToString();
                        //セクションID
                        sd.selectionID = dataTable.Rows[i]["selectionID"].ToString();
                        //申請日
                        sd.request_date = dataTable.Rows[i]["request_date"].ToString();
                        //申請区分
                        sd.request_div = dataTable.Rows[i]["request_div"].ToString();
                        //所属会社（施工会社）
                        sd.belong_company = dataTable.Rows[i]["belong_company"].ToString();
                        //所属部署（施工会社）
                        sd.belong_department = dataTable.Rows[i]["belong_department"].ToString();
                        //JMCIA
                        sd.jmcia_flag = Int32.Parse(dataTable.Rows[i]["jmcia_flag"].ToString());
                        //SBWCP
                        sd.sb_wcp = Int32.Parse(dataTable.Rows[i]["sb_wcp"].ToString());
                        //北海道
                        sd.hokkaidou = dataTable.Rows[i]["hokkaidou"].ToString();
                        //東北
                        sd.touhoku = dataTable.Rows[i]["touhoku"].ToString();
                        //北陸
                        sd.hokuriku = dataTable.Rows[i]["hokuriku"].ToString();
                        //信越
                        sd.shinetsu = dataTable.Rows[i]["shinetsu"].ToString();
                        //関東
                        sd.kantou = dataTable.Rows[i]["kantou"].ToString();
                        //東海
                        sd.tokai = dataTable.Rows[i]["tokai"].ToString();
                        //近畿
                        sd.kinki = dataTable.Rows[i]["kinki"].ToString();
                        //四国
                        sd.shikoku = dataTable.Rows[i]["shikoku"].ToString();
                        //中国
                        sd.chugoku = dataTable.Rows[i]["chugoku"].ToString();
                        //九州
                        sd.kyuushu = dataTable.Rows[i]["kyuushu"].ToString();
                        //沖縄
                        sd.okinawa = dataTable.Rows[i]["okinawa"].ToString();
                        //承認フラグ
                        sd.apploval_flag = Int32.Parse(dataTable.Rows[i]["apploval_flag"].ToString());
                        //削除フラグ
                        sd.delete_flag = Int32.Parse(dataTable.Rows[i]["delete_flag"].ToString());
                        //作成日
                        sd.create_date = dataTable.Rows[i]["create_date"].ToString();
                        //作成者
                        sd.create_name = dataTable.Rows[i]["create_name"].ToString();
                        //更新日
                        sd.update_date = dataTable.Rows[i]["update_date"].ToString();
                        //更新者
                        sd.update_name = dataTable.Rows[i]["update_name"].ToString();


                        selectionpersonL.Add(sd);

                    }
                //データ件数を表示
                lblErrMsg.Text = rd_enginner_infoL.Count().ToString();

                }
                Session["selectionpersonL"] = selectionpersonL;
                logger.Info(ComConst.INFO_LOG_END + sUserID + "選任・解任 個別情報の表示処理");

            }
            catch (Exception ex)
            {
                lblErrMsg.Text = ex.Message;
                logger.Error("User:" + sUserID + ex.Message, ex);
            }

        }

        ///<summary>
        //承認依頼をする。
        ///</summary>
        ///<remarks>
        ///This is a test.
        ///</remarks>
        protected void uupdateShonin_Click(object sender, EventArgs e)
        {
            logger.Info(ComConst.INFO_LOG_START + sUserID + "承認依頼ボタン押下処理");


            string sSql = string.Empty;
            bool ret = false;

            List<selection_personal> sList = (List<selection_personal>)Session["selectionpersonL"];

            try
            {
                //承認依頼項目のチェック
                if (chkShoninFlg() == false)
                {
                    lblErrMsg.Text = "承認依頼の項目を選択して下さい。";
                }
                else
                {
                    //セッション情報を獲得
                    m_ComFunc = (ComFunc)Session[ComConst.COM_FUNC];

                    //トランザクションの開始
                    m_ComFunc.DB_BeginTranzaction();

                    int idx = 0;

                    foreach (GridViewRow row in GridView1.Rows)
                    {
                        CheckBox cb = (CheckBox)row.FindControl("chkbox");
                        if (cb.Checked)
                        {
                            for (int iIndex = 0; iIndex < sList.Count(); iIndex++)
                            {
                                if (idx == iIndex)
                                {
                                    pengineerid = sList[iIndex].enginnerID.ToString();

                                    pselectionID = sList[iIndex].selectionID.ToString();
                                   
                                    //申請日を取得
                                    prequest_date = sList[iIndex].request_date.ToString();
                                    //SQL
                                    sSql = "UPDATE  selection_personal_tbl ";
                                    sSql = sSql + " SET apploval_flag=" + "'" + 1 + "'";       //承認フラグ
                                    sSql = sSql + "  WHERE enginnerID = '" + pengineerid + "'";
                                    sSql = sSql + "  AND selectionID = '" + pselectionID + "'";
                                    sSql = sSql + "  AND request_date = '" + prequest_date + "'";

                                    ret = m_ComFunc.DB_Execute(sSql);


                                    if (ret)
                                    {
                                        ret = true;
                                    }
                                    else
                                    {
                                        ret = false;
                                        break;

                                    }

                                }


                            }
                        }
                        idx++;

                    }


                    if (ret == true)
                    {
                        m_ComFunc.DB_Commit();
                        lblErrMsg.Text = "承認依頼の登録が成功しました。";
                    }
                    else
                    {
                        m_ComFunc.DB_Rollback();
                        lblErrMsg.Text = "承認依頼の登録の失敗しました。";
                    }
                    GridView1.DataSource = selection_personal_tblREAD();
                    GridView1.DataBind();
                
                }
                logger.Info(ComConst.INFO_LOG_END + sUserID + "承認依頼ボタン押下処理");

            }
            catch (Exception ex)
            {
                lblErrMsg.Text = ex.Message;
                ret = false;
                logger.Error("User:" + sUserID + ex.Message, ex);

            }

        }
        ///<summary>
        //j選任・解任 個別情報検索
        ///</summary>
        ///<remarks>
        ///This is a test.
        ///</remarks>
        private bool chkShoninFlg()
        {
            bool ret = false;
            for (int i = 0; i < GridView1.Rows.Count; i++)
            {
                System.Web.UI.WebControls.CheckBox chk =
                    (System.Web.UI.WebControls.CheckBox)GridView1.Rows[i].Cells[0].FindControl("chkbox");
                if (chk.Checked == true)
                {
                    ret = true;
                    break;

                }
            }

            return ret;
        }
        ///<summary>
        //全選択処理
        ///</summary>
        ///<remarks>
        ///This is a test.
        ///</remarks>
        protected void cboxAll_Click(object sender, EventArgs e)
        {
            logger.Info(ComConst.INFO_LOG_START + sUserID + "全選択ボタン押下処理");
            //dispworkerinfo(true);
            for (int i = 0; i < GridView1.Rows.Count; i++)
            {
                System.Web.UI.WebControls.CheckBox chk =
                    (System.Web.UI.WebControls.CheckBox)GridView1.Rows[i].Cells[0].FindControl("chkbox");
                chk.Checked = true;
            }
            logger.Info(ComConst.INFO_LOG_END + sUserID + "全選択ボタン押下処理");

        }

        ///<summary>
        //全選択処理
        ///</summary>
        ///<remarks>
        ///This is a test.
        ///</remarks>
        protected void UncboxAll_Click(object sender, EventArgs e)
        {
            logger.Info(ComConst.INFO_LOG_START + sUserID + "全解除ボタン押下処理");


            //dispworkerinfo(true);
            for (int i = 0; i < GridView1.Rows.Count; i++)
            {
                System.Web.UI.WebControls.CheckBox chk =
                    (System.Web.UI.WebControls.CheckBox)GridView1.Rows[i].Cells[0].FindControl("chkbox");
                chk.Checked = false;
            }

            logger.Info(ComConst.INFO_LOG_END + sUserID + "全解除ボタン押下処理");
        }
        ///<summary>
        //詳細状況表示処理
        ///</summary>
        ///<remarks>
        ///This is a test.
        ///</remarks>
        protected void statusDetail_Click(object sender, EventArgs e)
        {
            string ids = "";
            for (int i = 0; i < GridView3.Rows.Count; i++)
            {
                GridViewRow row = GridView3.Rows[i];
                RadioButton rb =
                  (RadioButton)row.FindControl("RadioButton1");
                if (rb != null)
                {
                    if (rb.Checked == true)
                    {
                        ids += GridView3.Rows[i].Cells[2].Text + " ";
                        selitem.Value = i.ToString();
                        Session["selitem"] = selitem.Value;
                        break;
                    }
                }
            }
            lblErrMsg.Text =  ids +"が選択されました。";
            //詳細状況表示
            dispstatusDetail();
        }
        private void radiochk()
        {
            int sel = Convert.ToInt32(selitem.Value);
            for (int i = 0; i < GridView3.Rows.Count; i++)
            {
                GridViewRow row = GridView3.Rows[i];
                RadioButton rb =
                    (RadioButton)row.FindControl("RadioButton1");
                if (rb != null)
                {
                    if (i == sel )
                    {
                        rb.Checked = true;
                        break;
                    }
                }
            }

        }

        ///<summary>
        //従事者情報一覧データ作成処理
        ///</summary>
        ///<remarks>
        ///This is a test.
        ///</remarks>
        protected void GridView3_RowCreated(object sender, GridViewRowEventArgs e)
        {
            for (int i = 0; i < GridView3.Rows.Count; i++)
            {
                GridViewRow row = GridView3.Rows[i];
                RadioButton rb =
                  (RadioButton)row.FindControl("RadioButton1");
                rb.Attributes["onClick"] = "getIndex(" + i +")";

            }

        }
        #region  ページング処理
        protected void GridView3_PageIndexChanging(object sender, GridViewPageEventArgs e)
        {
            GridView3.PageIndex = e.NewPageIndex;
            Session["gPage_num"] = (GridView3.PageIndex + 1).ToString();

            selradio_enginner_info_tbl();

            //GridView3.DataBind();

        }

        protected void GridView2_PageIndexChanging(object sender, GridViewPageEventArgs e)
        {
            GridView2.PageIndex = e.NewPageIndex;
            Session["gPage_num"] = (GridView2.PageIndex - 1).ToString();

            dispstatusDetail();
            GridView2.DataBind();

        }

        protected void GridView1_PageIndexChanging(object sender, GridViewPageEventArgs e)
        {
            GridView1.PageIndex = e.NewPageIndex;
            Session["gPage_num"] = (GridView1.PageIndex - 1).ToString();
            selselection_personal_tbl();

            GridView1.DataBind();

        }
        #endregion
        //承認依頼の対象データ検索
        private DataTable selection_personal_tblREAD()
        {
            logger.Info(ComConst.INFO_LOG_START + sUserID + "承認依頼の対象データ検索処理");

            string sSql = string.Empty;
            bool bRet = false;
            System.Data.DataTable dataTable = null;
            string dummy = string.Empty;

            try
            {
                //共通機能
                m_ComFunc = (ComFunc)Session[ComConst.COM_FUNC];

                //SQL文作成
                sSql = "select ";
                sSql = sSql + " B.license_number license_number,B.LastName LastName,B.FirstName FirstName,A.enginnerID enginnerID,A.selectionID selectionID,A.request_date request_date,A.request_div,A.belong_company";
                sSql = sSql + " ,A.belong_department,A.jmcia_flag,A.sb_wcp,A.hokkaidou,A.touhoku,A.hokuriku,A.shinetsu,A.kantou,A.tokai,A.kinki,A.shikoku,A.chugoku,A.kyuushu,A.okinawa,A.apploval_flag,' ' dummy";
                sSql = sSql + " ,A.delete_flag,A.create_date,A.create_name,A.update_date,A.update_name  FROM selection_personal_tbl A,radio_enginner_info_tbl B  ";
                sSql = sSql + " WHERE A.enginnerID = B.enginnerID ";
                sSql = sSql + " AND A.apploval_flag = '" + 0 + "'";
                sSql = sSql + " AND A.delete_flag = '0'";

                //SQL文発行
                bRet = m_ComFunc.DB_Select(sSql, ref dataTable);

                if (bRet == false)
                {
                    lblErrMsg.Text = "検索できませんでした。";
                }
                for (int i = 0; i < dataTable.Rows.Count; i++)
                {
                    //選任/解任個別情報
                    selection_personal sd = new selection_personal();
                    //作業者ID
                    sd.enginnerID = dataTable.Rows[i]["enginnerID"].ToString();
                    //セクションID
                    sd.selectionID = dataTable.Rows[i]["selectionID"].ToString();
                    //申請日
                    sd.request_date = dataTable.Rows[i]["request_date"].ToString();
                    //申請区分
                    sd.request_div = dataTable.Rows[i]["request_div"].ToString();
                    //所属会社（施工会社）
                    sd.belong_company = dataTable.Rows[i]["belong_company"].ToString();
                    //所属部署（施工会社）
                    sd.belong_department = dataTable.Rows[i]["belong_department"].ToString();
                    //JMCIA
                    sd.jmcia_flag = Int32.Parse(dataTable.Rows[i]["jmcia_flag"].ToString());
                    //SBWCP
                    sd.sb_wcp = Int32.Parse(dataTable.Rows[i]["sb_wcp"].ToString());
                    //北海道
                    sd.hokkaidou = dataTable.Rows[i]["hokkaidou"].ToString();
                    //東北
                    sd.touhoku = dataTable.Rows[i]["touhoku"].ToString();
                    //北陸
                    sd.hokuriku = dataTable.Rows[i]["hokuriku"].ToString();
                    //信越
                    sd.shinetsu = dataTable.Rows[i]["shinetsu"].ToString();
                    //関東
                    sd.kantou = dataTable.Rows[i]["kantou"].ToString();
                    //東海
                    sd.tokai = dataTable.Rows[i]["tokai"].ToString();
                    //近畿
                    sd.kinki = dataTable.Rows[i]["kinki"].ToString();
                    //四国
                    sd.shikoku = dataTable.Rows[i]["shikoku"].ToString();
                    //中国
                    sd.chugoku = dataTable.Rows[i]["chugoku"].ToString();
                    //九州
                    sd.kyuushu = dataTable.Rows[i]["kyuushu"].ToString();
                    //沖縄
                    sd.okinawa = dataTable.Rows[i]["okinawa"].ToString();
                    //承認フラグ
                    sd.apploval_flag = Int32.Parse(dataTable.Rows[i]["apploval_flag"].ToString());
                    //削除フラグ
                    sd.delete_flag = Int32.Parse(dataTable.Rows[i]["delete_flag"].ToString());
                    //作成日
                    sd.create_date = dataTable.Rows[i]["create_date"].ToString();
                    //作成者
                    sd.create_name = dataTable.Rows[i]["create_name"].ToString();
                    //更新日
                    sd.update_date = dataTable.Rows[i]["update_date"].ToString();
                    //更新者
                    sd.update_name = dataTable.Rows[i]["update_name"].ToString();


                    selectionpersonL.Add(sd);

                }
                Session["selectionpersonL"] = selectionpersonL;

                logger.Info(ComConst.INFO_LOG_END + sUserID + "承認依頼の対象データ検索処理");
            }
            catch (Exception ex)
            {
                lblErrMsg.Text = ex.Message;
                logger.Error("User:" + sUserID + ex.Message, ex);

            }

            return dataTable;

        }
        ///<summary>
        ///</summary>
        ///<remarks>
        ///This is a test.
        ///</remarks>
        //protected void chkbox_CheckedChanged(object sender, EventArgs e)
        //{
        //    CheckBox chkbx = (CheckBox)sender;
        //    int idx = 0;
        //    gIndex.Clear();
        //    foreach (GridViewRow row in GridView1.Rows)
        //    {
        //        CheckBox cb = (CheckBox)row.FindControl("chkbox");
        //        if (cb.Checked)
        //        {
        //            gIndex.Add(idx);
        //        }
        //        idx++;
        //    }
        //    Session["Hello"] = gIndex;

        //}
        ///<summary>
        //選任/解任更新一覧のデータセット処理
        ///</summary>
        ///<remarks>
        ///This is a test.
        ///</remarks>
        protected void GridView1_DataBound(object sender, EventArgs e)
        {
            List<string> ArrayValues = new List<string>();
            //ArrayValues.Add(String.Concat("'", cbHeader.ClientID, "'"));

            foreach (GridViewRow row in GridView1.Rows)
            {
                CheckBox cb = (CheckBox)row.FindControl("chkbox");
                cb.Attributes["onclick"] = "ChangeHeaderAsNeeded();";
                ArrayValues.Add(String.Concat("'", cb.ClientID, "'"));
            }

        }

        //所属部署（施工会社）の取得
        protected void BelongLtdList_SelectedIndexChanged(object sender, EventArgs e)
        {
            logger.Info(ComConst.INFO_LOG_START + sUserID + "所属部署（施工会社）取得処理");

            string sSql = string.Empty;
            bool bRet = false;
            System.Data.DataTable dt = new System.Data.DataTable();
            bool pbFirstFlg = true;
            string sTargetCompanyID = "";

            if (BelongLtdList.SelectedItem.Text != "")
            {
                //SQL文作成
                sSql = "SELECT distinct company_id ";
                sSql = sSql + " FROM company_mst WHERE del_flag = 0";
                sSql = sSql + " AND company_name= '" + BelongLtdList.SelectedItem.Text + "'";

                //SQL文発行
                bRet = m_ComFunc.DB_Select(sSql, ref dt);
                if (dt != null)
                {
                    sTargetCompanyID = dt.Rows[0][0].ToString();
                }

                //初期化
                BelongDeptList.Items.Clear();
                //空白設定フラグによる判別
                if (pbFirstFlg)
                {
                    BelongDeptList.Items.Add("");
                }

                //SQL文作成
                sSql = "SELECT distinct company_id,section_id,section_name";
                sSql = sSql + " FROM section_mst WHERE del_flag = 0";
                sSql = sSql + " AND company_id ='" + sTargetCompanyID + "'";
                sSql = sSql + " ORDER BY company_id ";

                //SQL文発行
                bRet = m_ComFunc.DB_Select(sSql, ref dt);
                if (bRet)
                {
                    for (int i = 0; i < dt.Rows.Count; i++)
                    {

                        BelongDeptList.Items.Add(dt.Rows[i][2].ToString());
                    }

                }
            }
        

            logger.Info(ComConst.INFO_LOG_END + sUserID + "所属部署（施工会社）取得処理");

        }



    }
}