﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using EmpCRM.Dto;
using EmpCRM.common;

namespace EmpCRM
{
    public partial class Mainmenu : System.Web.UI.Page
    {
        protected override void OnPreLoad(EventArgs e)
        {
            base.OnPreLoad(e);
            ComFunc m_ComFunc = (ComFunc)Session[ComConst.COM_FUNC];

            UserRole userRole = Session[ComConst.SESSION_USER_ROLE] as UserRole;

            if (!LoginUtil.IsLogin(userRole))
            {
                Response.Redirect("error.htm", false);
            }
            else
            {
                btn1.Enabled = false; //従事者・選任/解任情報  一括登録
                btn2.Enabled = false; //部門毎従事者選任/解任一覧
                btn3.Enabled = false; //選任/解任 承認
                btn4.Enabled = false; //選任/解任日設定
                btn5.Enabled = false; //選任/解任 申請リスト出力
                btn6.Enabled = false; //選任/解任 申請状況確認
                btn7.Enabled = false; //従事者情報 編集画面
                btn8.Enabled = false; //選任/解任情報 検索・設定
                btn9.Enabled = false; //会社情報編集
                btnDepartmentChange.Enabled = false;//部門付替え

                //システム部門の場合
                if (userRole.Roles.Contains(ComConst.SYSTEM_OPERATE_USER))
                {
                    //データ登録系
                    btn1.Enabled = true; //従事者・選任/解任情報  一括登録
                    btn7.Enabled = true; //従事者情報 編集画面
                    btn8.Enabled = true; //選任/解任情報 検索・設定
                    btn2.Enabled = true; //部門毎従事者選任/解任一覧
                    btn3.Enabled = true; //選任/解任 承認
                    btn9.Enabled = true; //会社情報編集
                    btnDepartmentChange.Enabled = true;//部門付替え
                }
                //承認ユーザ権限
                else if (userRole.Roles.Contains(ComConst.APPROVAL_USER))
                {
                    //データ登録系
                    btn1.Enabled = true; //従事者・選任/解任情報  一括登録
                    btn7.Enabled = true; //従事者情報 編集画面
                    btn8.Enabled = true; //選任/解任情報 検索・設定
                    btn2.Enabled = true; //部門毎従事者選任/解任一覧
                    btn3.Enabled = true; //選任/解任 承認
                }
                //申請ユーザ権限
                else if (userRole.Roles.Contains(ComConst.REQUEST_USER))
                {
                    //データ登録系
                    btn1.Enabled = true; //従事者・選任/解任情報  一括登録
                    btn7.Enabled = true; //従事者情報 編集画面
                    btn8.Enabled = true; //選任/解任情報 検索・設定
                }


                if (userRole.Areas != null && userRole.Areas.Count() > 0)
                {
                    //地域
                    btn4.Enabled = true; //選任/解任日設定
                    btn5.Enabled = true; //選任/解任 申請リスト出力
                    btn6.Enabled = true; //選任/解任 申請状況確認
                }
            }
            ////ユーザ名、ログイン日時表示暫定対応
            //Panel PnlUserInfo = new Panel();
            //Label lblUserName = new Label();
            //lblUserName.Text = string.Format("ユーザ名：{0}", userRole.UserName);

            //Label lblLoginDateTime = new Label();
            //lblLoginDateTime.Text = string.Format("ログイン日時：{0}",userRole.LoginDateTime.ToString("yyyy/MM/dd hh:mm:ss"));

            //PnlUserInfo.Controls.Add(lblUserName);
            //PnlUserInfo.Controls.Add(lblLoginDateTime);

            //this.Controls.Add(PnlUserInfo);
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            btn1.Visible = true;
            //this.btn1.Click += new System.EventHandler(this.btn1_Click);
        }

        //従事者・選任/解任情報 一括登録
        protected void btn1_Click(object sender, EventArgs e)
        {
            Response.Redirect("EmployeeAllAdd.aspx", false);
        }

        //部門毎選任/解任一覧
        protected void btn2_Click(object sender, EventArgs e)
        {
            Response.Redirect("BumonSelectedMissi.aspx", false);
        }

        //選任解任承認
        protected void btn3_Click(object sender, EventArgs e)
        {
            Response.Redirect("EmployeeMissionPermit.aspx", false);
        }

        //選任/解任日選択画面
        protected void btn4_Click(object sender, EventArgs e)
        {
            Response.Redirect("EmployeeSelectedDateAdd.aspx", false);
        }

        //選任/解任申請リスト出力画面
        protected void btn5_Click(object sender, EventArgs e)
        {
            Response.Redirect("ApplicationListPrint.aspx", false);
        }

        //選任/解任 申請状況確認画面
        protected void btn6_Click(object sender, EventArgs e)
        {
            Response.Redirect("ApplicationStatusList.aspx", false);
        }

        //従事者情報編集画面
        protected void btn7_Click(object sender, EventArgs e)
        {
            Response.Redirect("EmployeeEdit.aspx", false);
        }

        //選任/解任情報 検索・設定
        protected void btn8_Click(object sender, EventArgs e)
        {
            Response.Redirect("EmployeeSearch.aspx", false);
        }

        //会社情報編集
        protected void btn9_Click(object sender, EventArgs e)
        {
            Response.Redirect("CompanyInfo.aspx", false);
        }

        //部門付け替え
        protected void btnDepartmentChange_Click(object sender, EventArgs e)
        {
            Response.Redirect("DepartmentChange.aspx", false);
        }

    }
}