﻿#region " DBアクセス共通クラス"
//-----------------------------------------------------------------------
//【ファイル名】   共通関数クラス
//【機　能】      
//【備　考】  　　
//【作成者】      nakamura
//【作成日】      2017/1/28
//【修正履歴】    YYYY/MM/DD 修正内容　修正者
//-----------------------------------------------------------------------
#endregion
using OfficeOpenXml;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.UI.WebControls;
using EmpCRM.Dto;
using System.Reflection;
using log4net;
using System.Text.RegularExpressions;

namespace EmpCRM.common
{
    public class ComFunc
    {
        private static ILog logger = LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);

        #region メンバー
//        private ComFunc m_ComFunc = null;
        //ログインユーザID
        private string m_sUserID = string.Empty;
        //DBアクセスクラス
        private ComDB m_ComDB = new ComDB();

        #endregion

        #region コンストラクタ
        public ComFunc(string psUserID)
        {
            //ログインユーザIDの設定
            m_sUserID = psUserID;
            //DBアクセスクラスのインスタンス生成
            m_ComDB = new ComDB();
        }
        public ComFunc()
        {

        }

        #endregion

        #region DB_Connect
        //
        //
        public Boolean DB_Connect(string connectstr)
        {
            Boolean ret;
            try
            {
                m_ComDB.DB_Connect(connectstr);
                ret = true;

            }
            catch (Exception ex)
            {
                logger.Error(ex.Message, ex);
                ret = false;
            }
            return ret;

        }

        #endregion


        #region DB_Disconnect
        public void DB_Disconnect()
        {
            m_ComDB.DB_Disconnect();
        }

        #endregion DB_Disconnect

        #region DB_Select
        public Boolean DB_Select(string psSql, ref  DataTable pdatatable)
        {

            SqlDataAdapter adptData = new SqlDataAdapter();

            Boolean ret = false;



            try
            {

                //SQL文発行

                ret = m_ComDB.DB_Select(psSql, ref adptData);


                adptData.SelectCommand.CommandType = CommandType.Text;

                DataSet dsData = new DataSet();
                //データの取得
                adptData.Fill(dsData);

                pdatatable = dsData.Tables[0];

                //Me.DataGridView1.DataSource = ds.Tables(0);

                adptData.Dispose();
                dsData.Dispose();

                ret = true;

            }
            catch (Exception ex)
            {

                ret = false;
            }
            return ret;
        }
        #endregion

        #region SelectByParams

        public bool DB_Select(string sql, List<SqlParameter> sqlParams, ref DataTable result)
        {
            try
            {
                return m_ComDB.DB_SelectByParams(sql, sqlParams, ref result);;
            }
            catch(Exception ex)
            {
                throw ex;
            }
        }
        #endregion SelectByParams

        #region
        public bool DB_BeginTranzaction()
        {
            bool ret;
            try
            {
                m_ComDB.DB_BeginTranzaction();
                ret = true;
            }
            catch
            {
                ret = false;
            }
            return ret;

        }
        #endregion
        #region
        public bool DB_Execute(string psSql)
        {
            bool ret;
            try
            {
                m_ComDB.DB_Execute(psSql);
                ret = true;
            }
            catch (Exception ex)
            {
                ret = false;
            }
            return ret;

        }
        public bool DB_ExecuteforErrMsg(string psSql, ref string message)
        {
            bool ret;
            try
            {
                m_ComDB.DB_Execute(psSql);
                ret = true;
            }
            catch (SqlException ex)
            {
                switch (ex.Number)
                {
                    case 1222: // 外部キー制約違反
                        message = "対象データにロックがかかっていました。";
                        break;

                    case 2601: // 一意キー制約違反
                        message = "	同一免許番号で氏名の違う人が登録済みです。";
                        break;
                    case 2627: // PK制約違反
                        message = "同一免許番号で氏名の違う人が登録済みです。";
                        break;

                    default:
                        throw;
                } 
                ret = false;
            }
            return ret;

        }
        #endregion

        #region DB_Execute(param)
        /// <summary>
        /// SQLパラメータを利用したSQL実行（Insert、Update、Delete）
        /// </summary>
        /// <param name="psSql"></param>
        /// <param name="sqlParams"></param>
        /// <returns></returns>
        public bool DB_Execute(string psSql, List<SqlParameter> sqlParams)
        {
            bool ret;
            int rownum = 0;
            try
            {
                rownum = m_ComDB.DB_ExecuteByParams(psSql, sqlParams);
                if (rownum > 0)
                {
                    ret = true;
                }
                else
                {
                    ret = false;
                }
            }
            catch (Exception ex)
            {
                throw ex;
                //ret = false;
            }
            return ret;
        }
        #endregion

        #region
        public bool DB_Commit()
        {
            bool ret;
            try
            {
                m_ComDB.DB_Commit();
                ret = true;
            }
            catch
            {
                ret = false;
            }
            return ret;

        }
        #endregion
        #region
        public bool DB_Rollback()
        {
            bool ret;
            try
            {
                m_ComDB.DB_Rollback();
                ret = true;
            }
            catch
            {
                ret = false;
            }
            return ret;

        }
        #endregion

        #region JMCIA設定
        public void jmiciaList(System.Web.UI.WebControls.DropDownList pJmcia,  Boolean pbFirstFlg = false)
        {
            string sSql = string.Empty;
            bool bRet = false;
            System.Data.DataTable dt = new System.Data.DataTable();

            //初期化
            pJmcia.Items.Clear();
            //空白設定フラグによる判別
            if (pbFirstFlg)
            {
                pJmcia.Items.Add("");
            }
            //SQL文作成
            sSql = "SELECT distinct code_name,code ";
            sSql = sSql + " FROM code_mst";
            sSql = sSql + " WHERE code_type = '06'";
            sSql = sSql + " ORDER BY code ";


            //SQL文発行
            bRet = DB_Select(sSql, ref dt);
            if (bRet)
            {
                for (int i = 0; i < dt.Rows.Count; i++)
                {

                    pJmcia.Items.Add(dt.Rows[i][0].ToString());
                }

            }



        }
        #endregion
        #region 部門リスト設定
        public void bumoMasterList(System.Web.UI.WebControls.DropDownList BumonList,Dictionary<string, string> bumon, Boolean pbFirstFlg = false)
        {
            string sSql = string.Empty;
            bool bRet = false;
            System.Data.DataTable dt = new System.Data.DataTable();

            BumonList.Items.Clear();
            //空白設定フラグによる判別
            //if (pbFirstFlg)
            //{
            //    BumonList.Items.Add("");
            //}

            //初期化
            BumonList.Items.Clear();
            //空白設定フラグによる判別
            //BumonList.DataSource = bumon;
            //BumonList.DataTextField = "Value";
            //BumonList.DataValueField = "Key";
            //BumonList.DataBind();

            foreach (var p in bumon)
            {
                if (pbFirstFlg)
                {
                    BumonList.Items.Add("");
                    pbFirstFlg = false;
                }

                if (p.Value != "")
                {
                    BumonList.Items.Add(p.Value);
                }
                //                Console.WriteLine(string.Format("{0}:{1}", p.Key, p.Value));
            }



        }
        #endregion
        #region 部門リスト検索
        public string getBumonIdonSystem(int idx, Dictionary<string, string> bumon)
        {
            string ret="";

            //初期化
            int ii = 0;
            foreach (var p in bumon)
            {
                if (p.Value != "")
                {
                    if(ii ==idx)
                    {
                         ret = p.Key;
                         break;
                    }

                }
                ii++;

            }

            return ret;


        }
        #endregion
        #region 部門リスト検索 by 部門コード
        public string getBumonByCode(string idx, Dictionary<string, string> bumon)
        {
            string ret = "";

            //初期化
            foreach (var p in bumon)
            {
                if (p.Key ==  idx)
                {
                    ret = p.Value;
                    break;
                }


            }

            return ret;


        }
        #endregion

        #region SB/WCP設定
        public void sbwcpList(System.Web.UI.WebControls.DropDownList psbwcp, Boolean pbFirstFlg = false)
        {
            string sSql = string.Empty;
            bool bRet = false;
            System.Data.DataTable dt = new System.Data.DataTable();

            //初期化
            psbwcp.Items.Clear();
            //空白設定フラグによる判別
            if (pbFirstFlg)
            {
                psbwcp.Items.Add("");
            }
            //SQL文作成
            sSql = "SELECT distinct code_name,code ";
            sSql = sSql + " FROM code_mst";
            sSql = sSql + " WHERE code_type = '07'";
            sSql = sSql + " ORDER BY code ";

            //SQL文発行
            bRet = DB_Select(sSql, ref dt);
            if (bRet)
            {
                for (int i = 0; i < dt.Rows.Count; i++)
                {

                    psbwcp.Items.Add(dt.Rows[i][0].ToString());
                }

            }

        }
        #endregion
        #region 種別設定
        public void kindList(System.Web.UI.WebControls.DropDownList pKind, Boolean pbFirstFlg = false)
        {
            //初期化
            pKind.Items.Clear();
            //空白設定フラグによる判別
            if (pbFirstFlg)
            {
                pKind.Items.Add("");
            }
            pKind.Items.Add("新任");
            pKind.Items.Add("選任");
            pKind.Items.Add("解任");
        }
        #endregion

        #region 所属会社（施工会社）設定
        public void companyList(System.Web.UI.WebControls.DropDownList pCompany, Boolean pbFirstFlg = false)
        {
            string sSql = string.Empty;
            bool bRet = false;
            System.Data.DataTable dt = new System.Data.DataTable();

            //初期化
            pCompany.Items.Clear();
            //空白設定フラグによる判別
            if (pbFirstFlg)
            {
                pCompany.Items.Add("");
            }
            //SQL文作成
            sSql = "SELECT distinct company_id,company_name ";
            sSql = sSql + " FROM company_mst WHERE del_flag=0";
            sSql = sSql + " ORDER BY company_id ";

            //SQL文発行
            bRet = DB_Select(sSql, ref dt);
            if (bRet)
            {
                for (int i = 0; i < dt.Rows.Count; i++)
                {

                    pCompany.Items.Add(dt.Rows[i][1].ToString());
                }

            }

        }
        #endregion

        #region 所属部署（施工会社）設定
        public void departmentList(System.Web.UI.WebControls.DropDownList pDept, Boolean pbFirstFlg = false)
        {
            string sSql = string.Empty;
            bool bRet = false;
            System.Data.DataTable dt = new System.Data.DataTable();

            //初期化
            pDept.Items.Clear();
            //空白設定フラグによる判別
            if (pbFirstFlg)
            {
                pDept.Items.Add("");
            }

            //SQL文作成
            sSql = "SELECT distinct company_id,section_id,section_name";
            sSql = sSql + " FROM section_mst WHERE del_flag=0";
            sSql = sSql + " ORDER BY company_id ";

            //SQL文発行
            bRet = DB_Select(sSql, ref dt);
            if (bRet)
            {
                for(int i = 0 ;i < dt.Rows.Count;i++)
                {

                    pDept.Items.Add(dt.Rows[i][2].ToString());
                }

            }


        }
        #endregion

        #region　選任解任用WHERE句
        public string createWhere(
                                string plicenseno, 
                                string plastname,
                                string pfirstname,
                                string pfuri_familyname,
                                string pfuri_firstname,
                                string pBelongCompany,      //所属会社
                                string pBelognDept)         //所属部署
        {
            string ret = string.Empty;

            // Dictionaryの初期化
            Dictionary<string, string> map = new Dictionary<string, string>();

            map.Add("license_number", plicenseno);
            map.Add("lastname", plastname);
            map.Add("firstname", pfirstname);
            map.Add("LastName_Kana", pfuri_familyname);
            map.Add("FirstName_Kana", pfuri_firstname);
            map.Add("belong_company", pBelongCompany);
            map.Add("belong_department", pBelognDept);

            int andCount = 0;
            // キーと値のペアを列挙
            foreach (var p in map)
            {
                if (p.Value != "")
                {
                    andCount++;
                }

                //Console.WriteLine(string.Format("{0}:{1}", p.Key, p.Value));
            }
            if (andCount == 0)
            {
                ret = "";
            }
            else if (andCount == 1)
            {
                foreach (var p in map)
                {
                    if (p.Value != "")
                    {

                        ret = string.Format("{0} LIKE '%{1}%'", p.Key, p.Value);
                    }
                }

            }
            else　//1以上
            {
                int jcnt = 0;
                foreach (var p in map)
                {
                    if (p.Value != "")
                    {
                        if (andCount - 1 == jcnt)
                        {
                            //免許取得日
                            ret += string.Format("{0} = '{1}'", p.Key, p.Value);
                        }
                        else
                        {
                            ret += string.Format("{0} LIKE '%{1}%' AND ", p.Key, p.Value);
                        }

                        jcnt++;
                    }

                }
                //ret = ret1;
            }
            return ret;

        }

        #endregion
        #region　無線従事者情報用WHERE句
        public string createWhereEdit(
                                string plicenseno,
                                string plastname,
                                string pfirstname,
                                string pfuri_familyname,
                                string pfuri_firstname,
                                string pgetlicense_date)
        {
            string ret = string.Empty;

            // Dictionaryの初期化
            Dictionary<string, string> map = new Dictionary<string, string>();

            map.Add("license_number", plicenseno);
            map.Add("lastname", plastname);
            map.Add("firstname", pfirstname);
            map.Add("LastName_Kana", pfuri_familyname);
            map.Add("FirstName_Kana", pfuri_firstname);
            map.Add("getlicense_date", pgetlicense_date);

            int andCount = 0;
            // キーと値のペアを列挙
            foreach (var p in map)
            {
                if (p.Value != "")
                {
                    andCount++;
                }

                //Console.WriteLine(string.Format("{0}:{1}", p.Key, p.Value));
            }
            if (andCount == 0)
            {
                ret = "";
            }
            else if (andCount == 1)
            {
                foreach (var p in map)
                {
                    if (p.Value != "")
                    {

                        ret = string.Format("{0} LIKE '%{1}%'", p.Key, p.Value);
                    }
                }

            }
            else　//1以上
            {
                int jcnt = 0;
                foreach (var p in map)
                {
                    if (p.Value != "")
                    {
                        if (andCount - 1 == jcnt)
                        {
                            //免許取得日
                            ret += string.Format("{0} = '{1}'", p.Key, p.Value);
                        }
                        else
                        {
                            ret += string.Format("{0} LIKE '%{1}%' AND ", p.Key, p.Value);
                        }

                        jcnt++;
                    }

                }
                //ret = ret1;
            }
            return ret;

        }

        #endregion

        #region 形式チェック
        public bool formatCHK(string license_number, ref List<string> errMsg)
        {
            bool ret = false;

            ret = this.IsCorrectLicenseNumber(license_number);

            if (!ret)
            {
                errMsg.Add("'E");
                errMsg.Add("'100002");
                errMsg.Add("免許証番号に誤りがあります");
            }
            return ret;

        }
        #region 資格名取得
        public void  getLicense_name(System.Data.DataTable dt)
        {
            bool  bRet;
            string sSql = string.Empty;
            DataTable dataTable = new DataTable();

            for (int n = 0; n < dt.Rows.Count; n++)
            {

                string s2 = dt.Rows[n]["license_number"].ToString().Substring(1, 1); //2番目

                string s3 = dt.Rows[n]["license_number"].ToString().Substring(2, 1); //3番目
                string s4 = dt.Rows[n]["license_number"].ToString().Substring(3, 1); //4番目

                //SQL文作成
                sSql = "SELECT distinct code_name ";
                sSql = sSql + " FROM code_mst";
                sSql = sSql + " WHERE code_type ='01'";
                if ((s2.Equals("A")) || (s2.Equals("B")))
                {
                    sSql = sSql + " AND code = '" + s3 + "'";

                }
                else
                {
                    sSql = sSql + " AND code = '" + s4 + "'";
                }
                
                //SQL文発行
                bRet = DB_Select(sSql, ref dataTable);
                if (dataTable.Rows.Count > 0)
                {
                    dt.Rows[n]["license_name"] = dataTable.Rows[0][0].ToString();
                }
                else
                {
                    dt.Rows[n]["license_name"] = "";
                }

                //return dt;
            }
 
        }
        #endregion

        #endregion
        #region 必須チェック
        public bool mandatoryCHK(string pParam, int no,ref List<string> errMsg)
        {
            bool ret = false;

            if (pParam == "")
            {
                switch(no)
                {
                    case 1:             //免許証番号
                        errMsg.Add("'E");
                        errMsg.Add("100001");
                        errMsg.Add("免許証番号を入力してください");
                        ret = false;
                        break;
                    case 3:      //氏名（姓）
                        errMsg.Add("'E");
                        errMsg.Add("100001");
                        errMsg.Add("氏名（姓）を入力してください");
                        ret = false;
                        break;
                    case 4:      //氏名（名）
                        errMsg.Add("'E");
                        errMsg.Add("100001");
                        errMsg.Add("氏名（名）を入力してください");
                        ret = false;
                        break;
                    default:
                        break;
                }


            }
            else
            {
                 switch(no)
                {
                    case 2:             //免許取得日(年月日)
                        //日付妥当性チェック YYY/MM/DD
                        DateTime d1;
                        bool res1 = DateTime.TryParse(pParam, out d1);
                        if (res1 == false)
                        {
                            errMsg.Add("'E");
                            errMsg.Add("100005");
                            errMsg.Add("免許取得日が不正です。");
                            ret = false;
                        }
                        else

                        {
                            ret = true;
                        }
                        break;
                    case 5:      //氏名フリガナ（姓）
                        //文字種チェック
                        //if (Regex.IsMatch(pParam, "^[ァ-ヶー]*$") == false)  
                        //{
                         //ひらがなチェック
                        if (!(System.Text.RegularExpressions.Regex.IsMatch(pParam, @"^\p{IsHiragana}+$")))
                        {
                            errMsg.Add("'E");
                            errMsg.Add("100003");
                            errMsg.Add("氏名ふりがな（姓）を全角ひらがなで入力してください");
                            ret = false;
                        }
                        break;
                    case 6:      //氏名フリガナ（名）
                        //文字種チェック
                        char[] chArray2 = pParam.ToCharArray();

                        foreach (char c in chArray2)
                        {
                            //if (Regex.IsMatch(pParam, "^[ァ-ヶー]*$") == false)
                            //{
                            //ひらがなチェック
                            if (!(System.Text.RegularExpressions.Regex.IsMatch(pParam, @"^\p{IsHiragana}+$")))
                            {
                                errMsg.Add("'E");
                                errMsg.Add("100003");
                                errMsg.Add("氏名ふりがな（名）を全角ふりがなで入力してください");
                                ret = false;
                            }
                        }

                        break;
                    default:
                        break;

                }

            }

            return ret;

        }

        #endregion
        #region  /従事者情報DBに免許番号チェック
        //<summary>
        //従事者情報DBに免許番号が同じで、氏名が違うデータの存在チェック
        //</summary>
        public bool IsExistRadioMenKey(string pParam1, string pParam2, string pParam3, ref List<string> errMsg)
        {
            bool ret = false, bRet;
            string sSql = string.Empty;
            DataTable dataTable = new DataTable();

            //SQL文作成
            sSql = "SELECT license_number,LastName,firstName ";
            sSql = sSql + " FROM radio_enginner_info_tbl";
            sSql = sSql + " WHERE license_number = '" + pParam1 + "'";

            //SQL文発行
            bRet = DB_Select(sSql, ref dataTable);
            if (dataTable.Rows.Count > 0)
            {
                string lname = dataTable.Rows[0][1].ToString();
                string fname = dataTable.Rows[0][2].ToString();

                if ((lname.Equals(pParam2) == false) || (fname.Equals(pParam3) == false))
                {

                    errMsg.Add("'E");
                    errMsg.Add("'100101");
                    errMsg.Add("DBに違う氏名で免許証番号が同じデータが存在しています。");
                }

            }


            return ret;
        }
        #region 免許取得日チェック
        public bool IsRightDate(DateTime pParam1, ref List<string> errMsg)
        {
            bool ret = false;
            DateTime datedefult = new DateTime();
            if (pParam1.CompareTo(datedefult) == 0)
            {

                errMsg.Add("'E");
                errMsg.Add("'100101");
                errMsg.Add("免許取得日は正しい日付ではありません。");
            }

            return ret;
        }

        #endregion

        #endregion
        #region  /従事者情報DBに免許番号チェック
        //<summary>
        //従事者情報DBに3項目が同じデータが存在しているかチェックする
        //</summary>
        public bool isMultiLicnse_num(string pParam1, string pParam2, string pParam3, ref List<string> errMsg)
        {
            bool ret = false, bRet;
            string sSql = string.Empty;
            DataTable dataTable = new DataTable();

             //SQL文作成
            sSql = "SELECT license_number,LastName,firstName ";
            sSql = sSql + " FROM radio_enginner_info_tbl";
            sSql = sSql + " WHERE license_number = '" + pParam1 + "'";
            sSql = sSql + " AND LastName = '" + pParam2 + "'";
            sSql = sSql + " AND firstName = '" + pParam3 + "'";

            //SQL文発行
            bRet = DB_Select(sSql, ref dataTable);

            if (dataTable.Rows.Count > 0)
            {
                errMsg.Add("'E");
                errMsg.Add("''100102");
                errMsg.Add("DBに同じ免許番号、氏名のデータが存在しています。");

            }
            return ret;
        }


        #endregion

        #region code_mst取得メソッド(1コード)
        /// <summary>
        /// 定数マスタ取得メソッド
        /// </summary>
        /// <param name="codeType"></param>
        /// <param name="code"></param>
        /// <returns></returns>
        public string GetCodeMaster(string codeType ,string code)
        {
            DataTable result = new DataTable();

            try
            {
                if (DB_Select(@"select code_name from code_mst where code_type = '" + codeType + "' and code='" + code + "'", ref result))
                {
                    if (result.Rows.Count > 0)
                    {
                        return result.AsEnumerable().SingleOrDefault().Field<string>("code_name");
                    }
                    else
                    {
                        return string.Empty;
                    }
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return string.Empty;
        }
        #endregion code_mst取得メソッド

        #region 定数マスタ取得（1種類全て）
        public bool GetCodeMaster(string codeType ,ref DataTable dt)
        {
            string ret = string.Empty;
            dt = new DataTable();

            //SQLパラメータを生成
            List<SqlParameter> lstParam = new List<SqlParameter>();
            lstParam.Add(new SqlParameter("@code_type", codeType));

            string strSelect = "SELECT code,code_name FROM code_mst WHERE code_type = @code_type ORDER BY code";

            try
            {
                if (DB_Select(strSelect, lstParam, ref dt))
                {
                    return true;
                }
                else
                {
                    return false;
                }
            }
            catch (Exception ex)
            { 
                return false;
            }
        }
        #endregion

        #region 総通局リスト取得
        /// <summary>
        /// コードマスタから総通局の一覧を取得する。
        /// </summary>
        /// <returns></returns>
        public DataTable GetSotsuKyokuList()
        {
            DataTable result = null;
            try
            {
                GetCodeMaster("04", ref result);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return result;
        }
        #endregion 総通局リスト取得

        #region 選任部門マスタ取得(1部門)
        /// <summary>
        /// パラメータで与えられた選任部門IDにより一意に選任部門名を取得する。
        /// </summary>
        /// <param name="selectionId">選任部門ID</param>
        /// <returns></returns>
        public string GetSelectionInfoMaster(string selectionId)
        {
            DataTable result = new DataTable();
            try
            {
                if (DB_Select(@"select selection_section from selection_info_mst where selectionID = '" + selectionId + "'", ref  result))
                {
                    return result.AsEnumerable().SingleOrDefault().Field<string>("selection_section");
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }

            return string.Empty;
        }
        #endregion 選任部門マスタ取得

        #region 選任部門マスタ取得（一覧）
        public bool GetSelectionInfoMaster(ref DataTable result)
        {
            result = new DataTable();
            return DB_Select(@"SELECT selectionID,selection_section FROM selection_info_mst ORDER BY selectionID", ref result);
        }
        #endregion 選任部門マスタ取得（一覧）

        #region 資格種別取得
        /// <summary>
        /// 資格番号と資格番号一覧（Dictionary）から資格名を取得する。
        /// </summary>
        /// <param name="licenseNumber"></param>
        /// <param name="dictLicenseTypeName"></param>
        /// <returns></returns>
        public string GetLicenseTypeName(string licenseNumber,Dictionary<string,string> dictLicenseTypeName)
        {
            try
            {
                //資格種別記号を取得
                string strCode = GetLicenseTypeCode(licenseNumber);

                if (!string.IsNullOrEmpty(strCode))
                {
                    //Dictionaryより資格種別名を取得
                    return dictLicenseTypeName[strCode];
                }
                else
                {
                    return string.Empty;
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }

        /// <summary>
        /// 引数で与えられた資格番号から資格種別の記号を取得する。
        /// </summary>
        /// <param name="licnenseNumber"></param>
        /// <returns></returns>
        public string GetLicenseTypeCode(string licenseNumber)
        {
            //地域(先頭1文字)と発給年度(1～2文字)の文字列を取り除く（※平成39年（BZ）までは対応可能）
            Regex reg = new System.Text.RegularExpressions.Regex(@"^([ABCDEFGHIJO])(A[A-Z]|B[A-Z]|[D-Z])");
            string strCode = reg.Replace(licenseNumber, string.Empty).Substring(0, 1);

            Regex licenseCode = new System.Text.RegularExpressions.Regex("[ABCDEFGHIJKLNOQRTUVWXYZ]");
            if (licenseCode.IsMatch(strCode))
            {
                //地域と発給年度の文字列を取り除いた先頭の文字を資格種別として取得する。
                return strCode;
            }
            else
            {
                return string.Empty;
            }
        }

        #endregion 資格種別取得

        #region 免許番号チェック
        /// <summary>
        /// 免許番号の先頭3～4文字が正しい形式かどうかをチェックする
        /// </summary>
        /// <param name="licenseNumber">免許番号</param>
        /// <returns></returns>
        public bool IsCorrectLicenseNumber(string licenseNumber)
        {
            //発給局所＋取得年度＋資格種別のパターンを表す正規表現と合致すればTrue、合致しなければFalseを返却
            Regex reg = new System.Text.RegularExpressions.Regex(@"^([ABCDEFGHIJO])(A[A-Z]|B[A-Z]|[D-Z])([ABCDEFGHIJKLNOQRTUVWXYZ])");
            return reg.IsMatch(licenseNumber);
        }

        #endregion 免許番号チェック

        #region SB/WCPリスト取得
        public Dictionary<string, string> GetSbWcpList()
        {
            Dictionary<string, string> dictSbwcp = new Dictionary<string, string>();
            DataTable dt = new DataTable();

            try
            {
                GetCodeMaster("07", ref dt);
            }
            catch (Exception ex)
            {
                throw ex;
            }

            foreach (DataRow dr in dt.Rows)
            {
                dictSbwcp.Add(dr.Field<string>("code"), dr.Field<string>("code_name"));
            }
            return dictSbwcp;
        }
        #endregion SB/WCPリスト取得

        #region NumberSeqの取得
        public int geNumberSeq()
        {
            string sSql = string.Empty;
            int ret = 0;
            bool bRet = false;
            System.Data.DataTable datatable = new System.Data.DataTable();
            try
            {
                //SQL文作成
                sSql = "SELECT num,create_date";
                sSql = sSql + " FROM NumberSeq";

                //SQL文発行
                bRet = DB_Select(sSql, ref datatable);

                if (bRet == false)
                {
                    ret = 0;
                }
                else
                {
                    ret = (int)datatable.Rows[0][0];
 
                }

            }catch
            {
                ret = 0;
            }


            return ret;
        }
        #endregion

        #region NumberSeqの更新
        public bool setNumberSeq(int num)
        {
            bool ret = true;
            string sSql = string.Empty;

            try
            {
                 //トランザクションの開始
                DB_BeginTranzaction();

                sSql = "UPDATE  NumberSeq ";
                sSql = sSql + " SET num ="  + num ;
                sSql = sSql + ", create_date =  getdate() ";

                string msg = "";
                ret = DB_Execute(sSql);

                if (ret == false)
                {
                    DB_Rollback();
                    ret = false;
                }
                else
                {
                    DB_Commit();
                    ret = true;
                }

            }
            catch
            {
                ret = false;
            }

            return ret;
        }
        #endregion

        #region 会社マスタ取得
        public DataTable GetCompanyMaster()
        {
            DataTable result = null;

            string strSelect = "SELECT company_id,company_name FROM company_mst WHERE del_flag = 0 ORDER BY company_id";
            try
            {
                DB_Select(strSelect, ref result);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return result;
        }
        #endregion 会社マスタ取得

        #region 所属部署取得
        public DataTable GetDepartmentMaster(string companyId)
        {
            DataTable result = new DataTable();

            //選択されていない場合はNullを返却
            if (string.IsNullOrEmpty(companyId)) return null;

            //検索処理
            string strSelect = "SELECT section_id,section_name FROM section_mst WHERE company_id = @companyid AND del_flag = 0 ORDER BY company_id,section_id";

            try
            {
                List<SqlParameter> lstParam = new List<SqlParameter>();
                lstParam.Add(new SqlParameter("@companyid", companyId));
                DB_Select(strSelect, lstParam, ref result);
            }
            catch (Exception ex)
            {
                throw ex;
            }

            return result;
        }
        #endregion

        #region 承認フラグ取得
        public bool GetRequestStatusList(ref DataTable result)
        {
            result = new DataTable();
            return GetCodeMaster("03", ref result);
        }
        #endregion 申請ステータス取得

        #region 免許種別取得
        public Dictionary<string,string> GetLicenseNameList()
        {
            Dictionary<string, string> ret = new Dictionary<string, string>();

            //空文字列が渡された場合は空白を返す
            ret.Add(string.Empty, string.Empty);
            DataTable result = new DataTable();
            if (GetCodeMaster("01", ref result))
            {
                foreach (DataRow row in result.Rows)
                {
                    ret.Add(row.Field<string>("code").Trim(), row.Field<string>("code_name"));
                }
            }

            return ret;
        }
        #endregion

        #region 総合通信局取得
        public bool GetSotsuKyokuList(ref DataTable result)
        {
            result = new DataTable();
            return GetCodeMaster("04", ref result);
        }
        #endregion

        #region 地域名取得
        /// <summary>
        /// パラメータで与えられた地域コードに応じて地域名を返却する。
        /// </summary>
        /// <param name="areaCode"></param>
        /// <returns></returns>
        public string GetAreaName(string areaCode)
        {
            switch(areaCode)
            {
                case "HQ": return "本社";
                case "A": return "関東";
                case "B": return "信越";
                case "C": return "東海";
                case "D": return "北陸";
                case "E": return "近畿";
                case "F": return "中国";
                case "G": return "四国";
                case "H": return "九州";
                case "I": return "東北";
                case "J": return "北海道";
                case "O": return "沖縄";
                default: return string.Empty;
            }
        }
        #endregion 地域名取得


        /// <summary>
        /// パラメータで指定された地域コードに応じて列名を返却する。
        /// </summary>
        /// <param name="strAreaCode"></param>
        /// <returns></returns>
        public string GetAreaRowName(string strAreaCode)
        {
            switch (strAreaCode)
            {
                case "A": return "kantou";
                case "B": return "shinetsu";
                case "C": return "tokai";
                case "D": return "hokuriku";
                case "E": return "kinki";
                case "F": return "chugoku";
                case "G": return "kyuushu";
                case "H": return "shikoku";
                case "I": return "touhoku";
                case "J": return "hokkaidou";
                case "O": return "okinawa";
                default: return string.Empty;
            }
        }

        /// <summary>
        /// 地域IDから地域コードを取得する。
        /// </summary>
        /// <param name="strAreaId"></param>
        /// <returns></returns>
        public int getAreaCode(string strAreaId)
        {
            switch (strAreaId)
            {
                case "A": return 5;  //A:関東
                case "B": return 4;  //B:信越
                case "C": return 6;  //C:東海
                case "D": return 3;  //D:北陸
                case "E": return 7;  //E:近畿
                case "F": return 9;  //F:中国
                case "G": return 8; //G:四国
                case "H": return 10;  //H:九州
                case "I": return 2;  //I:東北
                case "J": return 1;  //J:北海道
                case "O": return 11; //O:沖縄
                default: return 0;
            }
        }

        #region 承認フラグリスト取得
        /// <summary>
        /// 承認フラグの値と名称のDictionaryを生成
        /// DBからは取得せず固定値で対応
        /// </summary>
        /// <returns></returns>
        public Dictionary<string, string> GetApprovalFlagList()
        {
            Dictionary<string, string> lstApprovalFlag = new Dictionary<string, string>();

            lstApprovalFlag.Add("0", ComConst.MISHONIN);
            lstApprovalFlag.Add("1", ComConst.SHONIN_REQ);
            lstApprovalFlag.Add("2", ComConst.SHONIN_COMPLETED);
            lstApprovalFlag.Add("3", ComConst.SHONIN_DENY);
            lstApprovalFlag.Add("4", ComConst.SHONIN_RETURN);

            return lstApprovalFlag;
        }
        #endregion 承認フラグリスト取得

        #region Excel処理関連
        /// <summary>
        /// パラメータで渡されたDataTableをExcelに出力する。
        /// </summary>
        /// <param name="inputDataTable">出力対象DataTable</param>
        /// <param name="serverFilePath">サーバ上でのフルパス</param>
        /// <param name="sheetName">出力シート名</param>
        public void CreateExcelFile(DataTable inputDataTable, string serverFilePath, string sheetName)
        {
            string directoryName = Path.GetDirectoryName(serverFilePath);
            //フォルダ存在確認
            if (!Directory.Exists(directoryName))
            {
                Directory.CreateDirectory(directoryName);
            }

            // ファイルが既に存在する場合は削除
            if (File.Exists(serverFilePath))
            {
                FileInfo fi = new FileInfo(serverFilePath);
                fi.Delete();
            }

            //シート名が空の場合、デフォルトのシート名を設定
            if (string.IsNullOrEmpty(sheetName))
            {
                sheetName = "sheet1";
            }

            try
            {
                //ファイルを生成
                var outputFile = new FileInfo(serverFilePath);

                using (var excel = new ExcelPackage(outputFile))
                {
                    using (var worksheet = excel.Workbook.Worksheets.Add(sheetName))
                    {
                        //ヘッダ行出力
                        int colNum = 1;
                        foreach (DataColumn column in inputDataTable.Columns)
                        {
                            worksheet.Cells[1, colNum].Value = column.ColumnName;
                            colNum++;
                        }

                        //データ行出力
                        int rowNum = 2;
                        foreach (DataRow row in inputDataTable.Rows)
                        {
                            colNum = 1;
                            foreach (DataColumn column in inputDataTable.Columns)
                            {
                                worksheet.Cells[rowNum, colNum].Value = row[column.ColumnName].ToString();
                                colNum++;
                            }
                            rowNum++;
                        }

                        excel.Save();
                    }
                }
            }
            catch(Exception ex)
            {
                throw ex;
            }
        }

        //一括取込用Excelファイルにデータを出力する。
        public void CreateExcelFileByFormat(DataTable inputDataTable, string serverFilePath, string sheetName)
        {
            string directoryName = Path.GetDirectoryName(serverFilePath);
            //フォルダ存在確認
            if (!Directory.Exists(directoryName))
            {
                Directory.CreateDirectory(directoryName);
            }

            // ファイルが既に存在する場合は削除
            if (File.Exists(serverFilePath))
            {
                FileInfo fi = new FileInfo(serverFilePath);
                fi.Delete();
            }

            //シート名が空の場合、デフォルトのシート名を設定
            if (string.IsNullOrEmpty(sheetName))
            {
                sheetName = "sheet1";
            }

            //Excelフォーマットファイルのフルパスを取得
            string formatFilePath = ConfigurationManager.AppSettings[ComConst.CONFIG_EXCEL_FORMAT_FILEPATH];

            try
            {
                //フォーマットExcelファイルをコピー
                var outputFile = new FileInfo(formatFilePath).CopyTo(serverFilePath);

                //ファイルを生成
                //var outputFile = new FileInfo(serverFilePath);

                using (var excel = new ExcelPackage(outputFile))
                {
                    using (var worksheet = excel.Workbook.Worksheets["申請リスト一覧"])
                    {
                        //データ行出力
                        int rowNum = 10;
                        foreach (DataRow row in inputDataTable.Rows)
                        {
                            int colNum = 2;

                            worksheet.InsertRow(rowNum, 1);
                            worksheet.Cells[rowNum + 1, colNum, rowNum + 1, 26].Copy(worksheet.Cells[rowNum, colNum]);
                            foreach (DataColumn column in inputDataTable.Columns)
                            {
                                if (row[column.ColumnName] is DateTime)
                                {
                                    worksheet.Cells[rowNum, colNum].Value = ((DateTime)row[column.ColumnName]).ToString("yyyy/MM/dd");
                                }
                                else
                                {
                                    worksheet.Cells[rowNum, colNum].Value = row[column.ColumnName];
                                }
                                colNum++;
                            }
                            rowNum++;
                        }
                        worksheet.DeleteRow(rowNum);
                        excel.Save();
                    }
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }

        }



        #endregion Excel処理関連

        #region ダウンロード用ファイル名設定
        public string GetDownloadFileName(string inputFileName,string defaultFileName)
        {
            string ret = string.Empty;

            string dlFilename = string.Empty;

            if (!string.IsNullOrEmpty(inputFileName) && !inputFileName.Equals(defaultFileName))
            {
                dlFilename = inputFileName;
            }
            else
            {
                dlFilename = defaultFileName;
            }

            string extension = Path.GetExtension(dlFilename);
            // 拡張子が未指定の場合
            if (string.IsNullOrEmpty(extension))
            {
                //拡張子を設定
                dlFilename = dlFilename + ".xlsx";
            }
            //拡張子がxlsxでない場合
            else if ("xlsx".Equals(extension))
            {
                //拡張子を.xlsxに変更
                dlFilename = Path.GetFileNameWithoutExtension(dlFilename) + ".xlsx";
            }

            //URLエンコードしたファイル名を返却
            return HttpUtility.UrlEncode(dlFilename);
        }

        /// <summary>
        /// サーバに作成される一時ファイルの名称を返却する。
        /// </summary>
        /// <param name="sessionID"></param>
        /// <returns></returns>
        public string CreateServerFileName(string sessionID)
        {
            return sessionID + DateTime.Now.ToString("yyyyMMddhhmmssfff") + ".xlsx";
        }

        #endregion ダウンロード用ファイル名設定

        #region ダウンロード処理
        /// <summary>
        /// パラメータで与えられた情報によりExcelファイルのダウンロード処理を実行する。
        /// </summary>
        /// <param name="res">HttpResponseオブジェクト</param>
        /// <param name="fileName">実際にユーザーがダウンロードするファイル名</param>
        /// <param name="fullPath">サーバ上でのファイルのフルパス</param>
        public void DownloadExcelFile(HttpResponse res, string fileName, string fullPath)
        {
            try
            {
                //レスポンス情報クリア
                res.ClearContent();

                //バッファリング
                res.Buffer = true;

                //HTTPヘッダー情報・MIMEタイプ設定
                res.AddHeader("Content-Disposition", String.Format("attachment;filename={0}", fileName));
                res.ContentType = "application/msexcel";

                res.WriteFile(fullPath);
                res.Flush();

                //ダウンロード後ファイル削除
                if (System.IO.File.Exists(fullPath))
                {
                    System.IO.File.Delete(fullPath);
                }

                res.End();
            }
            catch(Exception ex)
            {
                throw ex;
            }
        }
        #endregion ダウンロード処理

        #region 選任部門名取得
        /// <summary>
        /// 選任部門のDictionaryから部門名を取得する。
        /// </summary>
        /// <param name="selectionId"></param>
        /// <param name="sectionDictionary"></param>
        /// <returns></returns>
        public string GetSelectionSectionName(string selectionId,Dictionary<string,string> sectionDictionary)
        {
            //Dictionaryにkey：selectionIdが含まれている場合
            if (sectionDictionary.Keys.Contains(selectionId))
            {
                return sectionDictionary[selectionId];
            }
            else
            {
                // 含まれていない場合、IDをそのまま返却する。
                return selectionId;
            }
        }
        #endregion 選任部門名取得

        /// <summary>
        /// 選任解任個別情報テーブルに設定済みの選任部門IDの一覧を取得する。
        /// </summary>
        /// <returns>選任部門IDのリスト</returns>
        public List<string> getCurrentSelectionSectionList()
        {
            List<string> sectionList = new List<string>();

            DataTable result = new DataTable();

            //発行するSQLを生成
            string strSelect = @"select distinct selectionID From selection_personal_tbl";

            try
            {
                DB_Select(strSelect, ref result);

                if (result != null && result.Rows.Count > 0)
                {
                    foreach (DataRow row in result.Rows)
                    {
                        sectionList.Add(row.Field<string>("selectionID"));
                    }                    
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }

            return sectionList;
        }

        /// <summary>
        /// LDAPで管理部門一覧検索時に使用するフィルタ文字列を生成する。
        /// </summary>
        /// <returns></returns>
        public string GetFirstMatchSearchString()
        {
            string[] targetDepartmentNameList = (ConfigurationManager.AppSettings[ComConst.CONFIG_SECTION_LIST] as string).Split(',');

            //Web.Configの内容から検索対象の部署を絞り込む文字列を生成
            string searchString = string.Empty;
            if (targetDepartmentNameList.Count() > 0)
            {
                string tmp = string.Empty;
                foreach (string name in targetDepartmentNameList)
                {
                    if (!string.IsNullOrEmpty(name.Trim()))
                    {
                        tmp += string.Format("(displayName={0}*)", name);
                    }
                }
                if (!string.IsNullOrEmpty(tmp))
                {
                    searchString = string.Format("(|{0})", tmp);
                }
            }
            return searchString;
        }

        //所属会社ドロップダウンリストに中身を設定
        public void SetBelongCompanyDropdownlist(DropDownList ddl)
        {
            //設定済みの表示内容をクリア
            ddl.Items.Clear();

            ddl.Items.Add(new ListItem(string.Empty, string.Empty));
            DataTable dtCompanyList = this.GetCompanyMaster();
            if (dtCompanyList != null && dtCompanyList.Rows.Count > 0)
            {
                foreach (DataRow row in dtCompanyList.Rows)
                {
                    ddl.Items.Add(new ListItem(row.Field<string>("company_name"), row.Field<string>("company_id")));
                }
            }
        }

        //所属部署ドロップダウンリストに中身を設定
        public void SetBelongDepartmentDropdownlist(DropDownList ddl,string companyId)
        {
            //設定済みの表示内容をクリア
            ddl.Items.Clear();
            
            //空項目を追加
            ddl.Items.Add(new ListItem(string.Empty, string.Empty));

            //会社が選択済みなら部署の中身を設定する。
            if (!string.IsNullOrEmpty(companyId))
            {
                DataTable dtDepartmentList = this.GetDepartmentMaster(companyId);
                if (dtDepartmentList != null)
                {
                    foreach (DataRow row in dtDepartmentList.Rows)
                    {
                        ddl.Items.Add(new ListItem(row.Field<string>("section_name"), row.Field<string>("section_id")));
                    }
                }
            }
        }
    }
}