﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Data.SqlClient;
namespace EmpCRM.common
{
    public static class LogUtil
    {
        /// <summary>
        /// SQLログ出力用フォーマット取得（パラメータあり）
        /// </summary>
        /// <param name="strSql"></param>
        /// <param name="lstSqlParams"></param>
        /// <returns>SQLログ出力フォーマット</returns>
        public static string GetSqlLogFormat(string strSql, List<SqlParameter> lstSqlParams)
        {
            return "[Sql]:{" + strSql + "},[SqlParameter]:{" + GetSqlParamLogFormat(lstSqlParams) + "}";
        }

        /// <summary>
        /// SQLログ出力用フォーマット取得（パラメータなし）
        /// </summary>
        /// <param name="strSql"></param>
        /// <returns></returns>
        public static string GetSqlLogFormat(string strSql)
        {
            return "[Sql]:{" + strSql + "}";
        }


        /// <summary>
        /// SQLParameterリストの出力フォーマット取得
        /// </summary>
        /// <param name="lstSqlParams"></param>
        /// <returns></returns>
        private static string GetSqlParamLogFormat(List<SqlParameter> lstSqlParams)
        {
            string strParams = string.Empty;
            foreach (SqlParameter param in lstSqlParams)
            {
                strParams += "ParamName:{" + param.ParameterName + "},Value:{" + param.Value.ToString() + "},";
            }
            return strParams;
        }
    }
}