﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.DirectoryServices;
using System.Web.Security;
using System.Configuration;
using System.Runtime.InteropServices;
using System.Reflection;
using System.IO;
using log4net;

namespace EmpCRM.common
{
    public class MembershipProvider : System.Web.Security.MembershipProvider
    {
        //logger生成
        private static readonly ILog logger = LogManager.GetLogger(MethodBase.GetCurrentMethod().DeclaringType);

        private static string getEntryInfo(DirectoryEntry entry)
        {
            return string.Format("RequestInfo:Username:{0},Path:{1}", entry.Username, entry.Path);
        }
        /// <summary>
        /// ユーザ認証
        /// </summary>
        /// <param name="username"></param>
        /// <param name="password"></param>
        /// <returns></returns>
        public override bool ValidateUser(string username, string password)
        {
            throw new NotImplementedException();

            //logger.Info("START:LDAP認証処理");

            ////Web.Configから値取得
            //string domain = ConfigurationManager.AppSettings[ComConst.CONFIG_DOMAIN_NAME];
            //string domainName = String.Format(@"{0}\{1}", domain, username);
            ////エントリー情報の設定
            //using (DirectoryEntry entry = new DirectoryEntry())
            //{
            //    entry.Username = domainName;
            //    entry.Password = password;
            //    try
            //    {
            //        try
            //        {
            //            entry.Path = ConfigurationManager.AppSettings[ComConst.CONFIG_PRIMARY_AUTH_SERVER];
            //            logger.Info(getEntryInfo(entry));
            //            object logOnObj = entry.NativeObject;
            //        }
            //        catch (COMException ex)
            //        {
            //            logger.Error(((DirectoryServicesCOMException)ex).ExtendedErrorMessage);
            //            logger.Error(username + ":プライマリサーバでの認証失敗", ex);
            //            //プライマリサーバでの認証が失敗した場合、セカンダリサーバで認証を実施する。
            //            entry.Path = ConfigurationManager.AppSettings[ComConst.CONFIG_SECONDARY_AUTH_SERVER];
            //            //認証リクエスト情報を出力
            //            logger.Info(getEntryInfo(entry));
            //            object logOnObj = entry.NativeObject;
            //        }
            //        //ログイン成功
            //        logger.Info(username + "：認証成功");

            //        #region ユーザの保持する情報を取得
            //        using (DirectorySearcher seacher = new DirectorySearcher(entry))
            //        {
            //            seacher.Filter = "(sAMAccountName=" + username + ")";

            //            //取得対象属性リスト生成
            //            List<string> lstAttribute = new List<string>();
            //            lstAttribute.Add(ComConst.ATTRIBUTE_DISPLAYNAME);
            //            lstAttribute.Add(ComConst.ATTRIBUTE_CN);
            //            lstAttribute.Add(ComConst.ATTRIBUTE_MEMBEROF);
            //            lstAttribute.Add(ComConst.ATTRIBUTE_DEPARTMENTNUMBER);

            //            foreach (string str in lstAttribute)
            //            {
            //                seacher.PropertiesToLoad.Add(str);
            //            }

            //            SearchResult result = seacher.FindOne();

            //            if (result == null)
            //            {
            //                //取得失敗の場合はユーザIDをそのまま返却
            //                return false;
            //            }
            //            else
            //            {
            //                foreach (string propName in result.Properties.PropertyNames)
            //                {
            //                    foreach (string property in result.Properties[propName])
            //                    {
            //                        var logstring = string.Format("LDAP取得情報:{0}:{1}", propName, property);
            //                        logger.Debug(logstring);
            //                    }
            //                }
            //            }
            //        }
            //        #endregion ユーザの保持する情報を取得

            //        return true;
            //    }
            //    catch (DirectoryServicesCOMException ex)
            //    {
            //        logger.Error(((DirectoryServicesCOMException)ex).ExtendedErrorMessage);
            //        logger.Error(username + ":セカンダリサーバでの認証失敗", ex);

            //        return false;
            //    }
            //    finally
            //    {
            //        logger.Info("END  :LDAP認証処理");
            //    }
            //}
        }

        /// <summary>
        /// ユーザ認証を行い、ユーザ情報を返却する。
        /// </summary>
        /// <param name="username"></param>
        /// <param name="password"></param>
        /// <returns></returns>
        public SearchResult ValidateUerAndGetUserInfo(string username, string password)
        {
            logger.Info("START:LDAP認証処理");

            //Web.Configから値取得
            string domain = ConfigurationManager.AppSettings[ComConst.CONFIG_DOMAIN_NAME];
            string domainName = String.Format(@"{0}\{1}", domain, username);
            //エントリー情報の設定
            using (DirectoryEntry entry = new DirectoryEntry())
            {
                entry.Username = domainName;
                entry.Password = password;
                try
                {
                    try
                    {
                        entry.Path = ConfigurationManager.AppSettings[ComConst.CONFIG_PRIMARY_AUTH_SERVER];
                        logger.Info(getEntryInfo(entry));
                        object logOnObj = entry.NativeObject;
                    }
                    catch (COMException ex)
                    {
                        logger.Error(((DirectoryServicesCOMException)ex).ExtendedErrorMessage);
                        logger.Error(username + ":プライマリサーバでの認証失敗", ex);
                        //プライマリサーバでの認証が失敗した場合、セカンダリサーバで認証を実施する。
                        entry.Path = ConfigurationManager.AppSettings[ComConst.CONFIG_SECONDARY_AUTH_SERVER];
                        //認証リクエスト情報を出力
                        logger.Info(getEntryInfo(entry));
                        object logOnObj = entry.NativeObject;
                    }
                }
                catch (DirectoryServicesCOMException ex)
                {
                    logger.Error(((DirectoryServicesCOMException)ex).ExtendedErrorMessage);
                    logger.Error(username + ":セカンダリサーバでの認証失敗", ex);
                    logger.Debug("認証完全失敗");
                    //取得失敗の場合はnullを返却
                    return null;
                }

                //ログイン成功
                logger.Info(username + "：認証成功");

                try
                {
                    #region ユーザの保持する情報を取得
                    using (DirectorySearcher seacher = new DirectorySearcher(entry))
                    {
                        seacher.Filter = "(sAMAccountName=" + username + ")";

                        //取得対象属性リスト生成
                        List<string> lstAttribute = new List<string>();
                        lstAttribute.Add(ComConst.ATTRIBUTE_DISPLAYNAME);
                        lstAttribute.Add(ComConst.ATTRIBUTE_CN);
                        lstAttribute.Add(ComConst.ATTRIBUTE_MEMBEROF);
                        lstAttribute.Add(ComConst.ATTRIBUTE_DEPARTMENT);
                        lstAttribute.Add(ComConst.ATTRIBUTE_DEPARTMENTNUMBER);

                        //ロード対象の属性を追加
                        foreach (string str in lstAttribute)
                        {
                            seacher.PropertiesToLoad.Add(str);
                        }

                        //検索を実行
                        SearchResult result = seacher.FindOne();

                        if (result == null)
                        {
                            //取得失敗の場合はnullを返却
                            return null;
                        }
                        else
                        {
                            foreach (string propName in result.Properties.PropertyNames)
                            {
                                foreach (string property in result.Properties[propName])
                                {
                                    var logstring = string.Format("LDAP取得情報:{0}:{1}", propName, property);
                                    logger.Debug(logstring);
                                }
                            }
                        }

                        // 検索結果を返却
                        return result;
                    }
                    #endregion ユーザの保持する情報を取得
                }
                catch (Exception ex)
                {
                    logger.Debug("ユーザ情報検索失敗");
                    throw ex;
                }
                finally
                {
                    logger.Info("END  :LDAP認証処理");
                }
            }
        }

        /// <summary>
        /// パラメータで指定されたユーザの表示名を取得する
        /// </summary>
        /// <param name="result"></param>
        /// <returns></returns>
        public string GetUserDisplayName(SearchResult result)
        {
            logger.Info("START:ユーザ名取得処理");
            try
            {
                foreach (string property in result.Properties[ComConst.ATTRIBUTE_DISPLAYNAME])
                {
                    if (!string.IsNullOrEmpty(property))
                    {
                        logger.Debug(string.Format("取得ユーザ名:{0}", property));
                        return property;
                    }
                }

                foreach (string cn in result.Properties[ComConst.ATTRIBUTE_CN])
                {
                    logger.Debug("ユーザ名取得失敗");
                    logger.Debug(string.Format("取得ユーザ名:{0}", cn));
                    return cn;
                }

                logger.Debug("ユーザ名取得失敗");
                return string.Empty;
            }
            catch (Exception ex)
            {
                //logger.Error(((DirectoryServicesCOMException)ex).ExtendedErrorMessage);
                //logger.Error(username + ":セカンダリサーバでの認証失敗", ex);
                //取得失敗の場合はユーザIDをそのまま返却
                //return username;
                logger.Debug("ユーザ名取得失敗");
                logger.Error(ex.Message, ex);
                return string.Empty;
            }
            finally
            {
                logger.Info("END  :ユーザ名取得処理");
            }
        }

        /// <summary>
        /// パラメータで与えられたユーザの所属部門コードを取得する。
        /// </summary>
        /// <param name="username"></param>
        /// <returns></returns>
        public string GetUserDepartment(SearchResult result)
        {
            logger.Info("START:所属部門コード取得処理");

            try
            {
                string departmentNumber = string.Empty;

                // DepartmentNumberから取得
                foreach (string property in result.Properties[ComConst.ATTRIBUTE_DEPARTMENTNUMBER])
                {
                    string[] depNumber = property.Split(':');
                    //「登録区分」=「1」かつ「本務／兼務区分」=「0001」の場合
                    if ("1".Equals(depNumber[0]) && "0001".Equals(depNumber[3]))
                    {
                        logger.Debug(string.Format("取得所属部門コード:{0}", depNumber[1]));
                        //組織コードを取得
                        //return depNumber[1];
                        departmentNumber = depNumber[1];
                    }
                }

                // DepartmentNumberから取得できない場合はDepartmentから取得
                if (string.IsNullOrEmpty(departmentNumber))
                {
                    foreach (string property in result.Properties[ComConst.ATTRIBUTE_DEPARTMENT])
                    {
                        departmentNumber = property;
                    }
                }

                //departmentNumber or departmentから取得できていればそのコードを返却
                if (!string.IsNullOrEmpty(departmentNumber))
                {
                    return departmentNumber;
                }

                logger.Debug("所属部門コード取得失敗:部門の設定が不正です。");
                //部門コードが取得できなかった場合ダミー値を返却する
                logger.Debug("【暫定対応】ダミー部門：9999999を設定");
                return "9999999";
            }
            catch (Exception e)
            {
                logger.Debug("所属部門コード取得失敗:例外発生");
                //エラーログ出力
                logger.Error(e.Message, e);
                return string.Empty;
            }
            finally
            {
                logger.Info("END  :所属部門コード取得処理");
            }
        }


        /// <summary>
        /// パラメータで与えられた部門コードから部門名を取得する。
        /// </summary>
        /// <param name="departmentCode"></param>
        /// <returns></returns>
        public string GetDepartmentName(string departmentCode)
        {
            logger.Info("START:部門名取得処理");

            string adminUser = ConfigurationManager.AppSettings[ComConst.CONFIG_ADMIN_USER];
            string adminPasswd = ConfigurationManager.AppSettings[ComConst.CONFIG_ADMIN_PASSWORD];
            string domain = ConfigurationManager.AppSettings[ComConst.CONFIG_DOMAIN_NAME];
            string domainName = String.Format(@"{0}\{1}", domain, adminUser);

            using (DirectoryEntry entry = new DirectoryEntry())
            {
                entry.Username = domainName;
                entry.Password = adminPasswd;
                try
                {
                    try
                    {
                        entry.Path = ConfigurationManager.AppSettings[ComConst.CONFIG_PRIMARY_AUTH_SERVER];
                        object logOnObj = entry.NativeObject;
                    }
                    catch (COMException ex)
                    {
                        logger.Error(((DirectoryServicesCOMException)ex).ExtendedErrorMessage);
                        logger.Error(adminUser + ":プライマリサーバでの認証失敗", ex);
                        //プライマリサーバでの認証が失敗した場合、セカンダリサーバで認証を実施する。
                        entry.Path = ConfigurationManager.AppSettings[ComConst.CONFIG_SECONDARY_AUTH_SERVER];
                        object logOnObj = entry.NativeObject;
                    }
                    //ログイン成功
                    logger.Info(adminUser + "：認証成功");

                    //検索処理
                    using (DirectorySearcher searcher = new DirectorySearcher(entry))
                    { 
                        searcher.Filter = "(name=" + departmentCode + ")";
                        searcher.PropertiesToLoad.Add(ComConst.ATTRIBUTE_DISPLAYNAME);
                        SearchResult result = searcher.FindOne();

                        if (result == null)
                        {
                            //return string.Empty;
                            //取得できない場合は部門コードをそのまま表示
                            logger.Debug("部門名取得失敗");
                            logger.Debug("部門名:" + departmentCode);
                            return departmentCode;
                        }
                        else
                        {
                            foreach (string item in result.Properties[ComConst.ATTRIBUTE_DISPLAYNAME])
                            {
                                logger.Debug("部門名:" + item);
                                return item;
                            }
                        }
                    }

                    //return string.Empty;
                    //取得できない場合は部門コードをそのまま表示
                    logger.Debug("部門名取得失敗");
                    logger.Debug("部門名:" + departmentCode);
                    return departmentCode;
                }
                catch (DirectoryServicesCOMException ex)
                {
                    //認証失敗
                    logger.Error(((DirectoryServicesCOMException)ex).ExtendedErrorMessage);
                    logger.Error(adminUser + ":セカンダリサーバでの認証失敗", ex);
                    //return string.Empty;
                    //取得できない場合は部門コードをそのまま表示
                    logger.Debug("部門名取得失敗");
                    logger.Debug("部門名:" + departmentCode);
                    return departmentCode;
                }
                finally
                {
                    logger.Info("END  :部門名取得処理");
                }
            }
        }


        /// <summary>
        /// 組織コードと組織名の組み合わせを取得するメソッド
        /// </summary>
        /// <returns></returns>
        public Dictionary<string, string> GetDepartmentList()
        {
            logger.Info("START:部門一覧取得処理");

            string adminUser = ConfigurationManager.AppSettings[ComConst.CONFIG_ADMIN_USER];
            string adminPasswd = ConfigurationManager.AppSettings[ComConst.CONFIG_ADMIN_PASSWORD];
            string domain = ConfigurationManager.AppSettings[ComConst.CONFIG_DOMAIN_NAME];
            string domainName = String.Format(@"{0}\{1}", domain, adminUser);

            Dictionary<string, string> departDict = new Dictionary<string, string>();

            using (DirectoryEntry entry = new DirectoryEntry())
            {
                entry.Username = domainName;
                entry.Password = adminPasswd;
                try
                {
                    try
                    {
                        entry.Path = ConfigurationManager.AppSettings[ComConst.CONFIG_PRIMARY_AUTH_SERVER] + ConfigurationManager.AppSettings[ComConst.CONFIG_SECTION_FILTER];
                        object logOnObj = entry.NativeObject;
                    }
                    catch (COMException ex)
                    {
                        logger.Error(((DirectoryServicesCOMException)ex).ExtendedErrorMessage);
                        logger.Error(adminUser + ":プライマリサーバでの認証失敗", ex);
                        //プライマリサーバでの認証が失敗した場合、セカンダリサーバで認証を実施する。
                        entry.Path = ConfigurationManager.AppSettings[ComConst.CONFIG_SECONDARY_AUTH_SERVER];
                        object logOnObj = entry.NativeObject;
                    }

                    //ログイン成功
                    logger.Info(adminUser + "：認証成功");
                    //検索処理
                    using (DirectorySearcher searcher = new DirectorySearcher(entry))
                    {
                        //Web.Configの内容から検索対象の部署を絞り込む文字列を生成
                        string searchString = new common.ComFunc().GetFirstMatchSearchString();

                        searcher.SizeLimit = 0;
                        searcher.PageSize = 1000;
                        //displayNameがWeb.Configで設定された部門名に前方一致する部門のみ取得
                        searcher.Filter = string.Format("(&(objectClass=OrganizationalUnit){0})", searchString);
                        searcher.PropertiesToLoad.Add(ComConst.ATTRIBUTE_DISPLAYNAME);
                        searcher.PropertiesToLoad.Add(ComConst.ATTRIBUTE_OU);
                        SearchResultCollection results = searcher.FindAll();

                        if (results == null)
                        {
                            return new Dictionary<string, string>();
                        }
                        else
                        {
                            foreach (SearchResult result in results)
                            {
                                foreach (System.Collections.DictionaryEntry item in result.Properties)
                                {
                                    foreach (string str in result.Properties["adspath"])
                                    {
                                        logger.Debug(string.Format("{0}:{1}", "adspath", str));
                                        string strKey = result.Properties[ComConst.ATTRIBUTE_OU][0] as string;
                                        string strValue = string.Empty;
                                        //displayNameに要素が含まれている場合
                                        if (result.Properties[ComConst.ATTRIBUTE_DISPLAYNAME].Count > 0)
                                        {
                                            strValue = result.Properties[ComConst.ATTRIBUTE_DISPLAYNAME][0] as string;
                                        }
                                        else //displayNameの要素が含まれていない場合
                                        {
                                            strValue = strKey;
                                        }

                                        //一覧に追加済みのキーでない場合は追加する。
                                        if (!departDict.ContainsKey(strKey))
                                        {
                                            logger.Debug(string.Format("部門一覧に追加 Key:{0},Value:{1}", strKey, strValue));
                                            departDict.Add(strKey, strValue);
                                            break;
                                        }
                                    }
                                }
                            }
                            return departDict;
                        }
                    }
                    //return new Dictionary<string, string>();
                }
                catch (DirectoryServicesCOMException ex)
                {
                    logger.Error(((DirectoryServicesCOMException)ex).ExtendedErrorMessage);
                    logger.Error(adminUser + ":セカンダリサーバでの認証失敗", ex);
                    return new Dictionary<string, string>();
                }
                finally
                {
                    logger.Info("END  :部門一覧取得処理");
                }
            }
        }



        #region 未実装
        public override MembershipUser GetUser(string username, bool userIsOnline)
        {
            throw new NotImplementedException();
        }


        public override string ApplicationName
        {
            get
            {
                throw new NotImplementedException();
            }
            set
            {
                throw new NotImplementedException();
            }
        }
        public override bool ChangePassword(string username, string oldPassword, string newPassword)
        {
            throw new NotImplementedException();
        }

        public override bool ChangePasswordQuestionAndAnswer(string username, string password, string newPasswordQuestion, string newPasswordAnswer)
        {
            throw new NotImplementedException();
        }

        public override MembershipUser CreateUser(string username, string password, string email, string passwordQuestion, string passwordAnswer, bool isApproved, object providerUserKey, out System.Web.Security.MembershipCreateStatus status)
        {
            throw new NotImplementedException();
        }

        public override bool DeleteUser(string username, bool deleteAllRelatedData)
        {
            throw new NotImplementedException();
        }

        public override bool EnablePasswordReset
        {
            get
            {
                throw new NotImplementedException();
            }
        }

        public override bool EnablePasswordRetrieval
        {
            get
            {
                throw new NotImplementedException();
            }
        }

        public override MembershipUserCollection FindUsersByEmail(string emailToMatch, int pageIndex, int pageSize, out int totalRecords)
        {
            throw new NotImplementedException();
        }

        public override int GetNumberOfUsersOnline()
        {
            throw new NotImplementedException();
        }

        public override string GetPassword(string username, string answer)
        {
            throw new NotImplementedException();
        }

        public override MembershipUser GetUser(object providerUserKey, bool userIsOnline)
        {
            throw new NotImplementedException();
        }

        public override string GetUserNameByEmail(string email)
        {
            throw new NotImplementedException();
        }

        public override int MaxInvalidPasswordAttempts
        {
            get
            {
                throw new NotImplementedException();
            }
        }

        public override int MinRequiredNonAlphanumericCharacters
        {
            get
            {
                throw new NotImplementedException();
            }
        }

        public override int MinRequiredPasswordLength
        {
            get
            {
                throw new NotImplementedException();
            }
        }

        public override int PasswordAttemptWindow
        {
            get
            {
                throw new NotImplementedException();
            }
        }

        public override MembershipPasswordFormat PasswordFormat
        {
            get
            {
                throw new NotImplementedException();
            }
        }

        public override string PasswordStrengthRegularExpression
        {
            get
            {
                throw new NotImplementedException();
            }
        }

        public override bool RequiresQuestionAndAnswer
        {
            get
            {
                throw new NotImplementedException();
            }
        }

        public override bool RequiresUniqueEmail
        {
            get
            {
                throw new NotImplementedException();
            }
        }

        public override string ResetPassword(string username, string answer)
        {
            throw new NotImplementedException();
        }

        public override bool UnlockUser(string userName)
        {
            throw new NotImplementedException();
        }

        public override void UpdateUser(MembershipUser user)
        {
            throw new NotImplementedException();

        }

        public override MembershipUserCollection FindUsersByName(string usernameToMatch, int pageIndex, int pageSize, out int totalRecords)
        {
            throw new NotImplementedException();
        }

        public override MembershipUserCollection GetAllUsers(int pageIndex, int pageSize, out int totalRecords)
        {
            throw new NotImplementedException();
        }

        //public override MembershipUser GetUser(string username, bool userIsOnline)
        //{
        //    throw new NotImplementedException();
        //}

        #endregion

    }
}