﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using EmpCRM.common;
using EmpCRM.Dto;

namespace EmpCRM
{
    public partial class Header : System.Web.UI.UserControl
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            UserRole userRole = Session[ComConst.SESSION_USER_ROLE] as UserRole;
            ComFunc com = new ComFunc();
            //ログイン状態チェック
            if (!LoginUtil.IsLogin(userRole))
            {
                //未ログインの場合ログアウトボタン等を非表示（ログイン画面）
                pnlNavigation.Visible = false;
            }
            else
            {
                pnlNavigation.Visible = true;

                //ログイン済みヘッダにユーザ情報を設定
                lblUserName.Text = string.Format("{0}", userRole.UserName);
                lblDepartmentName.Text = string.Format("{0}:{1}", userRole.DepartmentId, userRole.DepartmentName);
                lblLoginDateTime.Text = string.Format("ログイン日時：{0}", userRole.DisplayLoginDateTime);

                EmpCRM.common.RoleProvider roleprovider = new RoleProvider();
                
                string strApprole = string.Empty;
                if (userRole.Roles.Contains(ComConst.SYSTEM_OPERATE_USER))
                {
                    //strApprole += roleprovider.GetGroupName(ComConst.SYSTEM_OPERATE_USER);
                }
                /*else*/
                if (userRole.Roles.Contains(ComConst.APPROVAL_USER))
                {
                    if (!string.IsNullOrEmpty(strApprole)) strApprole += ',';

                    strApprole += roleprovider.GetGroupName(ComConst.APPROVAL_USER);
                }
                /*else*/
                if (userRole.Roles.Contains(ComConst.REQUEST_USER))
                {
                    if (!string.IsNullOrEmpty(strApprole)) strApprole += ',';

                    strApprole += roleprovider.GetGroupName(ComConst.REQUEST_USER);
                }
                lblAppRole.Text = "権限：" + strApprole;

                string strAreas = string.Empty;

                //本社を含む場合は最初に本社を表示
                if (userRole.Areas.Contains("HQ"))
                {
                    strAreas += com.GetAreaName("HQ");
                }

                //本社以外を連結して表示
                foreach (string area in userRole.Areas)
                {
                    if (!"HQ".Equals(area))
                    {
                        if (string.IsNullOrEmpty(strAreas))
                        {
                            strAreas += com.GetAreaName(area);
                        }
                        else
                        {
                            strAreas += "," + com.GetAreaName(area);
                        }
                    }
                }

                lblAreaRole.Text = "地域ロール：" + strAreas;
            }
        }

        ///// <summary>
        ///// ログアウトボタン押下時処理
        ///// </summary>
        ///// <param name="sender"></param>
        ///// <param name="e"></param>
        //protected void lngLogOut_Click(object sender, EventArgs e)
        //{
        //    //セッションのユーザ情報をクリア
        //    Session[ComConst.SESSION_USER_ROLE] = null;
        //    Response.Redirect("~/Logout.aspx");
        //}
    }
}