﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="ApplicationListPrint.aspx.cs" Inherits="EmpCRM.ApplicationListPrint" %>
<%-- ヘッダーユーザコントロールを追加 --%>
<%@ Register Tagprefix="cc" Tagname="CommonHeader" Src="control/Header.ascx" %>
<%@ Register Tagprefix="cc" Tagname="DepartmentSelector" Src="control/DepartmentSelector.ascx" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml" lang="ja">
<head runat="server">
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <link rel="stylesheet" href="./css/style.css" type="text/css" />
    <title>従事者選任/選任解任申請リスト出力</title>
    <script src="./js/jquery-3.1.1.min.js"></script>
    <script type="text/javascript">
        $(function () {
            $('#btnChkAll').click(
                function () {
                    $("[id^='gvApplicationTarget_selectData']").prop('checked', true);
                    $("[id^='gvOutputStyleBumon_selectData']").prop('checked', true);
                });
            $('#btnUnchkAll').on('click',
                function () {
                    $("[id^='gvApplicationTarget_selectData']").prop('checked', false);
                    $("[id^='gvOutputStyleBumon_selectData']").prop('checked', false);
                });
        });
    </script>
</head>
<body>
    <div id="wrapper">
        <!-- header -->
        <cc:CommonHeader ID="CommonHeader" runat="server" />

        <div id="main">

            <h2>従事者&nbsp;選任/解任申請リスト出力</h2>
            <div class="tagReturn">
                <span>＞ </span>
                <asp:HyperLink id="lnkMenu" NavigateUrl="Mainmenu.aspx" Text="メインメニュー" target="_top" runat="server"/>
                <span>＞ </span>
                <span>従事者&nbsp;選任/解任申請リスト出力</span>

            </div>
            <br />

            <div id="content">
                <form name="ApplicationListPrintForm" id="upload_form" method="POST" class="inline_block" enctype="multipart/form-data" runat="server">
                    <table border="0">
                        <tr>
                            <td width="120">出力ファイル名：</td>
                            <td colspan="2">
                                <asp:TextBox ID="txtDownloadFileName" runat="server" MaxLength="256" Width="300px" CssClass="input_file" />
                            </td>
                        </tr>
                        <tr>
                            <td>シート名：</td>
                            <td colspan="2">
                                <asp:TextBox ID="txtSheetName" runat="server" MaxLength="256" style="width:300px; "/>
                            </td>
                        </tr>
                    </table>

                    <div style="margin-top:20px">
                        <span>申請対象検索</span>
                    </div>


                    <asp:Panel ID="pnlSystemUserSearchCondition" runat="server" Visible="false">
                        <table border="0" style="width: 600px; table-layout: fixed">
                            <tr>
                                <td class="tblItemTitle">
                                    <asp:Label ID="lblOutputStyle" Text="出力形式：" runat="server" />
                                </td>
                                <td>
                                    <asp:RadioButton ID="radioRegional" runat="server" GroupName="grpOutputStyle" Text="地域毎：" TextAlign="Left" CssClass="AppListRadio chkInput" Checked="true" OnCheckedChanged="radioRegional_CheckedChanged" AutoPostBack="true" />
                                </td>
                                <td>
                                    <asp:RadioButton ID="radioBumon" runat="server" GroupName="grpOutputStyle" Text="一括：" TextAlign="Left" CssClass="AppListRadio chkInput" OnCheckedChanged="radioBumon_CheckedChanged" AutoPostBack="true" />
                                </td>
                            </tr>
                            <tr class="trDepartmentDdlTitle" >
                                <td class="tblItemTitle" >管理部門：</td>
                                <td colspan="2">
                                    <cc:DepartmentSelector ID="ccDepartmentSelector" runat="server" />
                                    <asp:Label ID="lblBumon" runat="server" Visible="false" />
                                </td>
                            </tr>
                        </table>
                    </asp:Panel>

                    <table border="0" style="width: 600px; table-layout: fixed">
                        <tr>
                            <td class="tblItemTitle">提出先総通局</td>
                            <td colspan="2">
                                <asp:DropDownList ID="ddlSotsu" runat="server" />
                            </td>
                            <td></td>
                            <td></td>
                        </tr>
                        <tr>
                            <td>所属会社：</td>
                            <td colspan="2">
                                <asp:DropDownList ID="ddlCompany" runat="server" OnSelectedIndexChanged="ddlCompany_Changed" AutoPostBack="true" />
                            </td>
                            <td>JMCIAフラグ</td>
                            <td>
                                <asp:DropDownList ID="ddlJmcia" runat="server" CssClass="tblInputItemDDL" />
                            </td>
                        </tr>
                        <tr>
                            <td>所属部署：</td>
                            <td colspan="2">
                                <asp:DropDownList ID="ddlDepartment" runat="server" />
                            </td>
                            <td>SB/WCPフラグ</td>
                            <td>
                                <asp:DropDownList ID="ddlSbwcp" runat="server" CssClass="tblInputItemDDL" />
                            </td>

                        </tr>
                        <%-- 無線局種別 --%>
                        <tr>
                            <td>無線局種別：</td>
                            <td>
                                <asp:CheckBox ID="chkEX" runat="server" Text="EX" TextAlign="Right" CssClass="chkInput" />
                            </td>
                            <td>
                                <asp:CheckBox ID="chkFX" runat="server" Text="FX" TextAlign="Right" CssClass="chkInput" />
                            </td>
                            <td>
                                <asp:CheckBox ID="chkFB" runat="server" Text="FB" TextAlign="Right" CssClass="chkInput" />
                            </td>
                            <td>
                                <asp:CheckBox ID="chkFBR" runat="server" Text="FBR" TextAlign="Right" CssClass="chkInput" />
                            </td>
                            <td>
                                <asp:CheckBox ID="chkML" runat="server" Text="ML" TextAlign="Right" CssClass="chkInput" />
                            </td>
                        </tr>
                        <tr>
                            <td colspan="4">
                                <asp:Button ID="BtnSearch" runat="server" Text="検索" OnClick="BtnSearch_Click" CssClass="input_submit SmallBtn" />
                                <asp:Button ID="btnClear" runat="server" Text="クリア" OnClick="BtnClear_Click" CssClass="input_submit SmallBtn" />
                                <asp:Button ID="modoru" Text="戻る" class="input_submit SmallBtn" runat="server" OnClick="modoru_Click" />
                            </td>
                        </tr>
                    </table>
                        
                    <asp:Panel ID="PnlApplicationTarget" runat="server" Visible ="false" CssClass="EmployeeSearcMisshTable">
                        <p>申請対象リスト</p>

                        <asp:Panel ID="gvPanel" runat="server" Width="1500px" >
                            <%--<button id="btnChkAll" type="button" title="全選択" >全選択</button>--%>
                            <table id="Table2">
                                <tbody>
                                    <tr>
                                        <td>
                                            <input type ="button" id="btnChkAll" value="全選択" style="width: 4em;font-size:small;"/>
                                            <input type ="button" id="btnUnchkAll" value="全解除" style="width: 4em;font-size:small;"/>
                                        </td>
                                    </tr>
                                </tbody>
                            </table>
                            <%--申請対象リストgridview--%>
                            <asp:GridView ID="gvApplicationTarget" runat="server" AutoGenerateColumns="false" AllowPaging="true" RowStyle-Height="20px"
                                          OnPageIndexChanging="gvPageChanging" ShowHeaderWhenEmpty="true">
                                <PagerSettings Position="Bottom" Mode="NumericFirstLast" />
                                <PagerStyle HorizontalAlign="Center" CssClass="pagerRow" />
                                <HeaderStyle CssClass="gvHead" />
                                <Columns>
                                    <asp:BoundField DataField="No" HeaderText="No" ItemStyle-CssClass="indexNumberColumn" />
                                    <asp:TemplateField HeaderText="選択" ItemStyle-CssClass="chkBoxColumn">
                                        <ItemTemplate>
                                            <asp:CheckBox runat="server" ID="selectData" />
                                        </ItemTemplate>
                                    </asp:TemplateField>
                                    <asp:BoundField DataField="氏名（姓）" HeaderText="氏名（姓）" HeaderStyle-CssClass="lastnameColumn" ItemStyle-CssClass="lastnameColumn" />
                                    <asp:BoundField DataField="氏名（名）" HeaderText="氏名（名）" HeaderStyle-CssClass="firstnameColumn" ItemStyle-CssClass="firstnameColumn" />
                                    <asp:BoundField DataField="ふりがな（姓）" HeaderText="ふりがな（姓）" HeaderStyle-CssClass="kanalastnameColumn" ItemStyle-CssClass="kanalastnameColumn" />
                                    <asp:BoundField DataField="ふりがな（名）" HeaderText="ふりがな（名）" HeaderStyle-CssClass="kanafirstnameColumn" ItemStyle-CssClass="kanafirstnameColumn" />
                                    <asp:BoundField DataField="免許番号" HeaderText="免許番号" HeaderStyle-CssClass="licenseNumberColumn" ItemStyle-CssClass="licenseNumberColumn" />
                                    <asp:BoundField DataField="JMCIA" HeaderText="JMCIA" HeaderStyle-CssClass="jmcaColumn align_center" ItemStyle-CssClass="jmcaColumn align_center" />
                                    <asp:BoundField DataField="SB/WCP" HeaderText="SB/WCP" HeaderStyle-CssClass="sbwcpColumn align_center" ItemStyle-CssClass="sbwcpColumn align_center" />
                                    <asp:BoundField DataField="所属会社" HeaderText="所属会社" HeaderStyle-CssClass="belongCompanyColumn" ItemStyle-CssClass="belongCompanyColumn" />
                                    <asp:BoundField DataField="selectionDate" HeaderText="選任日" HeaderStyle-CssClass="dateColumn" ItemStyle-CssClass="dateColumn" />
                                    <asp:BoundField DataField="dismissDate" HeaderText="解任日" HeaderStyle-CssClass="dateColumn" ItemStyle-CssClass="dateColumn" />
                                    <asp:BoundField DataField="thcAreaName" HeaderText="総通局" HeaderStyle-CssClass="areaColumn align_center" ItemStyle-CssClass="areaColumn align_center" />
                                    <asp:TemplateField HeaderText="備考" ItemStyle-CssClass="remarksColumn">
                                        <ItemTemplate>
                                            <asp:TextBox ID="remarks" runat="server" CssClass="txtRemarks" />
                                        </ItemTemplate>
                                    </asp:TemplateField>
                                </Columns>
                            </asp:GridView>

                            <%-- 一括出力時 --%>
                            <asp:GridView ID="gvOutputStyleBumon" runat="server" AutoGenerateColumns="false" AllowPaging="true" RowStyle-Height="20px"
                                ShowHeaderWhenEmpty="true" OnPageIndexChanging="gvOutputStyleBumon_PageChanging">
                                <PagerSettings Position="Bottom" Mode="NumericFirstLast" />
                                <PagerStyle HorizontalAlign="Center" CssClass="pagerRow" />
                                <HeaderStyle CssClass="gvHead" />
                                <Columns>
                                    <asp:BoundField DataField="No" HeaderText="No" ItemStyle-CssClass="indexNumberColumn" />
                                    <asp:TemplateField HeaderText="選択" ItemStyle-CssClass="chkBoxColumn">
                                        <ItemTemplate>
                                            <asp:CheckBox runat="server" ID="selectData" />
                                        </ItemTemplate>
                                    </asp:TemplateField>
                                    <asp:BoundField DataField="LastName" HeaderText="氏名（姓）" HeaderStyle-CssClass="lastnameColumn" ItemStyle-CssClass="lastnameColumn" />
                                    <asp:BoundField DataField="FirstName" HeaderText="氏名（名）" HeaderStyle-CssClass="firstnameColumn" ItemStyle-CssClass="firstnameColumn" />
                                    <asp:BoundField DataField="LastName_Kana" HeaderText="ふりがな（姓）" HeaderStyle-CssClass="kanalastnameColumn" ItemStyle-CssClass="kanalastnameColumn" />
                                    <asp:BoundField DataField="FirstName_Kana" HeaderText="ふりがな（名）" HeaderStyle-CssClass="kanafirstnameColumn" ItemStyle-CssClass="kanafirstnameColumn" />
                                    <asp:BoundField DataField="displayGetLicenseDate" HeaderText="免許取得日" HeaderStyle-CssClass="dateColumn" ItemStyle-CssClass="dateColumn" />
                                    <asp:BoundField DataField="license_type" HeaderText="免許種別" HeaderStyle-CssClass="align_center" ItemStyle-CssClass="align_center" />
                                    <asp:BoundField DataField="license_number" HeaderText="免許番号" HeaderStyle-CssClass="licenseNumberColumn" ItemStyle-CssClass="licenseNumberColumn" />
                                    <asp:BoundField DataField="業務履歴" HeaderText="業務履歴" HeaderStyle-CssClass="" ItemStyle-CssClass="" />
                                    <asp:BoundField DataField="固定値" HeaderText="固定値" HeaderStyle-CssClass="" ItemStyle-CssClass="" />
                                    <asp:BoundField DataField="belong_company" HeaderText="所属会社" HeaderStyle-CssClass="belongCompanyColumn" ItemStyle-CssClass="belongCompanyColumn" />
                                    <asp:BoundField DataField="belong_department" HeaderText="所属部署" HeaderStyle-CssClass="belongDepartmentColumn" ItemStyle-CssClass="belongDepartmentColumn" />
                                    <asp:BoundField DataField="jmcia_flag" HeaderText="JMCIA" HeaderStyle-CssClass="jmcaColumn align_center" ItemStyle-CssClass="jmcaColumn align_center" />
                                    <asp:BoundField DataField="sb_wcp" HeaderText="SB/WCP" HeaderStyle-CssClass="sbwcpColumn align_center" ItemStyle-CssClass="sbwcpColumn align_center" />
                                    <asp:BoundField DataField="hokkaidou" HeaderText="北海道" HeaderStyle-CssClass="areaColumn align_center" ItemStyle-CssClass="areaColumn align_center" />
                                    <asp:BoundField DataField="touhoku" HeaderText="東北" HeaderStyle-CssClass="areaColumn align_center" ItemStyle-CssClass="areaColumn align_center" />
                                    <asp:BoundField DataField="hokuriku" HeaderText="北陸" HeaderStyle-CssClass="areaColumn align_center" ItemStyle-CssClass="areaColumn align_center" />
                                    <asp:BoundField DataField="shinetsu" HeaderText="信越" HeaderStyle-CssClass="areaColumn align_center" ItemStyle-CssClass="areaColumn align_center" />
                                    <asp:BoundField DataField="kantou" HeaderText="関東" HeaderStyle-CssClass="areaColumn align_center" ItemStyle-CssClass="areaColumn align_center" />
                                    <asp:BoundField DataField="tokai" HeaderText="東海" HeaderStyle-CssClass="areaColumn align_center" ItemStyle-CssClass="areaColumn align_center" />
                                    <asp:BoundField DataField="kinki" HeaderText="近畿" HeaderStyle-CssClass="areaColumn align_center" ItemStyle-CssClass="areaColumn align_center" />
                                    <asp:BoundField DataField="shikoku" HeaderText="四国" HeaderStyle-CssClass="areaColumn align_center" ItemStyle-CssClass="areaColumn align_center" />
                                    <asp:BoundField DataField="chugoku" HeaderText="中国" HeaderStyle-CssClass="areaColumn align_center" ItemStyle-CssClass="areaColumn align_center" />
                                    <asp:BoundField DataField="kyuushu" HeaderText="九州" HeaderStyle-CssClass="areaColumn align_center" ItemStyle-CssClass="areaColumn align_center" />
                                    <asp:BoundField DataField="okinawa" HeaderText="沖縄" HeaderStyle-CssClass="areaColumn align_center" ItemStyle-CssClass="areaColumn align_center" />
                                </Columns>
                            </asp:GridView>

                        </asp:Panel>
                        <p>
                            <asp:Button ID="BtnDownload" runat="server" Text="出力" CssClass="input_submit SmallBtn" OnClick="BtnDownload_Click" />
                        </p>
                    </asp:Panel>

                    <div>
                        <table class="errMsgTbl">
                            <tr>
                                <td>
                                    <asp:Label ID="lblErrMessage" runat="server" />
                                </td>
                            </tr>
                        </table>
                    </div>
                </form>
            </div>
        </div>
    </div>
</body>
</html>

