﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="CompanyInfo.aspx.cs" Inherits="EmpCRM.CompanyInfo" %>

<%-- ヘッダーユーザコントロールを追加 --%>
<%@ Register TagPrefix="cc" TagName="CommonHeader" Src="control/Header.ascx" %>

<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="ja">
<script runat="server">
   
    // ControlParameter コンストラクタの第三引数（パラメータの
    // バインド先のコントロールの名前）に UniqueID を使わないと
    // コントロールが見つからないというエラーになる。
    protected void GridView1_RowCommand(object sender,
      GridViewCommandEventArgs e)
    {
        if (e.CommandName == "Insert")
        {
            try
            {
                SqlDataSource1.InsertParameters.Clear();

                foreach (string key in Request.Form.AllKeys)
                {
                    if (key.Contains("companyTXT"))
                    {
                        SqlDataSource1.InsertParameters.Add(
                                      new ControlParameter(
                                          "company_id",
                                          TypeCode.String,
                                          key,
                                          "Text"));
                    }
                    if (key.Contains("sectionTXT"))
                    {
                        SqlDataSource1.InsertParameters.Add(
                                      new ControlParameter(
                                          "section_id",
                                          TypeCode.String,
                                          key,
                                          "Text"));
                    }
                    if (key.Contains("sectionnmTXT"))
                    {
                        SqlDataSource1.InsertParameters.Add(
                                      new ControlParameter(
                                          "section_name",
                                          TypeCode.String,
                                          key,
                                          "Text"));
                    }
                }

                SqlDataSource1.Insert();
                lblErrMsg.Text = "新規部門ID登録が成功しました。";
            }
            catch (Exception ex)
            {
                lblErrMsg.Text = ex.Message;
            }
        }

    }
  
</script>

<head id="Head1" runat="server">
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <link rel="stylesheet" href="./css/style.css" type="text/css" />
    <title>従事者情報編集画面</title>
    <script type="text/javascript">
        function LinkClick() {
            var companyid = document.forms.form1.companyID.value;
            var companynm = document.forms.form1.companyName.value;

            var url = 'CompanySearchResult.aspx?company_id=' + companyid + '&company_name=' + companynm;
            window.open(url, null);
        }
        function katakana(str) {
            return str.match(/^[ァ-ヶー]*$/);
        }
        var childWindowCount = 0;
        var childWindows = new Array();
        function ibtnCal1_Click(Flg) {
            childWindowCount++;
            if (Flg == '1') {
                var l = 450; // 表示するx座標
                var t = 290; // 表示するy座標
                var w = 260; // 横幅
                var h = 210; // 縦幅
                childWindow = window.open("calendar.aspx?flg=3", null,
                    "screenX=" + l + ",screenY=" + t + ",left=" + l + ",top=" + t + ",width=" + w + ",height=" + h + ',menubar=no, toolbar=no, scrollbars=no');

                childWindows[childWindowCount - 1] = childWindow;
            }
            //alert('件数2：　 ' + childWindowCount);
        }
        function closeChildWindow() {
            //alert('How many? ' + childWindowCount);
            for (var i = 0; i < childWindowCount; i++) {
                var closeWindow = childWindows[i];
                if (!closeWindow.closed) {
                    closeWindow.close();
                }
            }
        }

    </script>
</head>
<body>
    <div id="wrapper">
        <cc:CommonHeader ID="CommonHeader" runat="server" />

        <div id="main">



            <h2>会社情報編集</h2>
            <div class="tagReturn">
                ><asp:HyperLink ID="hyperlink2"
                    NavigateUrl="Mainmenu.aspx"
                    Text="メインメニュー"
                    Target="_top"
                    runat="server" />
                <span>＞ </span>
                <span><strong>会社情報編集 </strong></span>
            </div>

            <form id="form1" runat="server">

                <asp:Table ID="MainTB" runat="server" BorderColor="1" Width="65%" Border="0">
                    <asp:TableRow>
                        <asp:TableCell>
                            <asp:Table ID="CMDTB" runat="server" BorderColor="Black" HorizontalAlign="Left">
                                <asp:TableRow>
                                    <asp:TableCell>
                                        <asp:Button ID="add" Text="登録" CssClass="input_submit SmallBtn" runat="server" OnClick="add_Click" OnClientClick="return confirm('会社情報を登録してよろしいでしょうか？');" />
                                        <asp:Button ID="edit" Text="更新" CssClass="input_submit SmallBtn" runat="server" OnClick="edit_Click" OnClientClick="return confirm('会社情報を更新してよろしいでしょうか？');" />
                                        <asp:Button ID="del" Text="削除" CssClass="input_submit SmallBtn" runat="server" OnClick="del_Click" OnClientClick="return confirm('会社情報を削除してよろしいでしょうか？');" />
                                        <asp:Button ID="clear" Text="クリア" CssClass="input_submit SmallBtn" runat="server" OnClick="clear_Click" />
                                        <asp:Button ID="modoru" Text="戻る" CssClass="input_submit SmallBtn" runat="server" OnClick="modoru_Click" />
                                    </asp:TableCell>
                                </asp:TableRow>
                            </asp:Table>
                        </asp:TableCell>
                    </asp:TableRow>
                    <asp:TableRow>
                        <asp:TableCell>
                            <asp:Table ID="Table1" border="0" Width="50%" runat="server">
                                <asp:TableRow>
                                    <asp:TableCell>会社ID</asp:TableCell>
                                    <asp:TableCell>
                                        <asp:TextBox ID="companyID" MaxLength="5" Width="100px" runat="server" />
                                    </asp:TableCell>
                                </asp:TableRow>
                                <asp:TableRow>
                                    <asp:TableCell>会社名</asp:TableCell>
                                    <asp:TableCell>
                                        <asp:TextBox ID="companyName" MaxLength="30" Width="270px" runat="server" />
                                    </asp:TableCell>

                                </asp:TableRow>
                            </asp:Table>
                        </asp:TableCell>
                    </asp:TableRow>
                    <asp:TableRow>
                        <asp:TableCell>
                            <asp:Table ID="Table2" border="0" Width="50%" runat="server">
                                <asp:TableRow>
                                    <asp:TableCell>
                                        <a id="A2" href="javascript:void(0);" onclick="LinkClick()" class="input_submit SmallBtn" runat="server">検索</a>
                                        <asp:Button ID="BumoAll" class="input_submit LargeBtn" runat="server" Text="部門全体" OnClick="Bumoall_Click"/>
                                    </asp:TableCell>
                                </asp:TableRow>
                            </asp:Table>
                        </asp:TableCell>
                    </asp:TableRow>

                </asp:Table>
                <asp:Table ID="T101" runat="server" Width="100%">
                    <asp:TableRow>
                        <asp:TableCell HorizontalAlign="Left" Style="border-right-style: hidden; border-left-style: hidden; border-top-style: hidden;">部門編集：</asp:TableCell>
                    </asp:TableRow>
                </asp:Table>

                <asp:GridView ID="GridView1"
                    runat="server"
                    AutoGenerateColumns="False"
                    DataKeyNames="company_id,section_id"
                    DataSourceID="SqlDataSource1"
                    ShowFooter="True"
                     OnPageIndexChanging="GridView1_PageIndexChanging"
                    OnRowCommand="GridView1_RowCommand" AllowPaging="True">
                    <HeaderStyle BackColor="#CCFFFF" HorizontalAlign="Center"  />
                    <Columns>

                        <asp:TemplateField HeaderText="No."
                            InsertVisible="False"
                            SortExpression="ID">
                            <HeaderStyle Width="40px" />
                            <ItemStyle HorizontalAlign="Left" />

                            <EditItemTemplate>
                                <asp:Label ID="Label1"
                                    runat="server"
                                    Text='<%# Eval("No") %>'>
                                </asp:Label>
                            </EditItemTemplate>
                            <ItemTemplate>
                                <asp:Label ID="Label2"
                                    runat="server"
                                    Text='<%# Bind("No") %>'>
                                </asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>

                        <asp:TemplateField HeaderText="会社ID"
                            SortExpression="company_id">
                            <HeaderStyle Width="100px" />
                            <ItemStyle HorizontalAlign="Left" />

                            <EditItemTemplate>
                                <asp:TextBox ID="TextBox1" MaxLength="5"
                                    runat="server"
                                    Text='<%# Bind("company_id") %>'>
                                </asp:TextBox>
                            </EditItemTemplate>

                            <FooterTemplate>
                                <asp:TextBox ID="companyTXT" MaxLength="5"
                                    runat="server">
                                </asp:TextBox>
                            </FooterTemplate>
                            <ItemTemplate>
                                <asp:Label ID="Label13"
                                    runat="server"
                                    Text='<%# Bind("company_id") %>'>
                                </asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>

                        <asp:TemplateField HeaderText="部門iD"
                            SortExpression="section_id">
                            <HeaderStyle Width="100px" />
                            <ItemStyle HorizontalAlign="Left" />

                            <EditItemTemplate>
                                <asp:TextBox ID="TextBox2" MaxLength="5"
                                    runat="server"
                                    Text='<%# Bind("section_id") %>'>
                                </asp:TextBox>
                            </EditItemTemplate>
                            <FooterTemplate>
                                <asp:TextBox ID="sectionTXT" MaxLength="5"
                                    runat="server">
                                </asp:TextBox>
                            </FooterTemplate>
                            <ItemTemplate>
                                <asp:Label ID="Label4"
                                    runat="server"
                                    Text='<%# Bind("section_id") %>'>
                                </asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>

                        <asp:TemplateField HeaderText="部門名称"
                            SortExpression="section_name">
                            <HeaderStyle Width="450px" />
                            <ItemStyle HorizontalAlign="Left" />

                            <EditItemTemplate>
                                <asp:TextBox ID="TextBox3" MaxLength="80"
                                    runat="server"
                                    Text='<%# Bind("section_name") %>'>
                                </asp:TextBox>
                            </EditItemTemplate>
                            <FooterTemplate>
                                <asp:TextBox ID="sectionnmTXT" MaxLength="80"
                                    runat="server">
                                </asp:TextBox>
                            </FooterTemplate>
                            <ItemTemplate>
                                <asp:Label ID="Label5"
                                    runat="server"
                                    Text='<%# Bind("section_name") %>'>
                                </asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:TemplateField ShowHeader="False">
                            <HeaderStyle Width="150" />
                            <EditItemTemplate>
                                <asp:Button ID="Button4" runat="server" CommandName="Update" Text="更新" Width="62px" />
                                <asp:Button ID="Button5" runat="server" CommandName="Cancel" Height="21px" Text="キャンセル" Width="95px" />
                            </EditItemTemplate>
                            <FooterTemplate>
                                <asp:Button ID="Button1" runat="server" CommandName="Insert" Text="追加" Width="67px" />
                            </FooterTemplate>
                            <ItemTemplate>
                                <asp:Button ID="Button2" runat="server" CommandName="Edit" Text="編集" Width="62px" />
                                <asp:Button ID="Button3" runat="server" CommandName="Delete" Text="削除" Width="62px" />
                            </ItemTemplate>
                        </asp:TemplateField>


                    </Columns>

                    <EmptyDataTemplate>
                        <table style="width: 100%; height: 82px;">
                            <tr>
                                <th><asp:Label ID="Label14" runat="server" Text="会社ID" BackColor="#CCFFFF"></asp:Label></th>
                                <th><asp:Label ID="Label3" runat="server" Text="部門ID" BackColor="#CCFFFF"></asp:Label></th>
                                <th><asp:Label ID="Label6" runat="server" Text="部門名称" BackColor="#CCFFFF"></asp:Label></th>
                                <th><asp:Label ID="Label7" runat="server" Text=""></asp:Label></th>

                            </tr>
                            <tr>
                                <td>
                                    <asp:TextBox ID="companyTXT" MaxLength="5" Width="100px"
                                        runat="server">
                                    </asp:TextBox>
                                </td>
                                <td>
                                    <asp:TextBox ID="sectionTXT" MaxLength="5" Width="100px"
                                        runat="server"></asp:TextBox>
                                </td>
                                <td>
                                    <asp:TextBox ID="sectionnmTXT" MaxLength="80" Width="500px"
                                        runat="server">
                                    </asp:TextBox>
                                </td>
                                <td>
                                    <asp:Button ID="Button3"
                                        runat="server"
                                        CommandName="Insert" Text="追加" Width="67px"> 
                                    </asp:Button>
                                </td>
                                <td>&nbsp;
                                </td>
                            </tr>
                        </table>
                    </EmptyDataTemplate>
                    <PagerStyle BackColor="" CssClass="C1Heading" Height="30px"
                        VerticalAlign="Bottom"
                        HorizontalAlign="Center"/>
                </asp:GridView>
                <div>
                    <asp:SqlDataSource ID="SqlDataSource1" runat="server"
                        ConnectionString="<%$ ConnectionStrings:Softbank_dev %>"
                        DeleteCommand="UPDATE section_mst SET del_flag = '1' WHERE (company_id = @company_id) AND (section_id = @SECTION_ID)"
                        InsertCommand="INSERT INTO section_mst(company_id, section_id, section_name, del_flag) VALUES (@company_id, @section_id, @section_name, 0)"
                        SelectCommand="SELECT ROW_NUMBER() OVER (ORDER BY COMPANY_ID) AS 'No', [company_id], [section_id], [section_name] FROM [section_mst]  WHERE (DEL_FLAG = 0)"
                        UpdateCommand="UPDATE section_mst SET section_name = @section_name WHERE (company_id = @company_id) AND (section_id = @SECTION_ID)">

                        <DeleteParameters>
                            <asp:Parameter Name="company_id" Type="String" />
                            <asp:Parameter Name="SECTION_ID" Type="String" />
                        </DeleteParameters>
                        <InsertParameters>
                            <asp:Parameter Name="company_id" Type="String" />
                            <asp:Parameter Name="section_id" Type="String" />
                            <asp:Parameter Name="section_name" Type="String" />
                        </InsertParameters>
                        <UpdateParameters>
                            <asp:Parameter Name="section_name" Type="String" />
                            <asp:Parameter Name="company_id" Type="String" />
                            <asp:Parameter Name="section_id" Type="String" />
                        </UpdateParameters>
                    </asp:SqlDataSource>

                </div>
                <!-- エラーメッセージ表示用ラベル -->
                <asp:Table ID="Table3" runat="server" CssClass="errMsgTbl">
                    <asp:TableRow>
                        <asp:TableCell HorizontalAlign="Center">
                            <asp:Label ID="lblErrMsg" runat="server" ForeColor="Red" Font-Size="16px"></asp:Label>
                        </asp:TableCell>
                    </asp:TableRow>
                </asp:Table>

            </form>
        </div>
    </div>
</body>
</html>
